
# Procedure: Save-var1
proc Save-var1 {} {
##########
# Procedure: Save-var1
# Description: Save variables setting on a file
# Arguments: none
# Return: none
# Sideeffects: none
##########

global modifica parnet parconf
global VAR_DIR HOME VAR_FILE

set modifica(1) 0

set vars {pop_size percentage epochs gens_for_epoch quantum generation_gap open_to_foreign foreign_mating_rate crossover_rate mutation_rate complement_rate migration_rate node_persistence global_persistence change_ratio decision_limit overlap_ratio}

set fileid [open $HOME/$VAR_DIR/$VAR_FILE w]

puts -nonewline $fileid "( "
puts -nonewline $fileid $parconf(goalcl)
puts $fileid " )"


foreach i $vars {puts $fileid $parconf($i)}

close $fileid
}



# Procedure Save-net1
proc Save-net1 {} {
##########
# Procedure: Save-net1
# Description: Save network setting on a file
# Arguments: none
# Return: none
# Sideeffects: none
##########

global NET_DIR NET_FILE HOME COM_DIR NODE_FILE
global PVM_DIR PVM_FILE
global parnet nhost host
global modifica
global checker

Check-Distribution

set modifica(2) 0

set fileid [open $HOME/$NET_DIR/$NET_FILE w]

puts $fileid $parnet(nodes)

puts $fileid $parnet(dimension)

puts $fileid $parnet(topology)

close $fileid

set fileid [open $HOME/$COM_DIR/$NODE_FILE w] 

puts $fileid $parnet(nodes)

close $fileid


set fileid [open $HOME/$PVM_DIR/$PVM_FILE w]
set i 0
while {$i < $nhost} {puts -nonewline $fileid "$host($i,1) ";puts $fileid $host($i,2);incr i}
close $fileid
}


# Procedure Restore-var1
proc Restore-var1 {} {
##########
# Procedure: Restore-var1
# Description: Restore variables setting from a file
# Arguments: none
# Return: none
# Sideeffects: none
##########

global parconf
global HOME
global VAR_DIR VAR_FILE

set vars {pop_size percentage epochs gens_for_epoch quantum generation_gap open_to_foreign foreign_mating_rate crossover_rate mutation_rate complement_rate migration_rate node_persistence global_persistence change_ratio decision_limit overlap_ratio}



if {[file exists $HOME/$VAR_DIR/$VAR_FILE]} then {
				set i 0
				set fileid [open $HOME/$VAR_DIR/$VAR_FILE]

				gets $fileid linea
				set cmd {Tra_rot $linea}
				set parconf(goalcl)  [eval $cmd]

				while {![eof $fileid]} {
					set parconf([lindex $vars $i]) [gets $fileid]
					incr i
							}
				close $fileid
			     }
}
				
# Procedure Restore-net1
proc Restore-net1 {} {	
##########
# Procedure: Restore-net1
# Description: Restore network settings from a file
# Arguments: none
# Return: none
# Sideeffects: none
##########

global NET_DIR NET_FILE HOME
global PVM_DIR PVM_FILE
global parnet host nhost

 set net {nodes dimension topology }

if {[file exists $HOME/$NET_DIR/$NET_FILE]} then {

				set fileid [open $HOME/$NET_DIR/$NET_FILE]
				set i 0
				
				while {![eof $fileid]} {
				set parnet([lindex $net $i]) [gets $fileid]
				incr i
							}
				close $fileid

				}

if {[file exists $HOME/$PVM_DIR/$PVM_FILE]} then {

				set fileid [open $HOME/$PVM_DIR/$PVM_FILE]
				set i 0
				while {![eof $fileid]} {
				gets $fileid linea

				if {$linea != {}} {
				set host($i,1) [lindex $linea 0]
				set host($i,2) [lindex $linea 1]
						   }
				incr i
				                       }
				set nhost [expr $i-1]
				close $fileid   }
				
}

# Procedure Restore-pid
proc Restore-pid {} {
##########
# Procedure: Restore-pid
# Description: Restore regal process id from a file
# Arguments: 
# Return: pid      if regal is running
#          0       otherwise
# Sideeffects: none
##########

global HOME COM_DIR PID_FILE

if {[file exists $HOME/$COM_DIR/$PID_FILE]} then {

				set fileid [open $HOME/$COM_DIR/$PID_FILE]
				
				gets $fileid linea
					
				close $fileid
				
				return $linea

				} else {return 0}


}


# Procedure Read-node
proc Read-node {} {
##########
# Procedure: Read-node
# Description: Restore number of node  from a file
# Arguments: 
# Return: number of nodes
# Sideeffects: none
##########

global HOME COM_DIR NODE_FILE

if {[file exists $HOME/$COM_DIR/$NODE_FILE]} then {

				set fileid [open $HOME/$COM_DIR/$NODE_FILE]
				
				gets $fileid linea
					
				close $fileid
				
				return $linea

				} else {return 0}


}



# Procedure Tra_rot
proc Tra_rot {list} {
##########
# Procedure: Tra_rot
# Description: delete from a list ( or )
# Arguments: a list with or without ( )
# Return: only the elements of the list contained in ( ... ) 
# Sideeffects: none
##########

set c 0
set x1 {}
set i [llength $list]

while {$c<$i} { if {[lindex $list $c] == "("} then {
					      incr c
					      while {[lindex $list $c] != ")"} {set x1 [concat $x1 [lindex $list $c]];if {$c > 100} then {break}
incr c}
					        } else {incr c}

return $x1
	      }
}



# Procedure Tra
proc Tra {list} {
##########
# Procedure: Tra
# Description: delete from a list < or >
# Arguments: a list with or without < >
# Return: only the elements of the list contained in < ... > 
# Sideeffects: none
##########

set c 0
set x1 {}
set i [llength $list]

while {$c<$i} { if {[lindex $list $c] == "<"} then {
					      incr c
					      while {[lindex $list $c] != ">"} {set x1 [concat $x1 [lindex $list $c]];if {$c > 100} then {break}
incr c}
					        } else {incr c}

return $x1
	      }
}

# Procedure Organizza
proc Organizza {nome_file} {
##########
# Procedure: Organizza
# Description: scans a COMMAND_FILE
# Arguments: file to scan
# Return: none
# Sideeffects: none
##########

global COM_DIR HOME
global node_monitored
global widget label graph parameters node axpar axvar axlabel
global grep
global visual

set fileid [open $nome_file]


while {![eof $fileid]} {
update idletask
gets $fileid linea
		
	switch  -regexp $linea {
		
		PREVIOUS-FORMULA {
				 set pfitem [gets $fileid]		
				 set pfnuovo [gets $fileid]
				 if {$node_monitored == $pfitem} then {
set nfile $HOME/$COM_DIR/$pfnuovo
ClearText $widget(main).1.up.3.fr.text
FileInText $widget(main).1.up.3.fr.text $nfile
if {[winfo exists .3]} then {ClearText .3.3.fr.text;FileInText .3.3.fr.text $nfile}}
					
				 }

		CURRENT-FORMULA {
				 set pfitem [gets $fileid]		
				 set pfnuovo [gets $fileid]
				 if {$node_monitored == $pfitem} then {
set nfile $HOME/$COM_DIR/$pfnuovo
ClearText  $widget(main).1.up.2.fr.text 
FileInText  $widget(main).1.up.2.fr.text $nfile
if {[winfo exists .2]} then {ClearText .2.2.fr.text;FileInText .2.2.fr.text $nfile}}
					
				 }

		FUNCTION        {
				 
				 set pfitem [gets $fileid]		
				 set pfnuovo [gets $fileid]
				 
				 #creo in x una lista di par. con parentesi
				 set x {}
		while {[gets $fileid linea]>0} {set x [concat $x $linea]}
				 
				 set cmd {Tra $x}	   
				 set fun_par [eval $cmd]	
				 #creo in par una lista di par. senza parentesi

				 if {$node_monitored == $pfitem} then {

# azzero i valori del grafo #
unset graph


#carico la prima volta i valori per axpar

if {$axvar == 0} then { 
			unset axpar
			set axvar 1
			set axpar(0) [llength $fun_par]
			set c 1
			foreach i $fun_par {set axpar($c) $i;incr c}
                        
                        # inizializzo abel assi grafici #

                        set axlabel(x,1) $axpar(1)
                        set axlabel(y,1) $axpar(2)
                        set axlabel(x,2) $axpar(1)
                        set axlabel(y,2) $axpar(2)
                        set axlabel(x,3) $axpar(1)
                        set axlabel(y,3) $axpar(2)
                        set axlabel(x,4) $axpar(1)
                        set axlabel(y,4) $axpar(2)

		      }
# carico i dati per la funzione #

set f [open $HOME/$COM_DIR/$pfnuovo]


while {[gets $f linea] > 0} {
		
	for {set i 0} {$i < [llength $fun_par]} {incr i 1} {lappend graph([lindex $fun_par $i]) [lindex $linea $i]}
	
		  	    }
close $f
Function $widget(main).1.dw {2} {right}
if {$node_monitored != "Supervisor"} {Function $widget(main).1.dw {1} {left}}

                       }

		}



		PARAMETER       {
				 set pfitem [gets $fileid]		
				 set pfnuovo [gets $fileid]


				 set x {}
				 while {[gets $fileid linea]>0} {set x [concat $x $linea]}
				 
				 
		
				 set cmd {Tra $x}	   
				 set par_par [eval $cmd]	
				 
				 if {$node_monitored == $pfitem} then {

# carico i dati per i parametri #

unset parameters
set parameters(start) 0
set parameters(0) [llength $par_par]

set p [open $HOME/$COM_DIR/$pfnuovo]

gets $p lista_val

set i 1
foreach v $par_par {
			set parameters($i,0) [lindex $par_par [expr $i-1]]
			set parameters($i,1) [lindex $lista_val [expr $i-1]]
			incr i
		     }

close $p 
Parameters $label(parameters) $widget(main).1.up {1}}
					
				 }

		GLOBAL-REPORT   {
				 set pfnuovo [gets $fileid]

				 set x {}
				 while {[gets $fileid linea]>0} {set x [concat $x $linea]}
				 set cmd {Tra $x}	   
				 set lista_par [eval $cmd]	

				 if {$node_monitored == "Supervisor"} then {

# carico i dati per il global-report #
set m [open $HOME/$COM_DIR/$pfnuovo]


while {[gets $m rep] > 0} {
	set node([lindex $rep 0],1) [lindex $rep 1]
	set node([lindex $rep 0],2) [lindex $rep 2]
			   }

close $m 
}
					
				}



			       }




			}

close $fileid

if {$grep == 1} {
  Org_rep_graf $visual(1) 1
  Org_rep_graf $visual(2) 2
  Org_rep_graf $visual(3) 3
                }

}

# Procedure Aspetta2
proc Aspetta2 {} {
##########
# Procedure: Aspetta2
# Description: waits for a new created COMMAND_FILE
# Arguments: none
# Return: none
# Sideeffects: none
##########
global monitoring

global COM_DIR COM_FILE HOME env GLOBBE_FILE
global ciclo data 
set ciclo 1


while {$ciclo} {
		blt_bgexec data $env(GUI_PATH)/cfile/wait.o $data  $HOME/$COM_DIR/$COM_FILE 10
		tkwait variable data
		#aspetter sul nuovo valore avuto da wait.o#
		if {$ciclo!=0} then {
                 if {$monitoring == 1} then {
		    if {[file exists $HOME/$COM_DIR/$GLOBBE_FILE]} then {
		          Organizza $HOME/$COM_DIR/$COM_FILE }
                                            }
                                    }
               }



}



# Procedure Controllo_file
proc Controllo_file {} {
##########
# Procedure: Controllo_file
# Description: create a new empty COMMAND_FILE for a START
# Arguments: none
# Return: none
# Sideeffects: none
##########

global COM_DIR COM_FILE HOME
global data

set fileid [open $HOME/$COM_DIR/$COM_FILE w]
close $fileid
set data [file mtime $HOME/$COM_DIR/$COM_FILE]


}

# Procedure Org_rep_graf
proc Org_rep_graf {node row} {
##########
# Procedure: setta i dati dei grafici per il graph report
# Description: set the graph array for graph report
# Arguments: node - the node monitored
#            row - the row in graph report
# Return: none
# Sideeffects: none
##########

global graphr1
global graphr2
global graphr3

if {$row == 1} {catch {unset graphr1}}
if {$row == 2} {catch {unset graphr2}}
if {$row == 3} {catch {unset graphr3}}



global COM_FILE COM_DIR HOME
set try 0

set fileid [open $HOME/$COM_DIR/$COM_FILE]
gets $fileid linea
while {![eof $fileid] && $try == 0} {

	switch  -regexp $linea {
		
		      FUNCTION {set pfitem [gets $fileid]
				set pfnuovo [gets $fileid]				
if {$node == $pfitem} then {set try 1

# creo in x una lista di par. con parentesi
set x {}
gets $fileid linea
while {$linea != {}} {set x [concat $x $linea];gets $fileid linea}				 

set cmd {Tra $x}	   
set par [eval $cmd]
	
#creo in par una lista di par. senza parentesi


# carico i dati per la funzione #
set f [open $HOME/$COM_DIR/$pfnuovo]

while {[gets $f linea] > 0} {
		
	for {set i 0} {$i < [llength $par]} {incr i 1} {
if {$row == 1} {lappend graphr1([lindex $par $i]) [lindex $linea $i]}
if {$row == 2} {lappend graphr2([lindex $par $i]) [lindex $linea $i]}
if {$row == 3} {lappend graphr3([lindex $par $i]) [lindex $linea $i]}
	                                               }
		            }
close $f

      }
	 	      }
         }

gets $fileid linea}
close $fileid
}
	
