# Procedure: Function
proc  Function {frame number pack} {
##########
# Procedure:  Function {}
# Description: Show the graph function  and button windows
# Arguments: frame - the widget frame
#            number - the widget id
#            pack - the packing side
# Return: none
# Sideeffects: none
#########
global axlabel
global symbol
global axpar
global graph
global visual


catch {destroy $frame.$number}

 # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

### crea menubuttons per scelta parametro asse y ###

AxButton $frame $number {y} {left}

### crea menubuttons per scelta parametro asse y ###

AxButton $frame $number {x} {bottom}

### crea grafico ###

Graph $frame $number {bottom}

set sx {{}} ; # serve per il check in graph display
set sy {{}} ; # come sopra

catch {set sx $graph($axlabel(x,$number))}
catch {set sy $graph($axlabel(y,$number))}

Graph-Display $frame $number $sx $sy {0} $symbol($number)

### crea button per scelta tipo grafico ###

Graph-Type $frame $number {top}

### pack della widget function ###

# pack widget $frame
  pack append $frame \
    $frame.$number {left frame center padx 14}

}

# Procedure: AxButton
proc AxButton {frame number ax pack {comm 0}} {
##########
# Procedure: AxButton
# Description: build the button for ax parameters
# Arguments: frame - the frame where to put the widget
#            number - the id of widget (if more widget in same frame)
#            ax - the ax controlled by button
#            pack - the packing side
#            comm - the command to be executed when click on a entry
# Return: none
# Sideeffects: none
##########
global axlabel
global axpar
global fonts
global color

if {$ax == {y}} {set nax {x}} {set nax {y}}

### preparo menu command ###

lappend com {AX} $frame $number $ax $comm

### creo menubutton ###

  # build widget $frame.$number.$ax
  menubutton $frame.$number.$ax \
    -menu $frame.$number.$ax.m \
    -textvariable axlabel($ax,$number) \
    -relief {ridge} \
    -width {14}

catch {$frame.$number.$ax config -font $fonts(func)}
 
  # build widget $frame.$number.$ax.m
  menu $frame.$number.$ax.m
 for {set i 1} {$i <= $axpar(0)} {incr i 1} {
 $frame.$number.$ax.m add command \
    -command $com \
    -label $axpar($i)
   }

### disabilito l'entry attiva nell'altro asse ###

$frame.$number.$ax.m disable $axlabel($nax,$number)

### pack del button ###

 # pack widget $frame.$number
    pack $frame.$number.$ax -side $pack
}


# Procedure: Graph
proc  Graph {frame number pack {w 250} {h 190}} {
##########
# Procedure:  Graph {}
# Description: Show the graph function 
# Arguments: frame - the widget frame
#            number - the widget id
#            pack - the packing side
#            w - the width of graph
#            h - the height of graph
# Return: none
# Sideeffects: none
#########
global color

### creazione grafico ###
#########################

blt_graph $frame.$number.graph

 $frame.$number.graph config -height $h
 $frame.$number.graph config -width $w
 $frame.$number.graph config -plotbackground $color(base)
 $frame.$number.graph config -plotrelief {flat}

 $frame.$number.graph legend config -mapped false

 $frame.$number.graph xaxis config -title {}
 $frame.$number.graph yaxis config -title {}

 # pack widget $frame.$number
  pack $frame.$number.graph -side $pack

}

# Procedure: Graph-Type
proc  Graph-Type {frame number pack {comm 0}} {
##########
# Procedure:  Graph-Type {}
# Description: Show the button for graph symbol choosing
# Arguments: frame - the widget frame
#            number - the widget id
#            pack - the packing side
#            comm - the command to exec
# Return: none
# Sideeffects: none
#########
global label
global color

###  menubutton per scelta linea/punti ###
 
# build widget $frame.$number.title
  menubutton $frame.$number.title \
    -menu $frame.$number.title.m \
    -text $label(function) \
    -relief {ridge} \
    -width {15}
 
# build widget $frame.$number.title.m
  menu $frame.$number.title.m

### preparo comandi ###

lappend line {Symbol} $frame $number {line} $comm
lappend dots {Symbol} $frame $number {circle} $comm

$frame.$number.title.m add command \
    -command $line \
    -label {Line Graph}

$frame.$number.title.m add command \
    -command $dots \
    -label {Dots Graph}

 # pack widget $frame.$number
  pack $frame.$number.title -side $pack

} 

 
# Procedure: AX
proc  AX {frame number ax comm} {
##########
# Procedure:  AX
# Description: set the axis parameter
# Arguments: frame - the widget frame
#            number the widget id
#            ax - the ax controlled
#            comm - the command to be executed (for global report is a new comm)
# Return: none
# Sideeffects: none
##########

global axpar
global axlabel
global symbol
global graph

if {$ax == {y}} {set nax {x}} {set nax {y}}

### prendo l' entry del menu appena scelta ###

set ind [$frame.$number.$ax.m index active]

### aggiorno stato opzioni del menu asse in questo modo: ###
### abilito l'entry dell'altro menu che e disabilitata   ###
### setto il nuovo valore da disabilitare                ###
### disabilito nell' altro menu l'entry data dal valore  ###
############################################################


$frame.$number.$nax.m enable $axlabel($ax,$number)

set axlabel($ax,$number) $axpar([expr $ind + 1])

$frame.$number.$nax.m disable $axlabel($ax,$number)   



### visualizzo grafico ###
##########################

if {$comm == 0} {
### eseguo per monitoring ###

set sx {{}} ; # serve per il check in graph display
set sy {{}} ; # come sopra

catch {set sx $graph($axlabel(x,$number))}
catch {set sy $graph($axlabel(y,$number))}

Graph-Display $frame $number $sx $sy {0} $symbol($number)} {

### eseguo solo per graph report ###
Col-Display $number}
}

# Procedure: Graph-Display
proc  Graph-Display {frame number xd yd {row 0} {sym line}} {
##########
# Procedure:  Graph-Display {}
# Description: Show the required graph
# Arguments: frame - the widget frame
#            number - the widget id
#            xd - the xdata graph
#            yd - the ydata graph
#            row - the row of graph report (only for graph report)
#            sym - the symbol of line
# Return: none
# Sideeffects: none
##########
global color
global axpar
global message

if {$row == 0} {set mess {This Node}} {
set mess {}; append mess {Node in Row } $row {,} [expr $number - 2]}

### display grafico ###

catch {$frame.$number.graph element delete line}
catch {
$frame.$number.graph element create line -xdata $xd -ydata $yd
$frame.$number.graph element config line -linewidth 0
$frame.$number.graph element config line -symbol $sym
if {$sym == {line}} {
$frame.$number.graph element config line -foreground $color(graph)} {
$frame.$number.graph element config line -foreground $color(graph)
$frame.$number.graph element config line -foreground $color(base)}
      }

## check correttezza lettura file ##

set lx [llength $xd]

for {set i 0} {$i < $lx} {incr i 1} {
if {[lindex $xd $i] == {}} {
Error $message(errgraphx) $mess $message(graphck) $message(graphtr)
break}
                                    }
set ly [llength $yd]

for {set i 0} {$i < $ly} {incr i 1} {
if {[lindex $yd $i] == {}} {
Error $message(errgraphy) $mess $message(graphck) $message(graphtr)
break}
                                    }
}


# Procedure: Symbol
proc  Symbol {frame number sym comm} {
##########
# Procedure:  Symbol
# Description: Update the graph symbol display (dots or line)
# Arguments: frame - the menus widget frame
#            number - the widget id
#            symbol - the graph symbol
#            comm - the command to exec (for monitoring or graph-report)
# Return: none
# Sideeffects: none
##########
global axlabel
global symbol
global graph

set symbol($number) $sym

if {$comm == 0} {
### eseguo per monitoring ###

set sx {{}} ; # serve per il check in graph display
set sy {{}} ; # come sopra

catch {set sx $graph($axlabel(x,$number))}
catch {set sy $graph($axlabel(y,$number))}

Graph-Display $frame $number $sx $sy {0} $symbol($number)} {

### eseguo solo per graph report ###
Col-Display $number} 

}



########################################################################
#                                                                      #
#                          REPORT GRAFICO GLOBALE                      #
#                                                                      #
########################################################################
# Procedure: Graph-Report
proc Graph-Report {} {
##########
# Procedure: Graph-Report
# Description: show the global graphic report widget
# Arguments: none 
# Return: none
# Sideeffects: none
##########

global visual
global grep

set grep 1

set visual(1) {none}
set visual(2) {none}
set visual(3) {none}

Graph-Rep

}

# Procedure: Graph-Rep
proc Graph-Rep {} {
##########
# Procedure: Graph-Rep
# Description: show the global graphic report widget
# Arguments: none 
# Return: none
# Sideeffects: none
##########

global totnode
global axpar
global visual
global axlabel


if {$totnode >= 2} {set dim 560}
if {$totnode == 1} {set dim 400}
if {$totnode == 0} {set dim 245}

### crea top level widget ###

catch {destroy .top}
toplevel .top

  # Window manager configurations
  global tkVersion
  wm positionfrom .top ""
  wm sizefrom .top ""
  wm maxsize .top 800 1000
  wm minsize .top 10 10 
  wm geometry .top 490x$dim
  wm geometry .top +200+0
  wm title .top {Regal 3.1: GRAPHIC GLOBAL REPORT}

### pulsanti di comando ###
###########################

Command-Row .top {0}


### prima riga grafici ###
##########################

Graph-Row .top {1}
#Row-Display .top {1} {1}

### seconda riga grafici ###
############################

if {$totnode > 0} {
Graph-Row .top {2}
#Row-Display .top {2} {1}
                        }

### terza riga grafici ###
##########################

if {$totnode > 1} {
Graph-Row .top {3}
#Row-Display .top {3} {1}
                        }
 

}


# Procedure: Command-Row
proc Command-Row {frame number} {
##########
# Procedure: Command-Row
# Description: build the command higher row
# Arguments: frame - the frame where to put the widget
#            number the widget id 
# Return: none
# Sideeffects: none
########## 
global color

catch {destroy $fraem.$number}
 
  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

### commands top left ###


  # build widget $frame.$number.qh
  frame $frame.$number.qh \
    -borderwidth {2} \
    -relief {sunken}

  # build widget $frame.$number.qh.quit
  button $frame.$number.qh.quit \
    -text {quit} \
    -command {set grep 0;destroy {.top}} \
    -width {9}

 catch {$frame.$number.qh.quit config -background $color(quit)}
 catch {$frame.$number.qh.quit config -foreground $color(writequit)}

  # build widget $frame.$number.qh.help
  button $frame.$number.qh.help \
    -text {help} \
    -command {Command-Help} \
    -width {9}

  # pack widget $frame.$number.qh
  pack append $frame.$number.qh \
    $frame.$number.qh.quit {top frame center padx 16 pady 10} \
    $frame.$number.qh.help {top frame center pady 10}
    

  # pack widget  $frame.$number
  pack append  $frame.$number \
     $frame.$number.qh {left frame center padx 12}

### comandi prima colonna ###

AxCommands $frame.$number {3}

### comandi seconda colonna ###

AxCommands $frame.$number {4}


### pack della riga comandi ###


# pack widget $frame
  pack append $frame  \
    $frame.$number {top frame nw}


}


# Procedure: Graph-Row
proc Graph-Row {frame number} {
##########
# Procedure: Graph-Row
# Description: build the 2 graphics row
# Arguments: frame - the frame where to put the widget
#            number the widget id 
# Return: none
# Sideeffects: none
##########
global axlabel
global symbol

catch {destroy $frame.$number}
 
  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

### scelta nodo da monitorare ###

NodeButton $frame $number
 
### grafico colonna 1 ###

# build widget $frame.$number.3
  frame $frame.$number.3 \
    -borderwidth {2} \
    -relief {ridge}
 
Graph $frame.$number {3} {left} {184} {145}


# pack widget $frame.$number
  pack append $frame.$number  \
    $frame.$number.3 {left frame w}

### grafico colonna 2 ###

# build widget $frame.$number.4
  frame $frame.$number.4 \
    -borderwidth {2} \
    -relief {ridge}

Graph $frame.$number {4} {left} {184} {145}


# pack widget $frame.$number
  pack append $frame.$number  \
    $frame.$number.4 {left frame w}


# pack widget $frame
  pack append $frame\
    $frame.$number {top frame w}
}


# Procedure: NodeButton
proc NodeButton {frame number} {
##########
# Procedure: NodeButton
# Description: build the menubutton for choose node in graph row
# Arguments: frame - the frame where to put the widget
#            number - the widget id
# Return: none
# Sideeffects: none
##########
global visual
global totnode
global node

 # build widget $frame.$number.node
  menubutton $frame.$number.node \
    -menu $frame.$number.node.m \
    -width {10} \
    -relief {ridge} \
    -textvariable visual($number)

  # build widget $frame.$number.node.m
  menu $frame.$number.node.m
   
  Init-menu-Graph $frame $number

  # pack widget $frame.$number
  pack append $frame.$number  \
    $frame.$number.node {left frame center padx 25}
}

# Procedure: Init-menu-Graph
proc  Init-menu-Graph {frame number} {
##########
# Procedure:  Init-menu-Graph
# Description: init the graph menubutton node of graph report
# Arguments: frame - the frame where is the button 
#            number - the widget id
# Return: none
# Sideeffects: none
##########
global totnode
global node

### preparo comandi menubutton ###

lappend comm {Row-Display} $frame $number 

### inizializzo menu di scelta nodo ###
#######################################

 $frame.$number.node.m add command \
    -command $comm \
    -label {Supervisor}


if {$totnode <= 20} then {

 for {set i 0} {$i < $totnode} {incr i 1} \
	{
 	 $frame.$number.node.m add command \
    	  -command $comm \
          -label $node($i,0)                                           
        }
                         } else {
  
 set nmenu [expr $totnode / 20]
 set start 0
 
 for {set n 0} {$n <= $nmenu} {incr n 1} {
	
  ## crea menu associato al cascade ##

  menu $frame.$number.node.m.$n

  for {set i $start} {$i < [expr $start + 20] && $i < $totnode} {incr i 1} {

		$frame.$number.node.m.$n add command \
    	 	 -command $comm \
          	 -label $node($i,0)

									    }
  ## preparo label per il cascade button ##

  set label {}

  set first $node($start,0)
  set last $node([expr $i -1],0)

  append label $first "--" $last

  ## creo cascade button ###

  $frame.$number.node.m add cascade \
    -label $label \
    -menu $frame.$number.node.m.$n

  set start [expr $start + 20]  

					 }
				  }

}

# Procedure: Enable-menu-Graph
proc Enable-menu-Graph {frame number} {
##########
# Procedure: Enable-menu-Graph
# Description: update the node menu
# Arguments: frame - the widget frame
#            number - the widget id
# Return: none
# Sideeffects: none
##########
global totnode
global widget

if {$totnode <= 20} then {

	for {set i 0} {$i <= $totnode} {incr i 1} {
		$frame.$number.node.m enable $i
						  }
                         } else {

	$frame.$number.node.m enable 0

	set nmenu [expr $totnode / 20]
	
	for {set n 0} {$n <= $nmenu} {incr n 1} {

		for {set i 0} {$i < 20} {incr i 1} {
				
			$frame.$number.node.m.$n enable $i

						   }
						 }
				 }
}


# Procedure: Update-Node-Graph
proc  Update-Node-Graph {node frame number} {
##########
# Procedure:  Update-Node-Graph
# Description: update the graph report node menu
# Arguments: node - the monitored node (Supervisor or NGA..)
#            frame - the widget frame
#            number - the widget id
# Return: none
# Sideeffects: none
##########
global widget
global totnode

###aggiorno stato entry del menu scelta nodo da monitorare ###
##############################################################

Enable-menu-Graph $frame $number

if {$totnode <= 20 || $node == "Supervisor"} then {
	$frame.$number.node.m disable $node
			   } else {
	
	set nmenu [expr $totnode / 20]
	for {set i 0} {$i <= $nmenu} {incr i 1} {
		catch {$frame.$number.node.m.$i disable $node}
						}
				  }

}

# Procedure: Graph-Mon
proc   Graph-Mon {frame number} {
##########
# Procedure:   Graph-Mon
# Description: return the node active in the menubutton node
# Arguments: frame - the widget frame
#            number - the widget id
# Return: none
# Sideeffects: none
##########
global totnode
global node
global visual

set proc [$frame.$number.node.m index active]

set nmenu [expr $totnode / 20]

if {$proc == 0} {set visual($number) {Supervisor}}

if {$proc != 0 && $proc != "none"} {
	set visual($number) $node([expr $proc - 1],0)
                                   }

if {$proc == "none"} {

	set i 0

	while {$proc == "none" && $i <= $nmenu} {

		catch {set proc [$frame.$number.node.m.$i index active]}
                
		set i [expr $i + 1]

						 }
        if {$proc != "none"} {
		set mult [expr [expr $i - 1] * 20]
		set visual($number) $node([expr $proc + $mult],0)
			     } {
		set visual($number) {Supervisor}
			       }
		     }



Update-Node-Graph $visual($number) $frame $number
}


# Procedure: AxCommands
proc AxCommands {frame number} {
##########
# Procedure: AxCommands
# Description: build the area with graph type, x, y buttons in command row
# Arguments: frame - the frame where to put the widget
#            number the widget id 
# Return: none
# Sideeffects: none
##########

catch {destroy $frame.$number}

  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2} \
    -relief {ridge}

### button per scelta tipo grafico ###

Graph-Type $frame $number {top} {1}


### label per assi ###

  # build widget $frame.$number.label
  frame $frame.$number.label \
    -borderwidth {2}

  # build widget $frame.$number.label.x
  label $frame.$number.label.x \
    -text {X axis:}

  # build widget $frame.$number.label.y
  label $frame.$number.label.y \
    -text {Y axis:}

  # pack widget $frame.$number.label
  pack append $frame.$number.label \
    $frame.$number.label.x {left frame w padx 25} \
    $frame.$number.label.y {left frame e padx 25}

  # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.label {top frame s}

### buttons per scelta asse ###

AxButton $frame $number {x} {left} {1}
AxButton $frame $number {y} {left} {1}


 # pack widget $frame
  pack append $frame \
    $frame.$number {left frame center}

}
 


# Procedure: Row-Display
proc Row-Display {frame number {flag 0}} {
##########
# Procedure: Row-Display
# Description: redisplay the graphs in a row
# Arguments: frame - the frame where to put the widget
#            number - the widget id 
#            flag - useful for set node to visual
# Return: none
# Sideeffects: none
##########
global symbol
global graphr1 graphr2 graphr3
global axlabel
global visual
global node

### aggiorno menu e label di nodo monitorato ###

if {$flag == 0} {

Graph-Mon $frame $number
                }

## setto valore dati x e y grafici ##

Org_rep_graf $visual($number) $number

# serve per il check in graph display #
set sx {{}}; set sy {{}}; set dx {{}}; set dy {{}} 

if {$number == 1} {
catch {
set sx $graphr1($axlabel(x,3))
set sy $graphr1($axlabel(y,3))
set dx $graphr1($axlabel(x,4))
set dy $graphr1($axlabel(y,4))
      }          
                  }

if {$number == 2} {
catch {
set sx $graphr2($axlabel(x,3))
set sy $graphr2($axlabel(y,3))
set dx $graphr2($axlabel(x,4))
set dy $graphr2($axlabel(y,4))        
      }
                  }

if {$number == 3} {
catch {
set sx $graphr3($axlabel(x,3))
set sy $graphr3($axlabel(y,3))
set dx $graphr3($axlabel(x,4))
set dy $graphr3($axlabel(y,4))
      }
                  }

### aggiorno grafici riga scelta ###

Graph-Display $frame.$number {3} $sx $sy $number $symbol(3)

Graph-Display $frame.$number {4} $dx $dy $number $symbol(4)

}

# Procedure: Col-Display
proc Col-Display {number {frame .top}} {
##########
# Procedure: Col-Display
# Description: redisplay the graphs in a column
# Arguments: frame - the frame where to put the widget
#            number the widget id 
# Return: none
# Sideeffects: none
##########
global axlabel
global graphr1 graphr2 graphr3
global symbol
global totnode

### servono per check in graph display ###

set x1 {{}}; set y1 {{}}
set x2 {{}}; set y2 {{}}
set x3 {{}}; set y3 {{}}

catch {set x1 $graphr1($axlabel(x,$number))}
catch {set y1 $graphr1($axlabel(y,$number))}
catch {set x2 $graphr2($axlabel(x,$number))}
catch {set y2 $graphr2($axlabel(y,$number))}
catch {set x3 $graphr3($axlabel(x,$number))}
catch {set y3 $graphr3($axlabel(y,$number))}



Graph-Display $frame.1 $number $x1 $y1 {1} $symbol($number)

if {$totnode >= 1} {
Graph-Display $frame.2 $number $x2 $y2 {2} $symbol($number)
                         }
if {$totnode >= 2} {
Graph-Display $frame.3 $number $x3 $y3 {3} $symbol($number)
                         }

}

