# Procedure: Init-Globals 
proc Init-Globals {} {
##########
# Procedure: Init-Globals
# Description: Initialize global variables
# Arguments: none
# Return: none
# Sideeffects: none
##########

Init-Paths
Init-Default
Init-Labels
Init-Widgets
Init-Messages
Init-Algs



###INSERT HERE THE COMMANDS FOR THE BUTTONS STAR RESTART HALT  ###




#######################################################################

global regal_com

set regal_com(start) regal; set regal_com(startf) -s 
set regal_com(restart) regal; set regal_com(restartf) -r 
set regal_com(halt) KILL_REGAL
#set regal_com(halt) kill; set regal_com(haltf) -9

########################################################################



################# Don't modify nothing below this line ################






global regal_pid ;#process id of Regal
set regal_pid 0



global data ciclo; #variables used to kill subprocess wait

set data {}
set ciclo {}

#modifica
global inwin ;#records the window is currently displayed
set inwin intro
}

# Procedure: Init-Paths 
proc Init-Paths {} {
##########
# Procedure: Init-Paths
# Description: Initialize paths
# Arguments: none
# Return: none
# Sideeffects: none
##########

global VAR_DIR VAR_FILE

set VAR_DIR dataframe; #directory where variables setting have to be saved
set VAR_FILE globalvar.i; #file name where variables setting have to be saved

global NET_DIR NET_FILE 

set NET_DIR dataframe ; #directory where network setting have to be saved
set NET_FILE parameters.i; #file name where network setting have to be saved

global PVM_DIR PVM_FILE

set PVM_DIR dataframe; #directory where pvm hosts setting have to be saved
set PVM_FILE pvm_hosts ; #file name where pvm hosts setting have to be saved


global HELP_DIR 

set HELP_DIR help ; #directory where the help file is

global COM_DIR COM_FILE GLOBBE_FILE

set COM_DIR interface ; #directory where the command file is
set COM_FILE COMMAND_FILE ;#name of the used command file 
set GLOBBE_FILE global_behaviour.tm ;#name of the used command file 

global PID_FILE 

set PID_FILE REGAL_PID ; #name for the pid_file

global NODE_FILE

set NODE_FILE REGAL_NODES ; #name for the regal_node file
}

# Procedure: Init-Default 
proc Init-Default {} {
##########
# Procedure: Init-Default
# Description: Initialize monitoring parameters to default
# Arguments: none
# Return: none
# Sideeffects: none
##########

# parameters
############

global parameters

catch {unset parameters}

set parameters(0) 6
set parameters(start) 0

set parameters(1,0) generation
set parameters(2,0) cover_pos
set parameters(3,0) cover_neg
set parameters(4,0) max_disjunct
set parameters(5,0) smallest_disjunct
set parameters(6,0) avg_disjunct

set parameters(1,1) 0
set parameters(2,1) 0
set parameters(3,1) 0
set parameters(4,1) 0
set parameters(5,1) 0
set parameters(6,1) 0

## function
############
 
global axvar

set axvar 0

global axpar

catch {unset axpar}


set axpar(0) 2
set axpar(1) {generation}
set axpar(2) {simplicity}


global axlabel

set axlabel(x,1) $axpar(1) 
set axlabel(y,1) $axpar(2)
set axlabel(x,2) $axpar(1)
set axlabel(y,2) $axpar(2)
set axlabel(x,3) $axpar(1)
set axlabel(y,3) $axpar(2)
set axlabel(x,4) $axpar(1)
set axlabel(y,4) $axpar(2)



global graph graphr1 graphr2 graphr3

catch {unset graph}
catch {unset graphr1}
catch {unset graphr2}
catch {unset graphr3}

set lista {generation simplicity cover-pos cover-neg max-disjunct smallest-disjunct avg-disjunct}

foreach i $lista {set graph($i) {};set graphr1($i) {};set graphr2($i) {};set graphr3($i) {}}


			    
## node monitored
##################

global node_monitored
set node_monitored {Supervisor}


### graphic report ###

global visual

catch {unset visual}

set visual(1) {none}
set visual(2) {none}
set visual(3) {none}

}




# Procedure: Init-Labels 
proc Init-Labels {} {
##########
# Procedure: Init-Labels
# Description: Initialize global variables : labels
# Arguments: none
# Return: none
# Sideeffects: none
##########

global label

# label di echostate
####################

set label(ready) {ready}
set label(setvar) {setting GA variables}
set label(setnet) {setting Network parameters}
set label(monitoring) {monitoring node: }

# label del buttons panel
#########################
set label(inter) {Interface Commands}
set label(reg) {Regal Commands}


set label(var) {SET VARS}
set label(net) {SET NET}
set label(str) {START}
set label(rst) {RESTART}
set label(last) {SEE STATUS}
set label(stm) {STOP MONIT}
set label(help) {HELP}
set label(quit) {QUIT}
set label(node) {NODE}
set label(halt) {HALT}
set label(graph) {GRAPH REPORT}
set label(refresh) {REFRESH}

# label di set var 
####################

set label(savevar) {Save Vars}

set label(ga) {GA PARAMETERS}
set label(migration) {MIGRATION}
set label(report) {REPORT}
set label(solution) {SOLUTION}
set label(par) {PARAMETERS}

set label(goalcl) {goalcl}
set label(pop_size) {pop-size}
set label(percentage) {percentage}
set label(global_persistence) {global-persist}
set label(epochs) {epochs}
set label(generation_gap) {generation-gap}
set label(gens_for_epoch) {gens-for-epoch}
set label(crossover_rate) {crossover-rate}
set label(mutation_rate) {mutation-rate}
set label(complement_rate) {complement-rate}
set label(migration_rate) {migration-rate}
set label(foreign_mating_rate) {foreign-mating-rt}
set label(open_to_foreign) {open-to-foreign}
set label(quantum) {quantum}
set label(node_persistence) {node-persist}
set label(decision_limit) {decision-limit}
set label(change_ratio) {change-ratio}
set label(overlap_ratio) {overlap-ratio}


# label di set net
##################

set label(savenet) {Save Net}

set label(virtual) {VIRTUAL NETWORK PARAMETERS}
set label(pvm) {PVM HOSTS PARAMETERS}

set label(distribution) {Current Distribution}

set label(nodes) {nodes}
set label(topology) {topology}
set label(dimension) {dimension}

# label di  monitoring
######################

### parameters

set label(parameters) {Parameters}

set label(generation) {generation}
set label(cover_pos) {cover-pos}
set label(cover_neg) {cover-neg}
set label(max_disjunct) {max-disjunct}
set label(smallest_disjunct) {smallest-disjunct}
set label(avg_disjunct) {avg-disjunct}
set label(assignement) {assignement}

### formula

set label(cur-formula) {Current Formula}
set label(prev-formula) {Previous Formula}

### function

set label(function) {Function}

### global report

set label(glbrep) {Population Number : }
set label(generation) {Generation}
set label(assignement) {Assignement}
}

# Procedure: Init-Messages 
proc Init-Messages {} {
##########
# Procedure: Init-Messages
# Description: Initialize global variables : Messages
# Arguments: none
# Return: none
# Sideeffects: none
##########

global message

# error message
###############

set message(errconf) {REGAL 3.1         

Configuration Parameters Error       


Incorrect value for parameter:
}
set message(errpar) {REGAL 3.1

Read File Error

Incorrent value for parameters data of:
}

set message(errgraphx) {REGAL 3.1

Read File Error

Incorrent value for  x graph data of:
}

set message(errgraphy) {REGAL 3.1

Read File Error

Incorrent value for y graph data of:
}


set message(graphck) {Error detected in COMMAND_FILE or in 
FUNCTION data file for the node}

set message(errck) {Error detected in PARAMETERS
data file for the node}

set message(graphtr) {Click REFRESH and try again}

set message(errconfint) {The value must be an integer >= }

set message(errconfloat) {The value must be a real in range (0,1)}

set message(errconfeven) {The value must be an even integer > 0}

set message(errconftop) {The legal value are displayed in the 
topology menu}

set message(errconfdist) {In Set Network menu

The sum of distributions must be
equal to the number of nodes}

set message(errconfexp) {In the Set Network menu

the number of nodes must be a power of 2}

set message(erdim) {In Set Network menu

The value of dimension must be equal
or less than the number of nodes}

set message(warning) {Click on OK will reset the value}

set message(regal) {Regal 3.2}

set message(approach) {A sex based approach to Concept Induction}

set message(copy) {Authors:

 Attilio Giordana   and   Filippo Neri
attilio@di.unito.it        neri@di.unito.it

      Dipartimento di Informatica
          Universita' di Torino
                   ITALY

                                     }

set message(quit) {Really Quit ?}
}

# Procedure: Init-Widgets 
proc Init-Widgets {} {
##########
# Procedure: Init-Widgets
# Description: Initialize global variables : Widgets
# Arguments: none
# Return: none
# Sideeffects: none
##########
global label
global monitoring

set monitoring 0


### bindings aggiungo il focus none utile per il check sui parametri ###
########################################################################

bind Button <Any-Enter> {+focus none}

# display control
#################

global first grep

set first 0
set grep 0

### widgets ###
###############

global widget

set widget(top) .
set widget(button) .button
set widget(main) .main
set widget(state) .state


### dimension ###
#################

global dim

set dim(int) 6
set dim(fl) 12
set dim(topol) 15
set dim(goal) 20
set dim(netpady) 20

### fonts ###
#############

global fonts

set fonts(form) {-adobe-times-medium-r-normal--14-*-*-*-*-*-iso8859-1}
set fonts(func) {-adobe-helvetica-bold-r-normal--10-100-75-75-p-60-iso8859-1}
set fonts(intr) {-adobe-helvetica-medium-o-normal--18-180-75-75-p-98-iso8859-1}
set fonts(intr1) {-adobe-helvetica-medium-o-normal--18-180-75-75-p-98-iso8859-1}

### colors ###
##############

global color
set color(cornice) {#ffe4c4}; # bisque
set color(base) {#ffe4c4}; # bisque
set color(entry) {#fffff0}; # avorio
set color(pulsanti) {#ebebeb}; # ghiacccio
set color(black) {#000000}; # nero
set color(state) {#bbdcee}; # azzurro
set color(graph) {#000000}; # nero
set color(quit) {#ff0000}; # rosso
set color(writequit) {#ffffff}; # bianco

### simbolo del grafico ###

global symbol
set symbol(1) {line}
set symbol(2) {line}
set symbol(3) {line}
set symbol(4) {line}


### stato dell' interfaccia ###

global echostate

set echostate $label(ready)

}


# Procedure: Init-Algs 
proc Init-Algs {} {
##########
# Procedure: Init-Algs
# Description: Initialize global variables : algorithm parameters
# Arguments: none
# Return: none
# Sideeffects: none
##########

# modifica dei parametri
########################

global modifica

set modifica(1) 0
set modifica(2) 0

# ga parameters
##########################
global parconf

set parconf(goalcl) {1}
set parconf(pop_size) {100}
set parconf(percentage) {0.800000}
set parconf(global_persistence) {200}
set parconf(epochs) {100}
set parconf(generation_gap) {0.900000}
set parconf(gens_for_epoch) {1}
set parconf(crossover_rate) {0.600000}
set parconf(mutation_rate) {0.000010}
set parconf(complement_rate) {0.00000}
set parconf(migration_rate) {0.500000}
set parconf(foreign_mating_rate) {0.500000}
set parconf(open_to_foreign) {1}
set parconf(quantum) {5}
set parconf(node_persistence) {0}
set parconf(decision_limit) {0.001000}
set parconf(change_ratio) {2}
set parconf(overlap_ratio) {0.999990}


# net parameters
########################

global parnet

set parnet(nodes) 0
set parnet(topology) {hypercube}
set parnet(dimension) {0}

global nhost

set nhost 0

global host


### error checking ###

global checker

set checker(dim) {0}
set checker(distr) {0} 
set checker(val) {0}

### report globale ###

global report

set report(start) 0

}
