# Procedure: Monitoring
proc  Monitoring {frame number} {
##########
# Procedure:  Monitoring
# Description: Show the Monitoring window
# Arguments: frame - the frame where to put the widget
#            number - the widget id
# Return: none
# Sideeffects: none
##########
global label
global echostate
global node_monitored
global node
global first

### crea area di monitoring ###
###############################

catch {destroy $frame.$number}

  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

  # build widget $frame.$number.up
  frame $frame.$number.up \
    -borderwidth {2} 

  # build widget $frame.$number.dw
  frame $frame.$number.dw \
    -borderwidth {2} 

  # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.up {top frame center} \
    $frame.$number.dw {bottom frame center}

  # pack widget $frame
  pack append $frame \
    $frame.$number {top frame center}
 
### setto nodo da visualizzare  ###
###################################


Node-Mon


### call delle varie parti di monitoring ###
############################################ 

 Formula $label(cur-formula) $frame.$number.up {2}
 Formula $label(prev-formula) $frame.$number.up {3}


 if {$node_monitored == {Supervisor}} \
   {Glb-Rep $label(glbrep) $frame.$number.dw {1} {left}
    if {$first == 0} \
        {Parameters $label(parameters) $frame.$number.up {1}
         Function $frame.$number.dw {2} {right}
         set first 1
        }
     

   } \
   {if {$first == 0} \
         {Parameters $label(parameters) $frame.$number.up {1}
          Function $frame.$number.dw {1} {left}
          Function $frame.$number.dw {2} {right}
          set first 1
         }
   }



### modifica label di stato della window ###
############################################

set echostate {}
append echostate $label(monitoring) $node_monitored

}

# Procedure: Update-Nodes
proc  Update-Nodes {node} {
##########
# Procedure:  Update-Nodes
# Description: update the node menu
# Arguments: node - the monitored node (Supervisor or NGA..)
# Return: none
# Sideeffects: none
##########
global widget
global totnode

###aggiorno stato entry del menu scelta nodo da monitorare ###
##############################################################

Enable-All

if {$totnode <= 20 || $node == "Supervisor"} then {
	$widget(button).gui.vol.node.m disable $node
			   } else {
	
	set nmenu [expr $totnode / 20]
	for {set i 0} {$i <= $nmenu} {incr i 1} {
		catch {$widget(button).gui.vol.node.m.$i disable $node}
						}
				  }

}


# Procedure: Enable-All
proc Enable-All {} {
##########
# Procedure: Enable-All
# Description: update the node menu
# Arguments: none
# Return: none
# Sideeffects: none
##########
global totnode
global widget

if {$totnode <= 20} then {

	for {set i 0} {$i <= $totnode} {incr i 1} {
		$widget(button).gui.vol.node.m enable $i
						  }
                         } else {

	$widget(button).gui.vol.node.m enable 0

	set nmenu [expr $totnode / 20]
	
	for {set n 0} {$n <= $nmenu} {incr n 1} {

		for {set i 0} {$i < 20} {incr i 1} {
				
			$widget(button).gui.vol.node.m.$n enable $i

						   }
						 }
				 }
}

# Procedure: Node-Mon
proc   Node-Mon {} {
##########
# Procedure:   Node-Mon
# Description: return the node active in the menubutton node
# Arguments: none
# Return: none
# Sideeffects: none
##########
global totnode
global node
global node_monitored

set proc [.button.gui.vol.node.m index active]

set nmenu [expr $totnode / 20]

if {$proc == 0} {set node_monitored {Supervisor}}

if {$proc != 0 && $proc != "none"} {
	set node_monitored $node([expr $proc - 1],0)
                                   }

if {$proc == "none"} {

	set i 0

	while {$proc == "none" && $i <= $nmenu} {

		catch {set proc [.button.gui.vol.node.m.$i index active]}
                
		set i [expr $i + 1]

						 }
        if {$proc != "none"} {
		set mult [expr [expr $i - 1] * 20]
		set node_monitored $node([expr $proc + $mult],0)
			     } {
		set node_monitored {Supervisor}
			       }
		     }



Update-Nodes $node_monitored
}


