# Procedure: ButtonS
proc  ButtonS {frame} {
##########
# Procedure:  ButtonS
# Description: build the buttons panel for non monitoring
# Arguments: frame - the frame where to put the widget
# Return: none
# Sideeffects: none
##########
global label
global color
global regal_pid

  # build widget $frame.gui
  frame $frame.gui \
    -borderwidth {2} \
    -relief {sunken}
 
# build widget $frame.gui.lab
  label $frame.gui.lab \
    -text $label(inter)

# pack widget $frame.gui
  pack append $frame.gui \
    $frame.gui.lab {top frame n padx 270}

### parte di pannello modificabile ###

Button-Idle $frame.gui

######################################
 
 # build widget $frame.gui.monit
  frame $frame.gui.monit \
    -borderwidth {2}

  # build widget $frame.gui.monit.last
  button $frame.gui.monit.last \
    -command {Command-Last} \
    -text $label(last) \
    -width {13}

  # build widget $frame.gui.monit.stop
  button $frame.gui.monit.stop \
    -text $label(stm) \
    -command {Command-Stm} \
    -width {13}

Config-Mon-Buttons {normal} {disabled}
 
  # pack widget $frame.gui.monit
  pack append $frame.gui.monit \
    $frame.gui.monit.last {top frame center padx 5 pady 5} \
    $frame.gui.monit.stop {top frame center pady 10}


  # pack widget $frame.gui
  pack append $frame.gui \
    $frame.gui.monit {right frame center}
 

    
  # build widget $frame.regal
  frame $frame.regal \
    -borderwidth {2} \
    -relief {sunken}

  # build widget $frame.regal.str
  button $frame.regal.str \
    -text $label(str) \
    -command {Command-Start {s}} \
    -width {9}

  # build widget $frame.regal.rst
  button $frame.regal.rst \
    -text $label(rst) \
    -command {Command-Start {r}} \
    -width {9}

  # build widget $frame.regal.halt
  button $frame.regal.halt \
    -text $label(halt) \
    -command {Command-Halt} \
    -width {9}


  # build widget $frame.regal.lab
  label $frame.regal.lab \
    -text $label(reg)

  # pack widget $frame.regal
  pack append $frame.regal \
    $frame.regal.lab {top frame n} \
    $frame.regal.str {left frame e padx 10} \
    $frame.regal.rst {left frame center padx 10} \
    $frame.regal.halt {left frame center padx 10 pady 40}

  if {$regal_pid == 0} \
        {Config-Regal-Buttons {normal} {normal} {disabled}} \
        {Config-Regal-Buttons {disabled} {disabled} {normal}}

  # build widget $frame.qh
  frame $frame.qh \
    -borderwidth {2} \
    -relief {sunken}

  # build widget $frame.qh.quit
  button $frame.qh.quit \
    -command {Command-Quit} \
    -text $label(quit) \
    -width {10}

 catch {$frame.qh.quit config -background $color(quit)}
 catch {$frame.qh.quit config -foreground $color(writequit)}

  # build widget $frame.qh.help
  button $frame.qh.help \
    -command {Command-Help} \
    -text $label(help) \
    -width {10}

  # pack widget $frame.qh
  pack append $frame.qh \
    $frame.qh.quit {top frame center padx 14 pady 30} \
    $frame.qh.help {top frame center pady 10}

  # pack widget $frame
  pack append $frame \
    $frame.gui {left frame center} \
    $frame.regal {left frame center padx 3} \
    $frame.qh {right frame center}

}


# Procedure: Button-Idle
proc  Button-Idle {frame} {
##########
# Procedure:  Button-Idle
# Description: build the buttons panel for non monitoring
# Arguments: frame - the frame where to put the widget
# Return: none
# Sideeffects: none
##########
global label

catch {destroy $frame.vol}

  # build widget $frame.vol
  frame $frame.vol \
    -borderwidth {2}

  # build widget $frame.vol.var
  button $frame.vol.var \
    -command {Command-Var} \
    -text $label(var) \
    -width {12}

  # build widget $frame.vol.net
  button $frame.vol.net \
    -command {Command-Net} \
    -text $label(net) \
    -width {12}

  # pack widget $frame.vol
  pack append $frame.vol \
    $frame.vol.var {left frame e} \
    $frame.vol.net {left frame center padx 10}

 # pack widget $frame
  pack append $frame \
    $frame.vol {left frame w}

}





# Procedure: Button-Monit
proc  Button-Monit {frame} {
##########
# Procedure:  Button-Monit
# Description: build the buttons panel for monitoring
# Arguments: frame - the frame where to put the widget
# Return: none
# Sideeffects: none
##########
global label

catch {destroy $frame.vol}

  # build widget $frame.vol
  frame $frame.vol \
    -borderwidth {2}

 # build widget $frame.vol.node
  menubutton $frame.vol.node \
    -menu $frame.vol.node.m \
    -relief {raised} \
    -text $label(node) \
    -width {10}

  # build widget $frame.vol.node.m
  menu $frame.vol.node.m

  # build widget $frame.vol.graph
  button $frame.vol.graph \
    -text $label(graph) \
    -command {Graph-Report} \
    -width {14}

  # build widget $frame.vol.ref
  button $frame.vol.ref \
  -text $label(refresh) \
  -command {Organizza $HOME/$COM_DIR/$COM_FILE} \
  -width {10}

### pack dei nuovi pulsanti ###
###############################

  # pack widget $frame.vol
  pack append $frame.vol \
    $frame.vol.graph {left frame center padx 10} \
    $frame.vol.ref {right frame center padx 5} \
    $frame.vol.node {right frame center padx 5}   


 # pack widget $frame
  pack append $frame \
    $frame.vol {left frame w}

}

# Procedure: Config-Regal-Buttons
proc  Config-Regal-Buttons {one two three} {
##########
# Procedure:  Config-Regal-Buttons
# Description: config the state of regal commands
# Arguments: the id of buttons
# Return: none
# Sideeffects: none
##########
global widget

$widget(button).regal.str config -state $one
$widget(button).regal.rst config -state $two
$widget(button).regal.halt config -state $three

}



# Procedure: Config-Set-Buttons
proc  Config-Set-Buttons {one two three} {
##########
# Procedure:  Config-Set-Buttons
# Description: config the state of set par buttons
# Arguments: the id of buttons
# Return: none
# Sideeffects: none
##########
global widget

catch {$widget(button).gui.vol.var config -state $one}
catch {$widget(button).gui.vol.net config -state $two}
catch {$widget(button).gui.vol.save config -state $three}

}



# Procedure: Config-Mon-Buttons
proc  Config-Mon-Buttons {one two} {
##########
# Procedure:  Config-Set-Buttons
# Description: config the state of monit buttons
# Arguments: the id of buttons
# Return: none
# Sideeffects: none
##########
global widget

$widget(button).gui.monit.last config -state $one
$widget(button).gui.monit.stop config -state $two

}


# Procedure: Init-menu-Node
proc  Init-menu-Node {frame} {
##########
# Procedure:  Init-menu-Node
# Description: init the menubutton node of monitoring
# Arguments: frame - the frame where is the button
# Return: none
# Sideeffects: none
##########
global totnode
global node

### inizializzo menu di scelta nodo ###
#######################################

 $frame.vol.node.m add command \
    -command {Command-Node} \
    -label {Supervisor}

$frame.vol.node.m disable 0

if {$totnode <= 20} then {

 for {set i 0} {$i < $totnode} {incr i 1} \
	{
 	 $frame.vol.node.m add command \
    	  -command {Command-Node} \
          -label $node($i,0)                                           
        }
                         } else {
  
 set nmenu [expr $totnode / 20]
 set start 0
 
 for {set n 0} {$n <= $nmenu} {incr n 1} {
	
  ## crea menu associato al cascade ##

  menu $frame.vol.node.m.$n

  for {set i $start} {$i < [expr $start + 20] && $i < $totnode} {incr i 1} {

		$frame.vol.node.m.$n add command \
    	 	 -command {Command-Node} \
          	 -label $node($i,0)

									    }
  ## preparo label per il cascade button ##

  set label {}

  set first $node($start,0)
  set last $node([expr $i -1],0)

  append label $first "--" $last

  ## creo cascade button ###

  $frame.vol.node.m add cascade \
    -label $label \
    -menu $frame.vol.node.m.$n

  set start [expr $start + 20]  

					 }
				  }

}





# Procedure: State
proc  State {frame} {
##########
# Procedure:  State
# Description: build the buttons panel for non monitoring
# Arguments: frame - the frame where to put the widget
# Return: none
# Sideeffects: none
##########
global color  
 
  # build widget $frame.state
  label $frame.state \
    -textvariable {echostate} \
    -width {100} \
    -background $color(state)
  
  # pack widget $frame
  pack append $frame \
    $frame.state {top frame center padx 33 pady 3}


}

# Procedure: Save-button
proc Save-button {frame text command} {
##########
# Procedure: Save-button
# Description: Show the save vars or net button
# Arguments: frame - the frame where to put the widget
#            text - the label button
#            command - the command to perform
# Return: none
# Sideeffects: none
##########
global widget

  catch {destroy $frame.save}

  # build widget $frame.save
  button $frame.save \
    -text $text \
    -command $command \
    -width {9}


  # pack widget $frame
  pack append $frame \
    $frame.save {left frame center padx 5}
}



