# Procedure: Parameters
proc  Parameters {title frame number} {
##########
# Procedure:  Parameters
# Description: Show the Parameters display window
# Arguments: title - the title of widget
#            frame - the frame where to put the widget
#            number - the id of widget
# Return: none
# Sideeffects: none
##########

global message

if {[Params $title $frame $number] != 0} {
 Error $message(errpar) {This Node} $message(errck) $message(graphtr)}
}

# Procedure: Params
proc  Params {title frame number} {
##########
# Procedure:  Params
# Description: Show the Parameters display window
# Arguments: title - the title of widget
#            frame - the frame where to put the widget
#            number - the id of widget
# Return: 1 if an error occur in read file 0 otherwise
# Sideeffects: none
##########
global parameters

set error 0

catch {destroy $frame.$number}

### crea area parametri top left ###
####################################

  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}
  
  # build widget $frame.$number.dummyv
  frame $frame.$number.dummyv \
    -borderwidth {2} \
    -geometry {1x165}
  
  # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.dummyv {left frame center}

  # build widget $frame.$number.title
  label $frame.$number.title \
    -text $title

  # build widget $frame.$number.fr
  frame $frame.$number.fr \
    -borderwidth {2}

###  crea  righe di parametri ###
#################################

for {set i 1} {$i <= $parameters(0)} {incr i 1} {
if {$parameters($i,1) == {}} {set error 1} }   
    

for {set i 1} {$i <= $parameters(0) && $i <= 4} {incr i 1} {
One-Par $parameters($i,0) parameters($i,1) $frame.$number.fr $i
}

### eventuali pulsanti di scrolling ###
#######################################

if {$parameters(0) > 4} {Scroll $frame $number Nextpar Prevpar}


### pack dell' area ###
#######################

 # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.title {top frame center pady 5} \
    $frame.$number.fr {top frame n pady 10}

  # pack widget $frame
  pack append $frame \
    $frame.$number {left frame nw padx 29}

return $error

}


# Procedure: One-Par
proc One-Par {label var frame number} {
##########
# Procedure: One-Par
# Description: build the single row of widget parameters
# Arguments: label - the title of listbox
#            var - the value displaied
#            frame - the frame where to put the widget
#            number - the number of widget (if more widget in same frame)
# Return: none
# Sideeffects: none
##########

catch {destroy $frame.$number}

  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

  # build widget $frame.$number.label
  label $frame.$number.label \
    -anchor {w} \
    -relief {ridge} \
    -text $label \
    -width {16}

  # build widget $frame.$number.val
  label $frame.$number.val \
    -anchor {e} \
    -relief {ridge} \
    -textvariable $var \
    -width {12}

  # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.label {left frame w} \
    $frame.$number.val {left frame w}

 # pack widget $frame
  pack append $frame \
    $frame.$number {top frame center}

}

  
 # Procedure: Nextpar
proc  Nextpar {frame number} {
##########
# Procedure:  Nextpar
# Description: Redisplay windows for parameters
# Arguments: frame - the frame where is the widget
#            number - the widget id
# Return: none
# Sideeffects: none
##########

global parameters

### aggiorna il valore di inizio display params ###
###################################################
set parameters(start) [expr $parameters(start) + 4]

if {[expr $parameters(start) + 4] > $parameters(0)} {
set parameters(start) [expr $parameters(0) - 4]} 

### redisplay global report ###
###############################

for {set i 1} {$i <= 4} {incr i 1} {
 
$frame.$number.fr.$i.label config -textvariable parameters([expr $i+$parameters(start)],0)
$frame.$number.fr.$i.val config -textvariable parameters([expr $i+$parameters(start)],1)

}

### aggiorna stato pulsanti di scorrimento ###
##############################################

if {$parameters(start) >= [expr $parameters(0) - 4] } \
 {$frame.$number.scroll.next config -state disabled} \
 {$frame.$number.scroll.next config -state normal}
 
$frame.$number.scroll.prev config -state normal

}


 # Procedure: Prevpar
proc  Prevpar {frame number} {
##########
# Procedure:  Prevpar
# Description: Redisplay windows for parameters
# Arguments: frame - the frame where is the widget
#            number - the widget id
# Return: none
# Sideeffects: none
##########

global parameters

### aggiorna il valore di inizio display params ###
###################################################

if {[expr $parameters(start) - 4] < 0} {
set parameters(start) 0} {
set parameters(start) [expr $parameters(start) - 4]}



### redisplay global report ###
###############################

for {set i 1} {$i <= 4} {incr i 1} {
 
$frame.$number.fr.$i.label config -textvariable parameters([expr $i+$parameters(start)],0)
$frame.$number.fr.$i.val config -textvariable parameters([expr $i+$parameters(start)],1)

}

### aggiorna stato pulsanti di scorrimento ###
##############################################

if {$parameters(start) <= 0} \
 {$frame.$number.scroll.prev config -state disabled} \
 {$frame.$number.scroll.prev config -state normal}
 
$frame.$number.scroll.next config -state normal

}
