# Procedure: Glb-Rep
proc  Glb-Rep {title frame number pack} {
##########
# Procedure:  Glb-Rep
# Description: Show the global parameters window (only for supervisor);
# Arguments: title - the title of widget
#            frame - the frame where to put the widget
#            number - the id of widget
#            pack - the pack side
# Return: none
# Sideeffects: none
##########

global totnode
global label


catch {destroy $frame.$number}

### creazione area di display master report ###
###############################################

  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

### dimensionatori ###

  # build widget $frame.$number.dummyv
  frame $frame.$number.dummyv \
    -borderwidth {2} \
    -geometry {1x230}

  # build widget $frame.$number.dummyh
  frame $frame.$number.dummyh \
    -borderwidth {2} \
    -geometry {300x1}

### titolo widget ###

  # build widget $frame.$number.title
  frame $frame.$number.title \
    -borderwidth {2}

  # build widget $frame.$number.title.lab
  label $frame.$number.title.lab \
    -text $title

  # build widget $frame.$number.title.num
  label $frame.$number.title.num \
    -text {} \
    -textvariable totnode \
    -width {10}

  # pack widget $frame.$number.title
  pack append $frame.$number.title \
    $frame.$number.title.lab {left frame center} \
    $frame.$number.title.num {left frame center}

# pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.dummyv {left frame center} \
    $frame.$number.dummyh {top frame center} \
    $frame.$number.title {top frame n pady 10}


### prima riga di display nodi ###
##################################

 # build widget $frame.$number.row1
  frame $frame.$number.row1 \
    -borderwidth {2}

### frame con le labels ###

GRTitles {NODES} $label(generation) $label(assignement) $frame.$number.row1 {10}

### ciclo for per la creazione di 1 frame per ogni nodo ###
###########################################################

 for {set i 0}  {$i <= [expr $totnode - 1] && $i <= 3} {incr i 1} {
  GRFrame $frame.$number.row1 $i}

### pack prima riga ###
#######################

# pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.row1 {top frame w pady 5}


### eventuale seconda riga di display ###
#########################################

if {$totnode > 4} {
 
  # build widget $frame.$number.row2
  frame $frame.$number.row2 \
    -borderwidth {2}

### frame con le labels ###

GRTitles {NODES} $label(generation) $label(assignement) $frame.$number.row2 {10}

### ciclo for per la creazione di 1 frame per ogni nodo ###
###########################################################

 for {set i 4}  {$i <= [expr $totnode - 1] && $i <= 7} {incr i 1} {
   GRFrame $frame.$number.row2 $i}

### pack seconda riga ###
#######################

# pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.row2 {top frame w pady 5}

}

### se i nodi sono > 8 call dei pulsanti di scroll ###
######################################################

if {$totnode > 8} {Scroll $frame $number}

### pack della finestra di global report ###
############################################

 # pack widget $frame
  pack $frame.$number -side $pack -anchor w

}

# Procedure: GRTitles
proc GRTitles {label0 label1 label2 frame number} {
##########
# Procedure: GRTitles
# Description: build the title left frame for global report
# Arguments: label i - the labels of widget
#            var - the value displaied
#            frame - the frame where to put the widget
#            number - the number of widget (if more widget in same frame)
# Return: none
# Sideeffects: none
##########

catch {destroy $frame.$number}

# build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

  # build widget $frame.$number.lab0
  label $frame.$number.lab0 \
    -anchor {w} \
    -text $label0 \
    -width {10}

  # build widget $frame.$number.lab1
  label $frame.$number.lab1 \
    -anchor {w} \
    -text $label1 \
    -width {10}

  # build widget $frame.$number.lab2
  label $frame.$number.lab2 \
    -anchor {w} \
    -text $label2 \
    -width {10}

  # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.lab0 {top frame n pady 5} \
    $frame.$number.lab1 {top frame center} \
    $frame.$number.lab2 {top frame center}
 
  # pack widget $frame
  pack append $frame \
    $frame.$number {left frame w padx 10}

}

# Procedure: GRFrame
proc GRFrame {frame number} {
##########
# Procedure: GRFrame
# Description: build the single frame for global report
# Arguments:
#            frame - the frame where to put the widget
#            number - the id of widget (if more widget in same frame)
# Return: none
# Sideeffects: none
##########
catch {destroy $frame.$number}

  # build widget $frame.$number
  frame $frame.$number \
   -borderwidth {2}

 # build widget $frame.$number.label0
  label $frame.$number.label0 \
    -relief {ridge} \
    -text {} \
    -textvariable node($number,0) \
    -width {8}

  # build widget $frame.$number.label1
  label $frame.$number.label1 \
    -relief {ridge} \
    -text {} \
    -textvariable node($number,1) \
    -width {8}

  # build widget $frame.$number.label2
  label $frame.$number.label2 \
    -relief {ridge} \
    -text {} \
    -textvariable node($number,2) \
    -width {8}

  # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.label0 {top frame n pady 5} \
    $frame.$number.label1 {top frame center} \
    $frame.$number.label2 {top frame center}


 # pack widget $frame
  pack append $frame \
    $frame.$number {left frame center} 

}


# Procedure: Scroll
proc  Scroll {frame number {next {Next}} {prev {Prev}}} {
##########
# Procedure:  Scroll
# Description: Show the scroll buttons for global report (only for supervisor)
# Arguments: frame - the frame where to put the widget
#            number - the widget id
#            next - the proc to exec on next (call by report or parameters)
#            prev - the proc to exec on prev (call by report or parameters)
# Return: none
# Sideeffects: none
##########

### prepara comandi next prev ###

lappend pv $prev $frame $number
lappend nx $next $frame $number

### crea area pulsanti di scorrimento di global report ###
##########################################################

catch {destroy $frame.$number.scroll}

 # build widget $frame.$number.scroll
  frame $frame.$number.scroll \
    -borderwidth {2}

  # build widget $frame.$number.scroll.prev
  button $frame.$number.scroll.prev \
    -text {<- Previous} \
    -width {12} \
    -state {disabled} \
    -command $pv

  # build widget $frame.$number.scroll.next
  button $frame.$number.scroll.next \
    -text {Next ->} \
    -width {12} \
    -command $nx

  # pack widget $frame.$number.scroll
  pack append $frame.$number.scroll \
    $frame.$number.scroll.prev {left frame w padx 20} \
    $frame.$number.scroll.next {left frame center}

 # pack widget $frame.$number
  pack append $frame.$number \
  $frame.$number.scroll {bottom frame center}
}


 # Procedure: Next
proc  Next {frame number} {
##########
# Procedure:  Next
# Description: Redisplay windows for global report (only for supervisor)
# Arguments: frame - the frame where is the widget
#            number - the widget id
# Return: none
# Sideeffects: none
##########

global totnode
global report
global node

### aggiorna il valore di inizio display nodi ###
#################################################
set report(start) [expr $report(start) + 8]

if {[expr $report(start) + 8] > [expr $totnode - 1]} {
set report(start) [expr $totnode - 8]} 

### redisplay global report ###
###############################

for {set i 0} {$i <= 3} {incr i 1} {
 
$frame.$number.row1.$i.label0 config -textvariable node([expr $i+$report(start)],0)
$frame.$number.row1.$i.label1 config -textvariable node([expr $i+$report(start)],1)
$frame.$number.row1.$i.label2 config -textvariable node([expr $i+$report(start)],2)

}

for {set i 4} {$i <= 7} {incr i 1} {
 
$frame.$number.row2.$i.label0 config -textvariable node([expr $i+$report(start)],0)
$frame.$number.row2.$i.label1 config -textvariable node([expr $i+$report(start)],1)
$frame.$number.row2.$i.label2 config -textvariable node([expr $i+$report(start)],2)

}

### aggiorna stato pulsanti di scorrimento ###
##############################################

if {$report(start) >= [expr $totnode - 8] } \
 {$frame.$number.scroll.next config -state disabled} \
 {$frame.$number.scroll.next config -state normal}
 
$frame.$number.scroll.prev config -state normal

}


# Procedure: Prev
proc  Prev {frame number} {
##########
# Procedure:  Prev
# Description: Redisplay windows for global report (only for supervisor)
# Arguments: frame - the frame where is the widget
#            number - the widget id
# Return: none
# Sideeffects: none
##########

global totnode
global report
global node

### aggiorna il valore di inizio display nodi ###
#################################################

if {[expr $report(start) - 8] < 0} {
set report(start) 0} {
set report(start) [expr $report(start) - 8]}


### redisplay global report ###
###############################

for {set i 0} {$i <= 3} {incr i 1} {

$frame.$number.row1.$i.label0 config -textvariable node([expr $i+$report(start)],0)
$frame.$number.row1.$i.label1 config -textvariable node([expr $i+$report(start)],1)
$frame.$number.row1.$i.label2 config -textvariable node([expr $i+$report(start)],2)

}

for {set i 4} {$i <= 7} {incr i 1} {
 
$frame.$number.row2.$i.label0 config -textvariable node([expr $i+$report(start)],0)
$frame.$number.row2.$i.label1 config -textvariable node([expr $i+$report(start)],1)
$frame.$number.row2.$i.label2 config -textvariable node([expr $i+$report(start)],2)

}

### aggiorna stato pulsanti di scorrimento ###
##############################################

if {$report(start) <= 0} \
 {$frame.$number.scroll.prev config -state disabled} \
 {$frame.$number.scroll.prev config -state normal}
 
$frame.$number.scroll.next config -state normal

}
