# Procedure: Set-Net
proc Set-Net {frame number} {
##########
# Procedure: Set-Net
# Description: Show the Network configurating window
# Arguments: frame - the frame where to put the widget
#            number - the widget id
# Return: none
# Sideeffects: none
##########

global label
global dim
global host
global nhost
global parnet
global echostate

### preparo messaggio di stato ###
##################################

set echostate $label(setnet)


catch {destroy $frame.$number}

### crea area di NETWORK setting ###
####################################

  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

### area di VIRTUAL parameters del net ###
##########################################

  # build widget $frame.$number.virtual
  frame $frame.$number.virtual \
    -borderwidth {2} \
    -relief {sunken}

### label area ###

  # build widget $frame.$number.virtual.label
  label $frame.$number.virtual.label \
    -text $label(virtual)
 
  # pack widget $frame.$number.virtual
  pack append $frame.$number.virtual \
    $frame.$number.virtual.label {top frame n padx 40 pady 120}
  
### crea tre entry con le rispettive label ###
##############################################

IEntry $label(nodes) {parnet(nodes)} $dim(int) $frame.$number.virtual {1} {0} {2} {left} $dim(netpady) {w}

MBEntry $label(topology) $dim(topol) $frame.$number.virtual {2} {left} $dim(netpady) {w}

if {$parnet(topology) == {grid}} {
  IEntry $label(dimension) {parnet(dimension)} $dim(int) $frame.$number.virtual    {3} {0} {2} {left} $dim(netpady) {w} {2} {2}} {
  Dummy {30} {30} $frame.$number.virtual {3} $dim(netpady)}

### pack dell'area di VIRTUAL parameters ###
############################################

  # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.virtual {left frame center padx 70} 


### area di PVM distribution ###
################################

  # build widget $frame.$number.pvm
  frame $frame.$number.pvm \
    -borderwidth {2} \
    -relief {sunken}

### bind sul frame usato per aggiornare il valore della listbox ###

bind $frame.$number.pvm <Enter> {focus none}

### label area ###

  # build widget $frame.$number.pvm.label
  label $frame.$number.pvm.label \
    -text $label(pvm)

  # pack widget $frame.$number.pvm
  pack append $frame.$number.pvm \
    $frame.$number.pvm.label {top frame n pady 30}

### creo struttura formata da listbox e entry per update ###
############################################################

Lbox $label(distribution) $frame.$number.pvm {1}

### inizializzo la host list load ###
 Up-List $frame.$number.pvm

catch {IEntry  $host([$frame.$number.pvm.1.fr.host curselection],1) host([$frame.$number.pvm.1.fr.host curselection],2) $dim(int) $frame.$number.pvm {2} {1} {2}}

### pack della area di DISTRIBUTION ###
#######################################

  # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.pvm {right frame center padx 34 pady 20}

### pack area di SET NETWORK ###
################################

  # pack widget $frame
  pack append $frame \
    $frame.$number {left frame center pady 42}

}


# Procedure: MBEntry
proc MBEntry {label dim frame number {pack top} {py 10} {anc center}} {
##########
# Procedure: MBEntry
# Description: build the menubutton entry widget
# Arguments: label - the entry label
#            dim - the width of the entry
#            frame - the frame where to put the widget
#            number - the number of widget (if more widget in same frame)
#            pack - how to pack label and frame
#            anc - the pack anchor
#            py - the pady of widget
# Return: none
# Sideeffects: none
##########
global color
global parnet

### crea struttura  menubutton, entry  ###
##########################################
 
catch {destroy $frame.$number}
 
  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

  # build widget $frame.$number.mb
  menubutton $frame.$number.mb \
    -menu $frame.$number.mb.m \
    -text $label \
    -activeforeground $color(black) \
    -background $color(base)

### preparo i comandi ###

lappend rdt {ReDim} $frame {total-connection} 
lappend rdh {ReDim} $frame {hypercube}
lappend rdg {ReDim} $frame {grid}

  # build widget $frame.$number.mb.m
  menu $frame.$number.mb.m
  $frame.$number.mb.m add command \
    -command $rdt \
    -label {total-connection}

  $frame.$number.mb.m add command \
    -command $rdh \
    -label {hypercube}

  $frame.$number.mb.m add command \
    -command $rdg \
    -label {grid}

  # build widget $frame.$number.label
  label $frame.$number.label \
    -background $color(entry) \
    -font {-Adobe-Helvetica-Medium-R-Normal--*-120-*} \
    -relief {sunken} \
    -textvariable {parnet(topology)} \
    -anchor {w} \
    -width {15}

## pack della widget ###
########################
  # pack widget $frame.$number
    pack $frame.$number.mb -side $pack 
    pack $frame.$number.label -side $pack -padx 5

 
  # pack widget $frame
    pack $frame.$number -side top -pady $py -anchor $anc
  
 }



# Procedure: Lbox
proc Lbox {label frame number} {
##########
# Procedure: Lbox
# Description: build a listbox widget
# Arguments: label - the title of listbox
#            frame - the frame where to put the widget
#            number - the number of widget (if more widget in same frame)
# Return: none
# Sideeffects: none
##########
global color

### preparo commandi associati allo scrolling ###
#################################################

lappend yscroll $frame.$number.fr.scrollbar {set}
lappend scroll $frame.$number.fr.host {yview}

### crea struttura  label , listbox  ###
########################################
 
catch {destroy $frame.$number}

  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

  # build widget $frame.$number.label
  label $frame.$number.label \
    -text $label

  # build widget $frame.$number.fr
  frame $frame.$number.fr \
    -borderwidth {2} 

  # build widget $frame.$number.fr.scrollbar
  scrollbar $frame.$number.fr.scrollbar \
    -command $scroll \
    -activeforeground $color(pulsanti)

  # build widget $frame.$number.fr.host
  listbox $frame.$number.fr.host \
    -geometry {30x10} \
    -relief {sunken} \
    -yscrollcommand $yscroll

## pack della widget ###
########################

  # pack widget $frame.$number.fr
  pack append $frame.$number.fr \
    $frame.$number.fr.host {left frame center} \
    $frame.$number.fr.scrollbar {left frame center filly}

 # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.label {top frame center} \
    $frame.$number.fr {top frame center padx 30}

 # pack widget $frame
    pack $frame.$number -side top -padx 50 -pady 10

### solo selezione singola (function built-in di tk) ###

tk_listboxSingleSelect $frame.$number.fr.host

### bind per update della label dell' entry in basso ###

lappend bind {New-Sel} $frame $number 

bind Listbox <Button-1> +$bind

}


# Procedure: ReDim
proc ReDim {frame val} {
##########
# Procedure: ReDim
# Description: destroy or build the dimension entry
# Arguments: frame - the frame where to put the widget
#            val - the new value for topology
# Return: none
# Sideeffects: none
##########

global parnet
global label
global dim
global checker
global modifica

set modifica(2) 1
set parnet(topology) $val
set checker(dim) 0

if {$val  == {grid}} {
IEntry $label(dimension) {parnet(dimension)} $dim(int) $frame {3} {0} {2} {left} $dim(netpady) {w} {2} {2}} {
Dummy {30} {30} $frame {3} $dim(netpady)}
}


# Procedure: Up-List 
proc Up-List {frame} {
##########
# Procedure: Up-List
# Description: Init the Host load distribution list
# Arguments: frame - the frame where is the listbox
# Return: none
# Sideeffects: none
##########

global host
global nhost

### salvo la current selection ###
##################################

set sel [$frame.1.fr.host curselection]

### cancello la listbox ###

$frame.1.fr.host delete 0 end

### inserisco i valori ###

for {set i 0} {$i < $nhost} {incr i 1} {
   set hostvar {}
   lappend hostvar $host($i,1) $host($i,2)
   $frame.1.fr.host insert end $hostvar
 }

### posiziono la selezione ###

if {[catch {$frame.1.fr.host select adjust $sel}]} {$frame.1.fr.host select adjust 0}
}


# Procedure: New-Sel
proc  New-Sel {frame number} {
##########
# Procedure: New-Sel
# Description: update entry sotto la listbox
# Arguments: frame - the frame where to put the widget
#            number - the number of widget (if more widget in same frame)
# Return: none
# Sideeffects: none
##########

global host
global dim

### update entry sotto listbox ###
catch {
IEntry $host([$frame.$number.fr.host curselection],1) host([$frame.$number.fr.host curselection],2) $dim(int) $frame {2} {1}
      }
}

