# Procedure: Set-Vars
proc Set-Vars {frame number} {
##########
# Procedure: Set-Vars
# Description: Show the configuration parameters window
# Arguments: frame the frame where to put the widget
#            number the widget id
# Return: none
# Sideeffects: none
##########

global label
global dim
global parconf
global echostate

### preparo messaggio di stato ###
##################################

set echostate $label(setvar)

### distruggo la finestra precedente e aggiorno stato pulsanti ###
##################################################################

 catch {destroy $frame.$number}

### crea frame globale per il set vars ###
##########################################

  # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}



### area di GA parametri ###
############################

  # build widget $frame.$number.ga
  frame $frame.$number.ga \
    -borderwidth {2} \
    -relief {sunken}

  # build widget $frame.$number.ga.label
  label $frame.$number.ga.label \
    -text $label(ga)



### area di GA - goal  ###
##########################

   # build widget $frame.$number.ga.goal
  frame $frame.$number.ga.goal \
    -borderwidth {2}

### crea la entry con le rispettiva label  ###
##############################################

FEntry $label(goalcl) {parconf(goalcl)} $dim(goal) $frame.$number.ga.goal {1}



### area di GA - popolazione ###
################################

  # build widget $frame.$number.ga.pop
  frame $frame.$number.ga.pop \
    -borderwidth {2}

### crea tre entry con le rispettive label ###
##############################################

IEntry $label(pop_size) {parconf(pop_size)} $dim(int) $frame.$number.ga.pop {1}

FEntry $label(percentage) {parconf(percentage)} $dim(fl) $frame.$number.ga.pop {2}

IEntry $label(global_persistence) {parconf(global_persistence)} $dim(int) $frame.$number.ga.pop {3}




### area di GA - generazioni ###
################################

   # build widget $frame.$number.ga.gen
  frame $frame.$number.ga.gen \
    -borderwidth {2}

### crea tre entry con le rispettive label ###
##############################################

IEntry $label(epochs) {parconf(epochs)} $dim(int) $frame.$number.ga.gen {1}

FEntry $label(generation_gap) {parconf(generation_gap)} $dim(fl) $frame.$number.ga.gen {2}

IEntry $label(gens_for_epoch) {parconf(gens_for_epoch)} $dim(int) $frame.$number.ga.gen {3}




### area di GA - crossover   ###
################################

   # build widget $frame.$number.ga.cross
  frame $frame.$number.ga.cross \
    -borderwidth {2} 

### crea tre entry con le rispettive label ###
##############################################

FEntry $label(crossover_rate) {parconf(crossover_rate)} $dim(fl) $frame.$number.ga.cross {1}

FEntry $label(mutation_rate) {parconf(mutation_rate)} $dim(fl) $frame.$number.ga.cross {2}

FEntry $label(complement_rate) {parconf(complement_rate)} $dim(fl) $frame.$number.ga.cross {3}



### pack dell'area di GA ###
############################

  # pack widget $frame.$number.ga
  pack append $frame.$number.ga \
    $frame.$number.ga.label {top frame center} \
    $frame.$number.ga.goal {top frame center pady 20} \
    $frame.$number.ga.pop {left frame center} \
    $frame.$number.ga.gen {left frame center} \
    $frame.$number.ga.cross {left frame center pady 30}




### area di MIGRATION parameters ###
####################################

  # build widget $frame.$number.mig
  frame $frame.$number.mig \
    -borderwidth {2} \
    -relief {sunken}

  # build widget $frame.$number.mig.label
  label $frame.$number.mig.label \
    -text $label(migration)

  # build widget $frame.$number.mig.label1
  label $frame.$number.mig.label1 \
    -text $label(par)

  # build widget $frame.$number.mig.fr
  frame $frame.$number.mig.fr \
    -borderwidth {2}


### crea tre entry con le rispettive label ###
##############################################

FEntry $label(migration_rate) {parconf(migration_rate)} $dim(fl) $frame.$number.mig.fr {1}

FEntry $label(foreign_mating_rate) {parconf(foreign_mating_rate)} $dim(fl) $frame.$number.mig.fr {2}

RBEntry $label(open_to_foreign) {parconf(open_to_foreign)} $frame.$number.mig.fr {3}


### pack dell'area di MIGRATION ###
###################################

  # pack widget $frame.$number.mig
  pack append $frame.$number.mig \
    $frame.$number.mig.label {top frame n} \
    $frame.$number.mig.label1 {top frame n pady 74} \
    $frame.$number.mig.fr {top frame center pady 30}




### area di REPORT parameters ###
#################################

  # build widget $frame.$number.rep
  frame $frame.$number.rep \
    -borderwidth {2} \
    -relief {sunken}

  # build widget $frame.$number.rep.label
  label $frame.$number.rep.label \
    -text $label(report)

  # build widget $frame.$number.rep.label1
  label $frame.$number.rep.label1 \
    -text $label(par)

  # build widget $frame.$number.rep.fr
  frame $frame.$number.rep.fr \
    -borderwidth {2}



### crea due entry con le rispettive label ###
##############################################

IEntry $label(quantum) {parconf(quantum)} $dim(int) $frame.$number.rep.fr {1}

IEntry $label(node_persistence) {parconf(node_persistence)} $dim(int) $frame.$number.rep.fr {2}


### pack dell'area di REPORT    ###
###################################
 
  # pack widget $frame.$number.rep
  pack append $frame.$number.rep \
    $frame.$number.rep.label {top frame n} \
    $frame.$number.rep.label1 {top frame n padx 15 pady 72} \
    $frame.$number.rep.fr {top frame center pady 104}





### area di SOLUTION parameters ###
###################################

  # build widget $frame.$number.sol
  frame $frame.$number.sol \
    -borderwidth {2} \
    -relief {sunken}

  # build widget $frame.$number.sol.label
  label $frame.$number.sol.label \
    -text $label(solution)

  # build widget $frame.$number.sol.label1
  label $frame.$number.sol.label1 \
    -text $label(par)

  # build widget $frame.$number.sol.fr
  frame $frame.$number.sol.fr \
    -borderwidth {2}


### crea tre entry con le rispettive label ###
##############################################

FEntry $label(decision_limit) {parconf(decision_limit)} $dim(fl) $frame.$number.sol.fr {1}

IEntry $label(change_ratio) {parconf(change_ratio)} $dim(int) $frame.$number.sol.fr {2}

FEntry $label(overlap_ratio) {parconf(overlap_ratio)} $dim(fl) $frame.$number.sol.fr {3}


### pack dell'area di SOLUTION ###
##################################

  # pack widget $frame.$number.sol
  pack append $frame.$number.sol \
    $frame.$number.sol.label {top frame n} \
    $frame.$number.sol.label1 {top frame n pady 44} \
    $frame.$number.sol.fr {top frame center pady 60}



### pack dell'area di set vars ###
##################################

   # pack widget $frame.$number
  pack append $frame.$number \
    $frame.$number.ga {left frame center} \
    $frame.$number.mig {left frame center} \
    $frame.$number.rep {left frame center} \
    $frame.$number.sol {left frame center pady 36}

  # pack widget $frame
  pack append $frame \
    $frame.$number {left frame center padx 11 pady 6}
 
}


