# Procedure: Add
proc Add {term modify {step 1}} {
##########
# Procedure: Add
# Description: Add 1
# Arguments: term - the term
#            step - the Add step
# Return: none
# Sideeffects: modify the global parameter value
##########
global modifica

upvar $term term1

set modifica($modify) 1
set term1 [expr $term1 + $step]
}


# Procedure: Sub
proc Sub {term modify {step 1} {inflimit 0}} {
##########
# Procedure: Sub
# Description: Substract 1
# Arguments: term - the term
#            step - the Sub step
#            inflimit - the inf limit of sub
# Return: none
# Sideeffects: modify the global parameter value
##########
global modifica

upvar $term term1

set modfica($modify) 1
if {$term1 > $inflimit} {set term1 [expr $term1 - $step]}

}


# Procedure: IsaInteger
proc IsaInteger {var} {
##########
# Procedure: IsaInteger
# Description: check if var is integer
# Arguments: var - the update var 
# Return: none
# Sideeffects: none
##########

if {[IsaNumber $var]} {
 if {[expr $var - [expr int($var)]] != 0} {return 0} {return 1}} {return 0}
}

# Procedure: IsaNumber
proc IsaNumber {var} {
##########
# Procedure: IsaNumber
# Description: check if var is a number
# Arguments: var - the update var 
# Return: none
# Sideeffects: none
##########

if {[catch {set temp [expr $var / 2]}]} {return 0} {return 1}
}


# Procedure: Init-Nodes
proc  Init-Nodes {} {
##########
# Procedure:  Init-Nodes
# Description: Init the array of nodes
# Arguments: none
# Return: none
# Sideeffects: none
##########

global totnode
global node

for {set i 0} {$i <= [expr $totnode - 1]} {incr i 1} {
set nf {}
append nf "NGA" $i
set node($i,0) $nf
}
}

# Procedure: ClearText
proc ClearText { textWidget} {
##########
# Procedure: ClearText
# Description: clear text widget
# Arguments: textWidget - the widget to clear
# Returns: none
# Sideeffects: the text widget is cleared
##########

  set status [lindex [$textWidget config -state] 4]
  $textWidget config -state normal
  $textWidget delete 1.0 end
  $textWidget config -state $status
}

# Procedure: FileInText
proc FileInText { textWidget {fileName ""}} {
##########
# Procedure: FileInText
# Description: fill a text with the contents of the file
# Arguments: textWidget - the widget
#            {fileName} - filename to read
# Returns: none
# Sideeffects: the text widget is filled
##########

  # check file existance
  if {"$fileName" == ""} {
    puts stderr "no filename specified"
    return
  }
  set fileid [open $fileName r]
    
    
  set textValue [read $fileid]
  $textWidget insert end "$textValue"
  #close $fileInFile
  close $fileid
}

