# Procedure: YesNoBox
proc YesNoBox {} {
##########
# Procedure: YesNoBox
# Description: show yesno box
# Arguments: none
# Returns: none
# Sideeffects: none
##########

global fonts
global message
global ynb

 # build widget .yesNoBox
   toplevel .yesNoBox 

  # Window manager configurations
  global tkVersion
  wm positionfrom .yesNoBox ""
  wm sizefrom .yesNoBox ""
  wm maxsize .yesNoBox 1000 1000
  wm minsize .yesNoBox 100 100
  wm geometry .yesNoBox 250x150
  wm title .yesNoBox {Regal 3.1}


  # build widget .yesNoBox.message1
  message .yesNoBox.message1 \
    -anchor {center} \
    -justify {center} \
    -padx {5} \
    -pady {2} \
    -relief {raised} \
    -text $message(quit) \
    -width {340}

catch {.yesNoBox.message1 config -font $fonts(intr)}

  # build widget .yesNoBox.frame1
  frame .yesNoBox.frame1 \
    -relief {raised}

  button .yesNoBox.frame1.button0 \
    -command {set ynb 1;catch {destroy .yesNoBox}} \
    -text {Yes}

catch {.yesNoBox.frame1.button0 config -font $fonts(intr)}

  # build widget .yesNoBox.frame1.button1
  button .yesNoBox.frame1.button1 \
    -command {set ynb 0;catch {destroy .yesNoBox}} \
    -text {No}

catch {.yesNoBox.frame1.button1 config -font $fonts(intr)}

  # pack widget .yesNoBox.frame1
  pack append .yesNoBox.frame1 \
    .yesNoBox.frame1.button0 {left frame center expand fillx} \
    .yesNoBox.frame1.button1 {left frame center expand fillx}

  # pack widget .yesNoBox
  pack append .yesNoBox \
    .yesNoBox.frame1 {bottom frame center fill} \
    .yesNoBox.message1 {top frame center expand fill}

 # wait for the box to be destroyed
    focus .yesNoBox    
    update idletask
    catch {grab .yesNoBox}
    tkwait w .yesNoBox

return $ynb
}

 
# Procedure: IEntry
proc IEntry {label var dim frame number {flag 0} {modify 1} {pack top} {py 10} {anc center} {step 1} {infl 0}} {
##########
# Procedure: IEntry
# Description: build the integer entry widget
# Arguments: label - the entry label
#            var - the var to modify
#            dim - the width of the entry
#            frame - the frame where to put the widget
#            number - the number of widget if more widget in same frame
#            pack - how to pack label and frame
#            py - the pady of widget
#            anc - the pack anchor
#            step - the step of + - buttons
#            infl - the inflimit of - button
#            flag - useful for bindings
#            modify - the modifica array index
# Return: none
# Sideeffects: none
##########
global modifica

### preparo commandi associati ai button ed al bind ###
######################################################

lappend sub {Sub} $var $modify $step $infl  
lappend add {Add} $var $modify $step
lappend bind {Check-Int} $var $label $infl
lappend mod {set} modifica($modify) {1}

### crea struttura   label, button-  entry  button+ ###
#######################################################
 
 catch {destroy $frame.$number}

 # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

  # build widget $frame.$number.label
  label $frame.$number.label \
    -text $label


  # build widget $frame.$number.fr
  frame $frame.$number.fr \
    -borderwidth {2}

  # build widget $frame.$number.fr.-
  button $frame.$number.fr.- \
   -command $sub \
   -text {-}

  # build widget $frame.$number.fr.entry
  entry $frame.$number.fr.entry \
    -relief {sunken} \
    -textvariable $var \
    -width $dim
 
  # build widget $frame.$number.fr.+
  button $frame.$number.fr.+ \
    -command $add \
    -text {+}

### pack della widget ###
#########################

  # pack widget $frame.$number.fr
  pack append $frame.$number.fr \
    $frame.$number.fr.- {left frame center} \
    $frame.$number.fr.entry {left frame center padx 2} \
    $frame.$number.fr.+ {left frame center}

 # pack widget $frame.$number
    pack $frame.$number.label -side $pack  
    pack $frame.$number.fr -side $pack -padx 5

# pack widget $frame
    pack $frame.$number -side top -pady $py -anchor $anc
    
### bind per check valore (associato al bind sui button in global.tcl) ###
##########################################################################

# bindings
bind $frame.$number.fr.entry <FocusOut> $bind
bind $frame.$number.fr.entry <FocusIn> $mod

### bind per button - + usato solo nel caso di NETWORK DISTRIBUTION    ###
##########################################################################

lappend bindUp {Up-List} $frame

if {$flag == 1} {

bind $frame.$number.fr.- <ButtonRelease-1> {tk_butUp %W}
bind $frame.$number.fr.+ <ButtonRelease-1> {tk_butUp %W}
bind $frame.$number.fr.- <ButtonRelease-1> +$bindUp
bind $frame.$number.fr.+ <ButtonRelease-1> +$bindUp

bind $frame.$number.fr.entry <FocusOut> +$bindUp
}
}


# Procedure: FEntry
proc FEntry {label var dim frame number {pack top} {py 10} {anc center}} {
##########
# Procedure: FEntry
# Description: build the float entry widget
# Arguments: label - the entry label
#            var - the var to modify
#            dim - the width of the entry
#            frame - the frame where to put the widget
#            number - the number of widget (if more widget in same frame)
#            pack - how to pack label and frame
#            py - the pady of widget
#            anc - the pack anchor
# Return: none
# Sideeffects: none
##########
global modifica
global color

### preparo commando associato al bind ###
##########################################

lappend bind {Check-Float} $var $label

### crea struttura   label,  entry  ###
#######################################

 catch {destroy $frame.$number}

 # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

 # build widget $frame.$number.label
  label $frame.$number.label \
    -text $label

 # build widget $frame.$number.fr
  frame $frame.$number.fr \
    -borderwidth {2}

  # build widget $frame.$number.fr.entry
  entry $frame.$number.fr.entry \
    -relief {sunken} \
    -textvariable $var \
    -width $dim
 
# build widget $frame.$number.fr.dummy
  button $frame.$number.fr.dummy \
    -text {} \
    -width {0} \
    -relief {flat} \
    -activebackground $color(base) \
    -background $color(base)

### pack della widget ###
#########################

# pack widget $frame.$number.fr
  pack append $frame.$number.fr \
    $frame.$number.fr.entry {left frame center} \
    $frame.$number.fr.dummy {left frame center} 
 
#pack widget $frame.$number
    pack $frame.$number.label -side $pack 
    pack $frame.$number.fr -side $pack -padx 5
 
 # pack widget $frame
    pack $frame.$number -side top -pady $py -anchor $anc

    
### bind per check valore (associato al bind sui button in global.tcl) ###
##########################################################################

if {$label != {goalcl}} {bind $frame.$number.fr.entry <FocusOut> $bind}

bind $frame.$number.fr.entry <FocusIn> {set modifica(1) 1}
}

# Procedure: RBEntry
proc RBEntry {label var frame number {pack top} {py 10} {anc center}} {
##########
# Procedure: RBEntry
# Description: build the radiobutton entry widget
# Arguments: label - the entry label
#            var - the var to modify
#            frame - the frame where to put the widget
#            number - the number of widget (if more widget in same frame)
#            pack - how to pack label and frame
#            py - the pady of widget
#            anc - the pack anchor
# Return: none
# Sideeffects: none
##########
global modifica

### crea struttura   label, radiob0, radiob1  ###
#################################################

 catch {destroy $frame.$number}

 # build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2}

 # build widget $frame.$number.label
  label $frame.$number.label \
    -text $label

# build widget $frame.$number.fr
  frame $frame.$number.fr \
    -borderwidth {2}

  # build widget $frame.$number.fr.rb0
  radiobutton $frame.$number.fr.rb0 \
    -relief {flat} \
    -text {0} \
    -command {set modifica(1) 1} \
    -value {0} \
    -variable $var

  # build widget $frame.$number.fr.rb1
  radiobutton $frame.$number.fr.rb1 \
    -relief {flat} \
    -text {1} \
    -command {set modifica(1) 1} \
    -value {1} \
    -variable $var

### pack della widget ###
#########################

  # pack widget $frame.$number.fr
  pack append $frame.$number.fr \
    $frame.$number.fr.rb0 {left frame center} \
    $frame.$number.fr.rb1 {left frame center}

  #pack widget $frame.$number
    pack $frame.$number.label -side $pack 
    pack $frame.$number.fr -side $pack -padx 5

  # pack widget $frame
    pack $frame.$number -side top -pady $py -anchor $anc   

}



# Procedure: Dummy
proc Dummy {width heigth frame number {py 10} {anc center}} {
##########
# Procedure: Dummy
# Description: build a dummy invisible frame
# Arguments: width - the width of frame
#            heigth - the heigth of frame
#            frame - the frame where to put the widget
#            number - the number of widget (if more widget in same frame)
#            py - the pady of widget
#            anc - the pack anchor
# Return: none
# Sideeffects: none
##########

catch {destroy $frame.$number}

# build widget $frame.$number
  frame $frame.$number \
    -borderwidth {2} \
    -width $width \
    -height $heigth

# pack widget $frame
    pack $frame.$number -side top -pady $py -anchor $anc


}


