# Procedure: Error
proc  Error {head label tail warn} {
##########
# Procedure:  Error
# Description: Show the error window
# Arguments: head - the head message
#            label - the incorrect parameter
#            tail - the correct range value
#            warn - the warning message
# Return: none
# Sideeffects: none
##########
global env

catch {destroy .error}

  # build widget .error
    toplevel .error 

  # Window manager configurations
  global tkVersion
  wm positionfrom .error ""
  wm sizefrom .error ""
  wm geometry .error +50+50
  wm maxsize .error 800 600
  wm minsize .error 10 10
  wm title .error {ERROR MESSAGE}


  # build widget .error.frame
  frame .error.frame \
    -borderwidth {2}

  # build widget .error.frame.fr
  frame .error.frame.fr \
    -borderwidth {2}

  # build widget .error.frame.fr.label
  label .error.frame.fr.label \
    -bitmap @$env(GUI_PATH)/bitmaps/error

  # build widget .error.frame.fr.message
  message .error.frame.fr.message \
    -aspect {1500} \
    -padx {5} \
    -pady {2} \
    -text $head

  # pack widget .error.frame.fr
  pack append .error.frame.fr \
    .error.frame.fr.label {right frame e pady 20} \
    .error.frame.fr.message {left frame w}


  # build widget .error.frame.button
  button .error.frame.button \
    -command {catch {destroy .error}} \
    -text {OK} \
    -width {10}

  # build widget .error.frame.label
  label .error.frame.label \
    -relief {ridge} \
    -text $label \
    -width {25}

  # build widget .error.frame.message1
  message .error.frame.message1 \
    -aspect {1500} \
    -padx {5} \
    -pady {2} \
    -text $tail

  # build widget .error.frame.warning
  message .error.frame.warning \
    -aspect {1500} \
    -padx {5} \
    -pady {2} \
    -text $warn

  # pack widget .error.frame
  pack append .error.frame \
    .error.frame.fr {top frame center fillx} \
    .error.frame.label {top frame center pady 20} \
    .error.frame.message1 {top frame center pady 20 fillx} \
    .error.frame.button {bottom frame center pady 5} \
    .error.frame.warning {bottom frame center pady 5}

  # pack widget .error
  pack append .error \
    .error.frame {top frame center expand fill}

focus .error
catch {grab .error}
tkwait window .error
}


# Procedure Winhelp
proc Winhelp {title label} {
##########
# Procedure: Winhelp
# Description: Shows a help window
# Arguments: the title of the help window, the label of the help window
# Return: none
# Sideeffects: none
##########
  
  global widget
  global color

  catch {destroy .help}
 
  # build widget .help
  toplevel .help 

  # Window manager configurations
  global tkVersion
  wm positionfrom .help ""
  wm sizefrom .help ""
  wm maxsize .help 1000 1000
  wm minsize .help 10 10
  wm title .help $title


  # build widget .help.frame
  frame .help.frame \
    -background $color(entry) \
    -borderwidth {2} \
    -relief {sunken}

  # build widget .help.frame.scrollbar
  scrollbar .help.frame.scrollbar \
    -activeforeground $color(pulsanti) \
    -command {.help.frame.text yview} \
    -relief {groove}

  # build widget .help.frame.text
  text .help.frame.text \
    -background $color(entry) \
    -relief {sunken} \
    -wrap {word} \
    -yscrollcommand {.help.frame.scrollbar set}

  # pack widget .help.frame
  pack append .help.frame \
    .help.frame.text {left frame center padx 10} \
    .help.frame.scrollbar {right frame center filly}

  # build widget .help.label
  label .help.label \
    -text {HELP}

  # build widget .help.button_close
  button .help.button_close \
    -command {destroy .help} \
    -text {CLOSE} \
    -width {17}

  # pack widget .help
  pack append .help \
    .help.label {top frame center} \
    .help.frame {top frame center} \
    .help.button_close {top frame center pady 5}

  

}

# Procedure Winwar
proc Winwar {mess number} {
##########
# Procedure: Winwar
# Description: Shows a warning window
# Arguments: The kind of warning to be displayed in the window, the path name 
# for the warning window
# Return: none
# Sideeffects: none
##########
 
global env
global modifica


  if {$mess == "var"} then {set text "You haven't saved variables setting.
Do you want to do it now?";set cmd "Save-var1;destroy .$number";set cmd1 "set modifica(1) 0;destroy .$number"}

  if {$mess == "net"} then {set text "You haven't saved network setting.
Do you want to do it now?";set cmd "Save-net1;destroy .$number";set cmd1 "set modifica(2) 0;destroy .$number"}

  # build widget .$number

  toplevel .$number 
  
  # Window manager configurations
  global tkVersion
  wm positionfrom .$number ""
  wm sizefrom .$number user
  wm geometry .$number 359x238
  wm maxsize .$number 359 238
  wm minsize .$number 359 238
  wm title .$number {Regal 3.1: WARNING}

  # build widget .$number.frame1
  frame .$number.frame1 \
    -borderwidth {2} \
    -relief {ridge}

  # build widget .$number.frame1.but_save
  button .$number.frame1.but_save \
    -text {Save} \
    -width {8} \
    -command $cmd

  # build widget .$number.frame1.but_dsave
  button .$number.frame1.but_dsave \
    -text {Don't Save} \
    -width {13} \
    -command $cmd1

  # pack widget .$number.frame1
  pack append .$number.frame1 \
    .$number.frame1.but_save {left frame center padx 112 pady 15} \
    .$number.frame1.but_dsave {right frame center padx 112 pady 15}
  # build widget .$number.message2
  message .$number.message2 \
    -aspect {1500} \
    -justify {center} \
    -padx {5} \
    -pady {2} \
    -text $text

  # build widget .$number.label5
  label .$number.label5 \
    -bitmap @$env(GUI_PATH)/bitmaps/questhead \
    -text {label5} \
    -width {50}

  # pack widget .$number
  pack append .$number \
    .$number.frame1 {bottom frame center fillx} \
    .$number.message2 {left frame center expand fill} \
    .$number.label5 {right frame center padx 27 filly}


  focus .$number
  catch {grab .$number}
  tkwait window .$number

}


# Procedure: SeeStatus 
proc SeeStatus {} {
##########
# Procedure: SeeStatus
# Description: Show directories selection box for seestatus
# Arguments: none
# Return: none
# Sideeffects: none
##########

global COM_DIR
global see
global regal_pid
global color

set see 1

  toplevel .topstatus 

  # Window manager configurations
  global tkVersion
  wm positionfrom .topstatus ""
  wm sizefrom .topstatus ""
  wm geometry .topstatus 250x250
  wm maxsize .topstatus 800 600
  wm minsize .topstatus 10 10
  wm title .topstatus {Directory Selection Box}


  # build widget .topstatus.frame
  frame .topstatus.frame \
    -borderwidth {2} \
    -relief {raised}

  # build widget .topstatus.frame.label
  label .topstatus.frame.label \
    -text {Select Directory for SeeStatus}

  # build widget .topstatus.frame.listframe
  frame .topstatus.frame.listframe \
    -borderwidth {2} \
    -relief {sunken}

  # build widget .topstatus.frame.listframe.scrollbar
  scrollbar .topstatus.frame.listframe.scrollbar \
    -command {.topstatus.frame.listframe.listbox yview} \
    -activeforeground $color(pulsanti)

  # build widget .topstatus.frame.listframe.listbox
  listbox .topstatus.frame.listframe.listbox \
    -geometry {23x9} \
    -yscrollcommand {.topstatus.frame.listframe.scrollbar set}

  # pack widget .topstatus.frame.listframe
  pack append .topstatus.frame.listframe \
    .topstatus.frame.listframe.listbox {left frame center} \
    .topstatus.frame.listframe.scrollbar {right frame center filly}

  # build widget .topstatus.frame.cancel
  button .topstatus.frame.cancel \
    -text {Cancel} \
    -command {set see 0; catch {destroy .topstatus}} \
    -width {9}

  # build widget .topstatus.frame.ok
  button .topstatus.frame.ok \
    -text {Ok} \
    -command {catch {set ind [.topstatus.frame.listframe.listbox curselection]}
              if {[catch {set COM_DIR [lindex [.topstatus.frame.listframe.listbox get $ind] 0]}] != 0} {set COM_DIR {}}
              if {$COM_DIR != {}} {
              catch {destroy .topstatus}}} \
    -width {9}

  # pack widget .topstatus.frame
  pack append .topstatus.frame \
    .topstatus.frame.label {top frame center pady 19} \
    .topstatus.frame.listframe {top frame center padx 40} \
    .topstatus.frame.cancel {right frame center padx 30 pady 30} \
    .topstatus.frame.ok {right frame center}

  # pack widget .topstatus
  pack append .topstatus \
    .topstatus.frame {top frame center expand fill}

### solo selezione singola (function built-in di tk) ###

tk_listboxSingleSelect .topstatus.frame.listframe.listbox

### cancello la listbox ###

.topstatus.frame.listframe.listbox delete 0 end

### carico listbox ###

set listadir [glob -nocomplain interface*]

foreach i $listadir {
if {[file isdirectory $i] == 1} {
    if {$i != {interface}} {
       .topstatus.frame.listframe.listbox insert end $i
                           } {
       if {$regal_pid != 0} {
            lappend temp $i *running*
            .topstatus.frame.listframe.listbox insert end $temp
                            } {
            .topstatus.frame.listframe.listbox insert end $i
                              }
                              }
                                }
                    }

catch {.topstatus.frame.listframe.listbox select adjust 0}

# wait for the box to be destroyed
    
focus .topstatus    
    update idletask
    catch {grab .topstatus}
    tkwait w .topstatus

return $see
}
