#---------------------------------------------------------------#
# 	Interfaccia Configuratore Regal ver 3			#
#---------------------------------------------------------------#

global  tk_version intfc_dir n_of_version procs_file const_file\
	lang open_w_attr open_w_pred trace_put actual_win first_at \
	ro_attr disabled_pred gdir attributes predicates lprogr_index
	
#---------------------------------------------------------------------------#
# salva subito la dir. di partenza da cui e' stato lanciato il configuratore
set gdir(orig) [pwd]

## I due files seguenti dovrebbero gia' essere chiamati dalla 
## dir (/usr/local/lib/tk) in cui risiedono 
source $tcl_lib_dir/init.tcl
source $tk_lib_dir/tk.tcl

# inizializzazione procedure fornite da Tix
auto_mkindex  $tixdir *.tcl
lappend auto_path $tixdir
tixInit $tixdir

#---------------------------------------------------------------#
set lang English
wm withdraw .
set tk_version "3.6"
#set trace_put 1; ## attiva il tracing con puts ##
set trace_put 0; ## disattiva il tracing con puts ##

# open_w_attr  : indica il numero di finestre attributo aperte
set open_w_attr 0
# open_w_pred  : indica il numero di finestre predicato aperte
set open_w_pred 0

# ro_attr : se = 1 indica che l'apertura di eventuali attributi dev'essere
# 	    fatto in modo read only (poiche' si sta editando un predicato)
set ro_attr 0

# disabled_pred : se = 1 indica che si sta editando gli attributi e quindi
#		  disabilita l'editing predicati (v. proc edit_pred_val)
set disabled_pred 0


#---------------------------------------------------------------#
# Modulo di inizializzazione e caricamento sottomoduli		#
#---------------------------------------------------------------#
set gdir(Int)	$gdir(conf_root)
cd $gdir(Int)

set n_of_version "3.2"
set procs_file procs.int
set const_file consts.int
set msg_file msg.int

#---------------------------------------------------------------#
# Caricamento definizioni procedure di utilita' generale 	#
#---------------------------------------------------------------#
if {$trace_put} {puts "prima di g_procs.tcl"}
source g_procs.tcl

# imposta la classe di widgets Text con i bindings definiti
# nella procedura 'normal_editor' di g_procs.tcl
normal_editor Text
set lprogr_index 10

if {$trace_put} {puts "prima di $procs_file"}
if {![equal_strings OK [safe_source $procs_file $gdir(Int)]]} {exit_wish}

#-----------------------------------------------#
#  Caricamento costanti e var. globali		#
#-----------------------------------------------#
if {$trace_put} {puts "prima di const_file"}
if {![equal_strings OK [safe_source $const_file $gdir(Int)]]} {exit_wish}

if {$trace_put} {puts "prima di msg_file"}
if {![equal_strings OK [safe_source $msg_file $gdir(Int)]]} {exit_wish}

if {$trace_put} {puts "prima di intro.int"}
if {![equal_strings OK [safe_source intro.int $gdir(Int)]]} {exit_wish}

## dirs & files ## 
set file(load_save) 	"lo_sa_conf.int"
incr lprogr_index 10
display_progress_bar $wid(init).l.barframe.bar $lprogr_index
if {![equal_strings OK [safe_source $file(load_save) $gdir(Int)]]} {exit_wish}

update
wm deiconify $wid(main_w)

# attende a distruggere la finestra di messaggio iniziale finche'
# non e' stata visualizzata la main window
tkwait visibility $wid(main_w)
destroy $wid(init)

#----------------------------------------------#
if {$trace_put} {puts "fine proto"}

