#include <stdio.h>
#include "dichat.h"
#include "newfflush.h"

#define fstampa2(ptemp,svat)\
   fprintf(svat,"%s\n%d\n%s\n%d\n%s\n",ptemp->nomeattr,ptemp->flag,\
	   ptemp->corpoattr.comment,ptemp->corpoattr.order,\
	   ptemp->corpoattr.type)

extern void print_help();

static int c;
int maxord=0; /* E' il massimo numero d'ordine tra gli attr. */

/* Testa, coda e preleva sono definite in menuprinc.c */
extern frame *testa; 
extern frame *coda;
extern preleva();

menuattr()
{
   char comando[3];
   int i,ciclo=1;
   char mess;

   for(i=0;i<MAXATTR;i++)
      attrpunt[i]=NULL;
   if(testa==coda)
      caricaattr();
   while(ciclo==1) {
      clearscr();
      printf("\n****** ATTRIBUTES CONFIGURATION ******\n\n");
      printf("______________________________________\n");
      printf(" sh = show attributes \n");
      printf(" ed = edit and insert attributes \n"); 
      printf(" rm = remove attributes \n"); 
      printf(" sv = save attributes \n");
      printf("\n type <help> for help\n");
      printf(" type <q> to exit\n");
      printf("______________________________________\n");
      scanf("%s",comando);
      if (strcmp(comando,"sh")==0)
	 shattr();
      else if (strcmp(comando,"ed")==0)
	 eda();
      else if (strcmp(comando,"rm")==0)
	 rema();
      else if (strcmp(comando,"sv")==0)
	 svattr();
      else if (strcmp(comando,"help")==0)
	 print_help("ATTRhelp");
      else if (strcmp(comando,"q")==0)
        ciclo=0;
   }
}



/* Rimozione di un attributo: pone il flag a 0 */

rema()
{
   frame *ptemp=testa;
   char nome[MAXNOME],mess;
   int ciclo=1;

   while(ciclo==1) {
      clearscr();
      printf("\n*** Remove attributes ***\n");
      printf("__________________________");
      printf("\nDefined attributes :\n");
      stampanomiattr();
      printf("\n__________________________\n");
      printf("\nAttribute name (<q> to quit): ");
      scanf("%s",nome);
      if (strcmp(nome,"q")==0)
         ciclo=0;
      else {
         while (ptemp!=coda && strcmp(ptemp->nomeattr,nome)!=0)
            ptemp++;
         if (ptemp!=coda && ptemp->flag==1)
               ptemp->flag=0;
         else {
            printf("Wrong attribute name : %s",nome);
	    newfflush();
            scanf("%c",&mess);
         }
      }
   }
}


eda()     /* crea e modifica gli attributi */
{
   char messaggio[8],com[MAXCOM],type[MAXTYPE],nome[MAXNOME],lex[MAXTYPE];
   int ord, ciclo=1, ciclo1;
   frame *ptemp=NULL;
   frame *ncontrollattr();

   while(ciclo==1) {
      ciclo1=1;
      clearscr();
      printf("\n*** Edit attributes ***\n");
      printf("________________________");
      printf("\nDefined attributes :\n");
      stampanomiattr();
      printf("\n________________________\n");
      printf("\nAttribute name (<q> to quit): ");
      scanf("%s",nome);
      if (strcmp(nome,"q")==0)
         ciclo=0;
      else while (ciclo1==1) {
         /* se l'attributo e' nuovo: */
	 if(((frame *)ptemp=(frame *)ncontrollattr(nome))==NULL) {
	    strcpy(coda->nomeattr,nome);
            coda->flag=1;
            strcpy(coda->corpoattr.comment," ");
            coda->corpoattr.order=-1;
            strcpy(coda->corpoattr.type," ");
            ptemp=coda++;
         }
	 clearscr();
         stampaattr(ptemp);
	 ptemp->flag=1;
	 printf("field (<q> to quit) : ");
	 newfflush();
	 scanf("%s",messaggio);
	 printf("\n");
	 if (strcmp(messaggio,"q")==0)
            ciclo1=0;
         else {
	    if (strcmp(messaggio,"comment")==0) {
               printf("::");
               newfflush();
               preleva(stdin,com,MAXCOM);
               strcpy(ptemp->corpoattr.comment,com);
            }
            else if(strcmp(messaggio,"order")==0) {
               int order=ptemp->corpoattr.order;
               printf("::");
               scanf("%d",&ord);
               if(order!=-1)
                  attrpunt[order]=NULL;
               if(attrpunt[ord]!=NULL && attrpunt[ord]->flag==1) {
                  printf("\nOrder used by %s  <q>",attrpunt[ord]->nomeattr);
                  newfflush();
                  scanf("%s",messaggio);
               }
               else {
                  if(ord>maxord)
                     maxord=ord;
                  ptemp->corpoattr.order=ord;
                  attrpunt[ord]=ptemp;
               }
            }
            else if(strcmp(messaggio,"type")==0) {
               printf("::");
               newfflush();
               preleva(stdin,type,MAXTYPE);
               controllatipo(type,lex);
               strcat(lex,type);
               strcpy(ptemp->corpoattr.type,lex);
            }
         }
      }
   }
}


/* Controllo se il nome dell'attributo e' gia' stato usato */

frame *ncontrollattr(nome)
   char nome[];
{
   frame *ptemp=testa;
        
   while(ptemp!=coda) {
      if(strcmp(ptemp->nomeattr,nome)==0)
         return((frame *)ptemp);
      ptemp++;
   }
   return(NULL);
}


/* Restituisce il tipo dell'attributo */

controllatipo(type,lex)
   char type[], lex[];
{
   if((strcmp(type,"int")==0)||
      (strcmp(type,"float")==0)||
      (strcmp(type,"short")==0)||
      (strcmp(type,"long")==0))
      strcpy(lex,"num$");
   else
      strcpy(lex,"string$");
}



/* Inizializza l'array attrpunt e le strutture frame dichiarati in dichat.h */

caricaattr()
{
   char nome[MAXNOME], com[MAXCOM], type[MAXTYPE];
   char num[2];
   FILE *svat;

   if((svat=fopen("sysframe/saveat","r"))!=NULL) {
      maxord=0;  
      indatpnt=0;
      c=getc(svat);
      while(c!=EOF) {
         preleva2(nome,svat);
	 strcpy(coda->nomeattr,nome);
	 preleva2(num,svat);
	 coda->flag=atoi(num);
	 preleva2(com,svat);
	 strcpy(coda-> corpoattr.comment,com);
	 preleva2(num,svat);
	 coda-> corpoattr.order=atoi(num);
	 attrpunt[atoi(num)]=coda;
	 if(atoi(num)>maxord)
	    maxord=atoi(num);
	 preleva2(type,svat);
	 strcpy(coda-> corpoattr.type,type);
	 coda++;
	 indatpnt++;
      }
      fclose(svat);
      return(1);
   }
   else
      return(0);
}



/* Carica una stringa qualunque terminata da '\n' */

preleva2(campo,svat)
   char campo[];
   FILE *svat;
{
   int i=0;

   while(c!='\n') {
      campo[i]=c;
      i++;
      c=getc(svat);
   }
   campo[i]='\0';
   c=getc(svat);
}



/* Salva su saveat le informazioni relative a tutti gli attributi */

svattr()
{
   FILE *svat;
   frame *ptemp=testa;
   char nome[MAXNOME];

   if (checkattr(ptemp,nome)) {
      svat=fopen("sysframe/saveat","w");
      while (ptemp!=coda) {
         sa(ptemp,svat);
         ptemp++;
      }
      fclose(svat);
   }
   else {
      printf("Wrong attribute : %s\nAttributes not saved\n",nome);
      sleep(3);
   }
}


/* Controlla se tutti gli attributi sono validi */

checkattr(punt,nome)
   frame *punt;
   char nome[];
{
   while (punt!=coda && punt->flag==1) {
      if(punt->corpoattr.order==-1) {
         strcpy(nome,punt->nomeattr);
         return(0);
      }
      punt++;
   }
   return(1);
}



/* Salva appropriatamente su saveat l'attributo*/

sa(punt,svat)
   frame *punt;
   FILE *svat;
{
   if(punt->flag==1) {
      fstampa2(punt,svat);
   }
}



	 
shattr()
{
   frame *ptemp=testa;
   char mess;
   int i;

   clearscr();
   newfflush();
   while(ptemp!=coda) {
      if (ptemp->flag==1) {
         stampaattr(ptemp);
	 printf("\n <cr> continue");
	 for (i=0;i<50;i++)
	    printf("-");
         scanf("%c",&mess);
	 if(mess=='q')
            break;
      }
      ptemp++; 
   } 
}



stampanomiattr()
{
   frame *ptemp=testa;

   while(ptemp!=coda) {
       if (ptemp->flag==1)
         printf("\n%s ",ptemp->nomeattr);
      ptemp++;
   }
}
	 


stampaattr( nomestruct )
   frame *nomestruct;
{
   printf("\n");
   printf("%s ", nomestruct->nomeattr);
   printf("\n  : comment : %s",nomestruct->corpoattr.comment);
   printf("\n  : order : %d",nomestruct->corpoattr.order);
   printf("\n  : type  : ");
   if (strcmp(nomestruct->corpoattr.type , " ") != 0) {
      int i=0;
      char temp[MAXTYPE];
      strcpy(temp,nomestruct->corpoattr.type);
      while(temp[i]!='$')
	 i++;
      i++;
      printf("%s", temp+i);
   }
   printf("\n\n");
}
