#include <stdio.h>
#include <math.h>
#include <string.h>
#include <sys/wait.h>
#include "dichat.h"
#include "dichpr.h"
#include "newfflush.h"
#include "consts.h"

#define DEFSHARET 3

#define virgola(stringa,fp) {\
   int i=4,cont=0;\
   while(stringa[i]!='\0') {\
      while((stringa[i]!=' ') && (stringa[i]!='\0'))\
         i++;\
      if(stringa[i]==' ')\
         stringa[i++]=',';\
      cont++;\
   }\
   fprintf(fp,"\n\t{%d, %s}",cont,stringa+4);\
}

#define mswitch(tipo,nvar,star,fp)\
   switch(tipo) {\
      case 'i':\
	 fprintf(fp,"'%d';\n",nvar+star);\
	 break;\
      case 'c': {\
	 if(nvar==0)\
	    fprintf(fp,"'%d';\n",nvar+star+2);\
	 else {\
	    if(star==1)\
	       fprintf(fp,"'b';\n");\
	    else\
	       fprintf(fp,"'a';\n");\
	 }\
	 break;\
      }\
      case 'f': {\
	 if(nvar==0)\
	    fprintf(fp,"'%d';\n",nvar+star+4);\
	 else if(star==1)\
	    fprintf(fp,"'d';\n");\
	 else\
	    fprintf(fp,"'c';\n");\
	 break;\
      }\
   }

   extern check_netloaded();
extern maxord;  /* dichiarato in attr.c */

extern struct host hosts[MAXH];	/*  PVM architecture identifier */
extern int nhosts;

/* Testa, coda, head, tail sono dichiarati in menuprinc.c */
extern frame *testa,*coda;
extern pred *head,*tail;

/* Per ogni predicato utente vengono registrati il numero
   di bit occupati nel template, ed il puntatore a funtable */
struct {
   char nomep[MAXNOME];
   int nbit, pfun;
} stpred[MAXPRED];

int startbit=0;  
int sharet;
char path[128];


/* Il configuratore puo' agire solo dopo la completa definizione di
   predicati ed attributi */

int not_yet_done(i) int i; {
  int j;
  for(j=0; j<i; j++)
    if(strcmp(hosts[j].arch, hosts[i].arch)==0) return(0);
  return(1);
  }

confdb()
{
   char com;
   char cmd[128], dummy1[20], dummy2[20];
   int mc, i;

   FILE *fp;

   if(strlen(path)==0)
      strcpy(path, MAINDIR);
   if((mc = menuconf())==1) {
      if(testa==coda && !caricaattr()) {
         printf("\nWARNING: attributes are undefined (<cr>)");
	 newfflush();
	 scanf("%c",&com);
	 return;
      }
      if((maxord + 1)!=indatpnt) {
         printf("\nWARNING: attribute order is inconsistent (<cr>)");
	 newfflush();
	 scanf("%c",&com);
	 return;
      }
      makeattrh();
      infopred(); 
      makeattri();
      makepredi();
      compilatemp();
      cmd[0]='\0';
      if(check_netloaded()) {
      sprintf(cmd,"%s %s/conf/setup0 %s\0","csh",path,path);
      system(cmd);
      for(i=0; i<nhosts; i++)
       if(not_yet_done(i)){
        sprintf(cmd,"%s %s/conf/setup %s %s %s\0",
			"csh",path,path,hosts[i].arch, hosts[i].name);
        system(cmd);
	}
      }
      else printf("Configuration failed: network not specified!\n");
   }
   else if(mc == 0){
      clearscr();
      printf("Configuration failed: some constants are unspecified\n");
      newfflush();
      scanf("%c",&com);
   }
}



int menuconf()
{
   FILE *fp;
   int pop,class,sample,maxobj;
   float alfa,beta,a;
   double mnt;
   float rsm;
   int minage, maxnodes, maxhosts;
   char mess[13];

   strcpy(mess,"r");
   sharet = DEFSHARET;
   if((fp=fopen("sysframe/constga","r"))!=NULL) {
      fscanf(fp,"%d",&pop); 
      fscanf(fp,"%d",&class);
      fscanf(fp,"%d",&sample);
      fscanf(fp,"%d",&maxobj);
      fscanf(fp,"%f",&alfa);
      fscanf(fp,"%f",&beta);
      fscanf(fp,"%f",&a);
      fscanf(fp,"%lf",&mnt);
      fscanf(fp,"%f",&rsm);
      fscanf(fp,"%d",&minage);
      fscanf(fp,"%d",&maxnodes);
      fscanf(fp,"%d",&maxhosts);
      fclose(fp);
   }
   else {
      pop = class = sample = maxobj = 0;
      alfa=1.0;
      beta=1.0;
      a=0.01;
      mnt=0.0000001;
      rsm=0.5;
      minage=0;
      maxnodes=16;
      maxhosts=8;
   }
   while(strcmp(mess,"go")!=0) {
      clearscr();
      printf("_____________________________________________________________\n");
      printf("Parameters :\n\n");
      printf("maxsubpop: %d	maxcl: %d	mxsam: %d	obj_s: %d\n",
			 pop,class,sample,maxobj);
      printf("alfa: %f	beta: %f	a: %f	mnt: %.16lf\n",
		    alfa,beta, a, mnt);
      printf("rsm: %f	minage: %d\n", rsm, minage);
      printf("maxnodes: %d	maxhosts: %d\n", maxnodes,maxhosts);
      printf("_____________________________________________________________\n");
      printf("type <help> for information about parameters\n");
      printf("type <go> for continuing\n");
      printf("type <q> to leave the menu\n");
      printf("_____________________________________________________________\n");
      newfflush();
      scanf("%s",mess);
      if(strcmp(mess, "q")==0)
	 return(2);
      if(strcmp(mess,"maxsubpop")==0) {
         printf(":: ");
	 newfflush();
	 scanf("%d",&pop);
      }
      else if(strcmp(mess,"maxcl")==0) {
         printf(":: ");
	 newfflush();
	 scanf("%d",&class);
      }
      else if(strcmp(mess,"mxsam")==0) {
         printf(":: ");
	 newfflush();
	 scanf("%d",&sample);
      }
      else if(strcmp(mess,"obj_s")==0) {
         printf(":: ");
	 newfflush();
	 scanf("%d",&maxobj);
      }
      else if(strcmp(mess,"alfa")==0) {
         printf(":: ");
	 newfflush();
	 scanf("%f",&alfa);
      }
      else if(strcmp(mess,"beta")==0) {
         printf(":: ");
	 newfflush();
	 scanf("%f",&beta);
      }
      else if(strcmp(mess,"a")==0) {
	 printf(":: ");
	 newfflush();
	 scanf("%f",&a);
      }
      else if(strcmp(mess, "mnt")==0) {
	 printf(":: ");
	 newfflush();
	 scanf("%lf",&mnt);
      }
      else if(strcmp(mess, "rsm")==0) {
	 printf(":: ");
	 newfflush();
	 scanf("%f",&rsm);
      }
      else if(strcmp(mess, "help")==0)
	 print_help("Phelp");
      else if(strcmp(mess, "minage")==0) {
	 printf(":: ");
	 newfflush();
	 scanf("%d",&minage);
      }
      else if(strcmp(mess, "maxnodes")==0) {
	 printf(":: ");
	 newfflush();
	 scanf("%d",&maxnodes);
      }
      else if(strcmp(mess, "maxhosts")==0) {
	 printf(":: ");
	 newfflush();
	 scanf("%d",&maxhosts);
      }
   }
   if((fp=fopen("sysframe/constga","w"))!=NULL) {
      fprintf(fp,"%d %d %d %d %f %f %f %.16lf %f %d %d %d\n",
		     pop,class,sample,maxobj,
		     alfa,beta,a,
		     mnt, rsm,
		     minage,maxnodes,maxhosts);
      fclose(fp);
   }
   if((pop==0)||(class==0)||(sample==0))
      return(0);
   else {
      if((fp=fopen("constants.h","w"))!=NULL) {
         fprintf(fp,"#define MAXPOP %d	/* max dimension of each subpopulation */\n", pop);
	 fprintf(fp,"#define MAXCLASS %d	/* number of classes */\n",class);
	 fprintf(fp,"#define MAXSAMP %d	/* max number of examples */\n",sample);
	 fprintf(fp,"#define MAXOBJ %d	/* max number of objects for example */\n", maxobj);
	 fprintf(fp,"#define ALPHA %f	/* exponent of e in the fitness  */\n", alfa);
	 fprintf(fp,"#define BETHA %f	/* exponent of w in the fitness */\n", beta);
	 fprintf(fp,"#define A %f	/* weight for the generalisation in the fitness*/\n", a);
	 fprintf(fp,"#define PSM %f	/* Percentage seeding/mutation+seeding */\n", rsm);
	 fprintf(fp,"#define MNT %.16lf	/* minimum shared fitness */\n", mnt);
	 fprintf(fp,"#define MINAGE %d	/* min age for incremental covering */\n",minage);
	 fprintf(fp,"#define MAXNODES %d	/* max number of subpopulations */\n",maxnodes);
	 fprintf(fp,"#define MAXHOSTS %d	/* max number of hosts */\n",maxhosts);
	 fclose(fp);
      }
      return(1);
   }
}



/* Costruzione dei file attr.h fscanfs.h fprintfs.h */

makeattrh()
{
   FILE *fpa,*fs,*fp,*clib;
   int temp=0;
   int ord=0;
   int flag=1;

   if((fpa=fopen("attr.h","w"))!=NULL)
   if((fs=fopen("fscanfs.h","w"))!=NULL)
   if((fp=fopen("fprintfs.h","w"))!=NULL)
   if((clib=fopen("case_lib.h","w"))!=NULL) {
      fprintf(fpa,"/* struttura objtup */\nstruct objtup\n{\nint x1;");
      while(temp<indatpnt) {
         int i=0;
	 char nome[MAXNOME];
	 char *ptype=attrpunt[temp]->corpoattr.type;
	 fprintf(fs,"fscanf(strname,");
         fprintf(fp,"fprintf(strname,");
         while((*(ptype+(i++)))!='$')
	    ;
	 strcpy(nome,attrpunt[temp]->nomeattr);
	 switch(*(ptype+i)) {
	    case 'c':
	       fprintf(fpa,"\nchar %s%s;",nome,ptype+i+4);
	       fprintf(fs,"\"%%s\",");
	       fprintf(fp,"\"%%s \"");
	       break;
	    case 'f':
	       fprintf(fpa,"\nfloat %s;",nome);
	       fprintf(fs,"\"%%f\",&");
	       fprintf(fp,"\"%%f \"");
	       if(flag) {
	          fprintf(clib,"if(!strcmp(attr,\"%s\")) y=(float)objrel[i].%s;\n",nome,nome);
		  flag = 0;
               }
	       else
	          fprintf(clib,"else if(!strcmp(attr,\"%s\")) y=(float)objrel[i].%s;\n",nome,nome);
               break;
	    case 'l':
	       fprintf(fpa,"\nlong %s;",nome);
	       fprintf(fs,"\"%%l\",&");
	       fprintf(fp,"\"%%l \"");
	       if(flag) {
	          fprintf(clib,"if(!strcmp(attr,\"%s\")) y=(float)objrel[i].%s;\n",nome,nome);
		  flag = 0;
               }
               else
                  fprintf(clib,"else if(!strcmp(attr,\"%s\")) y=(float)objrel[i].%s;\n",nome,nome);
               break; 
            case 'i':
	       fprintf(fpa,"\nint %s;",nome);
	       fprintf(fs,"\"%%d\",&");
	       fprintf(fp,"\"%%d \"");
	       if(flag) {
                  fprintf(clib,"if(!strcmp(attr,\"%s\")) y=(float)objrel[i].%s;\n",nome,nome);
		  flag = 0;
               }
               else
		  fprintf(clib,"else if(!strcmp(attr,\"%s\")) y=(float)objrel[i].%s;\n",nome,nome);
               break; 
	    case 's':
	       fprintf(fpa,"\nshort %s;",nome);
	       fprintf(fs,"\"%%hd\",&");
	       fprintf(fp,"\"%%hd \"");
	       if(flag) {
		  fprintf(clib,"if(!strcmp(attr,\"%s\")) y=(float)objrel[i].%s;\n",nome,nome);
		  flag = 0;
               }
               else
		  fprintf(clib,"else if(!strcmp(attr,\"%s\")) y=(float)objrel[i].%s;\n",nome,nome);
               break; 
         }   
	 fprintf(fs,"objrel[i].%s);\n",nome);
         fprintf(fp,",objrel[i].%s);\n",nome);
         temp++;
      }
      fprintf(fpa,"\n};\n");
      fclose(fpa);
      fclose(fs);
      fclose(fp);
      fprintf(clib,"\n");
      fclose(clib);
   }
}
 
  

/* Costruzione dei file global.h set*.h semanticlib.h init.h 
   constants.h */

infopred()
{
   pred *ptemp=head;
   int i=0,j,nbit=0,indint=0,indfl=0,indfld=0,indchar=0,indf=0,maxint,maxfld;
   float max,min,step;
   char stringa[8],sv[8];
   char ppar[MAXPAR],com;
   FILE *fp,*fpsetint,*fpsetfl,*fpsetchar,*fpsetfld,*fpsem,*fproc,*fc;
   predstruct *punpred=NULL;

   if(head==tail)
      if(!caricapr()) {
         printf("\nWARNING: predicates are undefined (<cr>)");
	 newfflush();
	 scanf("%c",&com);
	 exit(0); 
      }
   if((fp=fopen("sysframe/max","r"))!=NULL) {
      fscanf(fp,"%d %d",&maxint,&maxfld);
      fclose(fp);
      fc=fopen("constants.h","a");
      fprintf(fc,"#define MAXSETINT %d\n#define MAXSETFLD %d\n",maxint+1,maxfld+1);
      fclose(fc);
   }
   if((fpsetint=fopen("setint.h","w"))!=NULL)
   if((fpsetfl=fopen("setfl.h","w"))!=NULL)
   if((fpsetfld=fopen("setfld.h","w"))!=NULL)
   if((fpsetchar=fopen("setchar.h","w"))!=NULL)
   if((fp=fopen("global.h","w"))!=NULL)
   if((fpsem=fopen("semanticlib.h","w"))!=NULL)
   if((fproc=fopen("init.h","w"))!=NULL) {
      fprintf(fproc,"init()\n{");
      fprintf(fpsetint,"/* ST di insiemi di interi */\nint setint[][MAXSETINT] ={");
      fprintf(fpsetfl,"/* ST di intervalli reali */\nfloat setfl[][3] ={");
      fprintf(fpsetfld,"/* ST di insiemi di reali*/\nfloat setfld[][MAXSETFLD] ={");
      fprintf(fpsetchar,"/* ST dei caratteri */\nchar *setchar[] ={");
      fprintf(fp,"union funct {int *(*a1) (); float *(*a2) (); char *(*a3) ();};\n\nstruct funt {char type; union funct code_pointer; int set_pointer; char fam[MAXNOME];}  funtable[MAXFUN];");
      fclose(fp);
 
      while(ptemp!=tail) {
         punpred=&(ptemp->corpopred);
         if(ptemp->flag==1) {
	    fprintf(fpsem,"%s\n",punpred->transsem);
	    strcpy(stpred[i].nomep,ptemp->nomepred);
	    if (punpred->lc=='l') {
	       strcpy(ppar,punpred->params);
               if(punpred->par[0]=='d') {
	          j=4;
		  nbit=0;
		  while(ppar[j]!=']') {
		     while((ppar[j]!=' ') && (ppar[j]!=']')) 
		        j++;
                     nbit++;
		     if(ppar[j]==' ')
		        j++;
                  }
		  ppar[j]='\0';
		  stpred[i].nbit=nbit;
		  fprintf(fproc,"funtable[%d].type=",indf);
		  if(punpred->var==1) {
		     if(ppar[j-1]=='*') {
		        mswitch(punpred->par[1],0,1,fproc);
			ppar[j-2]='\0';
		     }
		     else {
		        mswitch(punpred->par[1],0,0,fproc);
		     }
                  }
		  else {
		     if(ppar[j-1]=='*') {
		        mswitch(punpred->par[1],8,1,fproc);
			ppar[j-2]='\0';
                     }
		     else {
		        mswitch(punpred->par[1],8,0,fproc);
                     }
                  }
		  if(punpred->par[1]=='c') {
		     fprintf(fproc,"funtable[%d].code_pointer.a3=%s;\n",indf,ptemp->nomepred);
		     if(indchar==0)
		        fprintf(fpsetchar,"\n\t\"%s\"",ppar+4);
		     else
		        fprintf(fpsetchar,",\n\t\"%s\"",ppar+4);
		     fprintf(fproc,"funtable[%d].set_pointer=%d;\n",indf,indchar);
		     indchar++;
		  }
		  else if(punpred->par[1]=='i') {
		     fprintf(fproc,"funtable[%d].code_pointer.a1=%s;\n",indf,ptemp->nomepred);
		     if(indint!=0)
		        fprintf(fpsetint,",");
		     virgola(ppar,fpsetint);
		     fprintf(fproc,"funtable[%d].set_pointer=%d;\n",indf,indint);
		     indint++;
		  }
		  else {
		     fprintf(fproc,"funtable[%d].code_pointer.a2=%s;\n",indf,ptemp->nomepred);
		     if(indfld!=0)
		        fprintf(fpsetfld,",");
		     virgola(ppar,fpsetfld);
		     fprintf(fproc,"funtable[%d].set_pointer=%d;\n",indf,indfld);
		     indfld++;
		  }
               }
	       else {
	          int k=0;
		  j=4;
		  while(ppar[j]!=' ') 
		     sv[k++]=ppar[j++];
		  sv[k]='\0';
		  sscanf(sv,"%f",&max);
		  if(indfl==0)
		     fprintf(fpsetfl,"\n\t{%f, ",max);
		  else
		     fprintf(fpsetfl,",\n\t{%f, ",max);
		  k=0;
		  j++;
		  while(ppar[j]!=' ')
		     sv[k++]=ppar[j++];
		  sv[k]='\0';
		  sscanf(sv,"%f",&min);
		  fprintf(fpsetfl,"%f, ",min);
		  k=0;
		  j++;
		  while((ppar[j]!=' ') && (ppar[j]!=']') && (ppar[j]!='*'))
		     sv[k++]=ppar[j++];
		  sv[k]='\0';
		  sscanf(sv,"%f",&step);
		  fprintf(fpsetfl,"%f}",step);
		  stpred[i].nbit= (int) ceil(((max - min)/step) + 1); 
		  if(punpred->var==1)
		     if(ppar[j]!=']')
                        fprintf(fproc,"funtable[%d].type='7';\n",indf);
                     else
		        fprintf(fproc,"funtable[%d].type='6';\n",indf);
		  else
		     if(ppar[j]!=']')
		        fprintf(fproc,"funtable[%d].type='f';\n",indf);
                     else
		        fprintf(fproc,"funtable[%d].type='e';\n",indf);
                  fprintf(fproc,"funtable[%d].code_pointer.a2=%s;\n",indf,ptemp->nomepred);
		  fprintf(fproc,"funtable[%d].set_pointer=%d;\n",indf,indfl);
		  indfl++;
               }
            }
	    else {
	       if(punpred->var==1)
	          fprintf(fproc,"funtable[%d].type='0';\n",indf);
               else
	          fprintf(fproc,"funtable[%d].type='8';\n",indf);
	       fprintf(fproc,"funtable[%d].code_pointer.a1=%s;\n",indf,ptemp->nomepred);
	       if(indint==0)
	          fprintf(fpsetint,"\n\t{1, 1}");
	       else
	          fprintf(fpsetint,",\n\t{1, 1}");
	       fprintf(fproc,"funtable[%d].set_pointer=%d;\n",indf,indint);
	       indint++;
	    } 
	    fprintf(fproc,"strcpy(funtable[%d].fam,\"%s\");\n",indf,ptemp->nomepred);
	    stpred[i].pfun=indf++;
	    i++;
/*
if((ptemp+1)==tail) {
   if(indint==0) fprintf(fpsetint,"0 \n};\n");
   else fprintf(fpsetint," \n};\n");
   if(indchar==0) fprintf(fpsetchar,"\"\" \n};\n");
   else fprintf(fpsetchar," \n};\n");
   if(indfl==0) fprintf(fpsetfl,"0 \n};\n");
   else fprintf(fpsetfl," \n};\n");
   if(indfld==0) fprintf(fpsetfld,"0 \n};\n");
   else fprintf(fpsetfld," \n};\n");
 }
*/
         }
	 ptemp++;
      }
      if(indint==0)
         fprintf(fpsetint,"0 \n};\n");
      else
         fprintf(fpsetint," \n};\n");
      if(indchar==0)
         fprintf(fpsetchar,"\"\" \n};\n");
      else
         fprintf(fpsetchar," \n};\n");
      if(indfl==0)
         fprintf(fpsetfl,"0 \n};\n");
      else
         fprintf(fpsetfl," \n};\n");
      if(indfld==0)
         fprintf(fpsetfld,"0 \n};\n");
      else
         fprintf(fpsetfld," \n};\n");
      fclose(fpsetint);
      fclose(fpsetchar);
      fclose(fpsetfl);
      fclose(fpsetfld);
      fprintf(fpsem,"\n");
      fclose(fpsem);
      fprintf(fproc,"}\n");
      fclose(fproc);
      fc=fopen("constants.h","a");
      fprintf(fc,"#define MAXNOME 40	/* max lenght 'nome' field in 'attr' end 'pred' */\n#define MAXINT %d	/* dimension of 'setintl' */\n#define MAXFL %d		/* dimension of 'setfl' */\n#define MAXFLD %d	/* dimension of 'setfld' */\n#define MAXCHAR %d	/* dimension of 'setchar' */\n#define MAXFUN %d	/* dimension of 'funtable' */ \n",indint,indfl,indfld,indchar,indf);
      fclose(fc);
   }
}




/* Creazione del file attribute.i */

makeattri()
{
   int i;
   char t[MAXTYPE];
   frame *ptemp=testa; 
   FILE *fp;
   attrstruct *pstruct;

   fp=fopen("sysframe/attribute.i","w");
   fprintf(fp,"(\n");
   while(ptemp!=coda) {
      if(ptemp->flag==1) {
         pstruct=&(ptemp->corpoattr);
	 fprintf(fp,"#I(attribute  :name %s :sets (attributes semantic-op)",ptemp->nomeattr);
         i=0;
	 while(pstruct->type[i]!='$') {
            t[i]=pstruct->type[i];
	    i++;
	 }
	 t[++i]='\0';
	 fprintf(fp,":s-type %s :args ((var)) :c-name %s :c-transl (\"objrel[~a].~a\" (first args) c-name)" ,t,ptemp->nomeattr);
	 fprintf(fp," :comment \"%s\" :type %s :order %d :charlength 3) \n",pstruct->comment,(pstruct->type)+i, pstruct->order);
      }
      ptemp++;
   }
   fprintf(fp,")");
   fclose(fp);
}



/* Creazione del file predicate.i */

makepredi()
{
   pred *ptemp=head;
   FILE *fp;
   predstruct *pstruct;

   fp=fopen("sysframe/predicate.i","w");
   fprintf(fp,"(\n");
   while(ptemp!=tail) {
      if(ptemp->flag==1) {
         pstruct=&(ptemp->corpopred);
	 fprintf(fp,"#I(predicate  :name %s :sets (predicates)",ptemp->nomepred);
         fprintf(fp," :comment \"%s\" :form (%s) :semantics %s :params %s",pstruct->comment,pstruct->form,pstruct->semantics,pstruct->params);
	 fprintf(fp," :family nil :name_int (conf %s))\n",ptemp->nomepred);
      }
      ptemp++;
   }
   fprintf(fp,")");
   fclose(fp);
}



/* Creazione dei file match.h global.h constants.h constraints.h */
compilatemp()
{
   FILE *fp,*fglob,*fpglt,*fc,*fconst;
   int c,j,indmatch=0,indtempl=0,indntempl=0,indconst=0,lptemplate,
       maxp=0,maxb=0,oldmatch,nswitch=0;
   int var1, var2, nvar;
   char lpr[1000],lprc[1000];

   startbit=0;
   if((fpglt=fopen("match.h","w"))!=NULL)
   if((fglob=fopen("global.h","a"))!=NULL)
   if((fp=fopen("sysframe/savetempl","r"))!=NULL)
   if((fc=fopen("constants.h","a"))!=NULL)
   if((fconst=fopen("constraints.h","w"))!=NULL) {
      fprintf(fglob,"\n\nstruct template {short v1,v2; int tomatch,toconst;} templ[] ={\n\t");
      fprintf(fpglt,"/* MATCHTABLE */\nstruct matchtable {short startbit,nbit; int function,next;} matel[] ={");
      fprintf(fconst,"/* CONSTRAINTS TABLE */\nstruct constrtable {int function,next;} constrel[] ={ ");
      fscanf(fp,"%d", &var1);
      fprintf(fc,"#define MAXVAR %d	/* max number of positive variables */\n",var1);
      c=getc(fp);
      fscanf(fp,"%d", &var2);
      fprintf(fc,"#define MAXNVAR %d	/* max number of negative variables */\n",var2);
      fprintf(fc,"#define MAXV %d		/* max total number of variables */\n",var1+var2);
      c=getc(fp);

      /*  Agli identificatori delle variabili di lambda- viene sommato
	  il numero di variabili di lambda+, in modo che siano unici */
      c=getc(fp);
      while(1) {
	 /* stampa v1 */
	 fscanf(fp, "%d", &nvar);
	 if(c=='x') 
            fprintf(fglob,"%d, ", nvar);
         else
	    fprintf(fglob,"%d, ", nvar+var1);
	 c=getc(fp);
	 c=getc(fp);
	 
	 /* stampa v2 */
	 fscanf(fp, "%d", &nvar);
	 if(c=='x') {
	    fprintf(fglob,"%d, ", nvar);
	    c=getc(fp);
	    c=getc(fp);
         }
         else if(c=='y') {
	    fprintf(fglob,"%d, ", nvar+var1);
	    c=getc(fp);
	    c=getc(fp);
	 }
	 else
	    fprintf(fglob,"-1, ");    /* unario */
	 j=0;
	 
	 /* Recupera una lista di predicati */
	 while((c=getc(fp))!=')')
            lpr[j++]=c;
	 lpr[j]='\0';
	 j=0;
	 getc(fp);
	 getc(fp);
	 while((c=getc(fp))!=')')
            lprc[j++]=c;
	 lprc[j]='\0';
	 fprintf(fglob,"%d, ",indmatch);     /* stampa tomatch */
	 if(nswitch)
	    indntempl++;
	 else
	    indtempl++;
	 oldmatch=indmatch;
	 compilamatch(lpr,&indmatch,&maxb,fpglt);
	 if((indmatch - oldmatch) > maxp)
	    maxp=indmatch - oldmatch; 
	 if(j==0) {
	    if(indconst!=0)
	       fprintf(fconst,",");
	    fprintf(fconst,"\n\t-1, -1");
	    indconst++;
	    fprintf(fglob,"-1");   /* non ci sono pred di vincolo */
	 } 
	 else {
	    fprintf(fglob,"%d",indconst);
	    if(indconst!=0)
	       fprintf(fconst,",");
	    compilaconst(lprc,&indconst,fconst);
	 }
	 c=getc(fp);
	 c=getc(fp);
	 if(c==EOF) {
	    fprintf(fpglt," };\n");
            fprintf(fconst," };\n");
            fprintf(fglob," };\n");
            break;
         }
	 else if(c=='$') {
            nswitch=1;
	    lptemplate=startbit;
	    fprintf(fglob,",\n\t");
            fprintf(fpglt,",");
	    c=getc(fp);
	    c=getc(fp);
	 }
	 else {
	    fprintf(fglob,",\n\t");
            fprintf(fpglt,",");
         }
      }
   }
   fprintf(fc,"#define MAXTEMPL %d	/* dimension of positive template */\n",
		       indtempl);
   fprintf(fc,"#define MAXNTEMPL %d	/* dimension of negative template */\n",
		       indntempl);
   fprintf(fc,"#define MAXMATCH %d	/* dimension of 'matel' */\n",
		       indmatch);
   fprintf(fc,"#define MAXCONSTR %d	/* dimension of 'constrel' */\n",
		       indconst);
   fprintf(fc,"#define LTEMPLATE %d	/* lenght of template */\n",
		       startbit);
   fprintf(fc,"#define MAXPRED %d	/* max number of predicates */\n",
		       maxp);
   fprintf(fc,"#define MAXSUBBIT %d	/* max number of constants in a internal disjunction */\n", maxb);
   if(indntempl >0) fprintf(fc,"#define NEG	/* negation will be used */\n");
   fclose(fc);
   fclose(fconst);
   fclose(fpglt);
   fclose(fglob);
   fclose(fp);
}



/* Verifica l'esistenza di ogni predicato in lpr e ne memorizza
   sul file fp il puntatore alla funtable e l'indice del prossimo
   predicato di vincolo appartenente alla stessa famiglia */

compilaconst(lpr,ind,fp)
   char lpr[];
   int *ind;
   FILE *fp;
{
   int i=0,j;
   char nome[MAXNOME];

   while(lpr[i]!='\0') {
      j=0;
      while((lpr[i]!=' ') && (lpr[i]!='\0'))
         nome[j++]=lpr[i++];
      if(lpr[i]==' ')
         i++;
      nome[j]='\0';
      j=0;
      while(strcmp(nome,stpred[j++].nomep)!=0)
	 ;
      j--;
      fprintf(fp,"\n\t%d, ",stpred[j].pfun);
      ++(*ind);
      if(lpr[i] == '\0')
         fprintf(fp,"-1");
      else
         fprintf(fp,"%d,",(*ind));
   }
}


/* Verifica l'esistenza di ogni predicato in lpr e ne inizializza
   l'entry corrispondente nella match table */

compilamatch(lpr,ind,maxb,fp)
   char lpr[];
   int *ind,*maxb;
   FILE *fp;
{
   int i=0,j;
   char nome[MAXNOME];

   while(lpr[i]!='\0') {
      j=0;
      while((lpr[i]!=' ') && (lpr[i]!='\0'))
         nome[j++]=lpr[i++];
      if(lpr[i]==' ')
         i++;
      nome[j]='\0';
      j=0;
      while(strcmp(nome,stpred[j++].nomep)!=0)
	 ;
      j--;
      fprintf(fp,"\n\t%d, ",startbit);
      fprintf(fp,"%d, ",stpred[j].nbit);
      fprintf(fp,"%d, ",stpred[j].pfun);
      if(stpred[j].nbit > *maxb)
         *maxb=stpred[j].nbit;
      ++(*ind);
      if(lpr[i] == '\0')
         fprintf(fp,"-1");
      else
         fprintf(fp,"%d,",(*ind));
      startbit=startbit+stpred[j].nbit;
   }
}

print_help(h) char h[]; {
   char cmd[128];

   sprintf(cmd, "more -c %s/%s",HELP,h);
   system(cmd);
   printf("\n------------------------------------------------------------------------------\n");
   newfflush();
   printf("\nType a key to continue");
   getchar();
}
