#include <stdio.h>
#include <ctype.h>
#include "dichpr.h"
#include "dichat.h"
#include "newfflush.h"

#define COL 100

#define fstampa(headtemp,svpr) {\
   predstruct *punpred=&(headtemp->corpopred);\
   fprintf(svpr,"%s\n%d\n%s\n%s\n%s\n%s\n%s\n%c\n%d\n%s\n",\
	   headtemp->nomepred, headtemp->flag, punpred->comment,\
	   punpred->form, punpred->params, punpred->semantics,\
	   punpred->transsem, punpred->lc, punpred->var, punpred->par);\
}\

extern void print_help();

static int c;
static char risp;
extern template(); /* template.c */
extern preleva();  /* menuprinc.c */
extern pred *head;
extern pred *tail;
extern frame *coda;
extern frame *testa;
int maxint=2,maxfld=0; /* Massimo numero di parametri interi e reali */
int contarg=0;         /* Conta il numero degli arg */
char typepar;          /* Tipo dei parametri associati al pred. */

menupred()
{
   char comando[3];
   int ciclo=1;
   char mess;
 
   if (head==tail)
      caricapr();
   while(ciclo==1) {
      clearscr();
      printf("\n****** PREDICATES CONFIGURATION ******\n\n");
      printf("______________________________________\n");
      printf(" sh = show predicates\n");
      printf(" ed = edit and insert predicates\n");
      printf(" rm = remove predicates\n");
      printf(" ls = list predicates \n");
      printf(" sv = save predicates\n");
      printf(" sy = show predicate semantic syntax\n");
      printf("\n type <help> for help\n");
      printf(" type <q> to exit\n");
      printf("______________________________________\n");
      scanf("%s", comando);
      if (strcmp(comando,"sh")==0)
         showpr();
      else if (strcmp(comando,"ed")==0)
         edp();
      else if (strcmp(comando,"rm")==0)
         rem();
      else if (strcmp(comando,"ls")==0)
         listpred();
      else if (strcmp(comando,"sv")==0)
         svpred();
      else if (strcmp(comando,"sy")==0)
         print_help("OPdescr");
      else if (strcmp(comando,"help")==0)
         print_help("PREDhelp");
      else if (strcmp(comando,"q")==0)
        ciclo=0;
   }
}



/* Rimozione di un predicato */

rem()
{
   pred *headtemp;
   char nome[MAXNOME],mess;
   int ciclo=1;

   while(ciclo==1) {
      clearscr();
      printf("\n*** Remove predicates ***\n");
      printf("__________________________");
      printf("\nDefined predicates\n");
      stampanomipred();
      printf("\n__________________________\n");
      printf("\nPredicate name (<q> to quit): ");
      scanf("%s",nome);
      if (strcmp(nome,"q")==0)
         ciclo=0;
      else {
	 headtemp=head;
         while (headtemp!=tail && strcmp(headtemp->nomepred,nome)!=0)
	    headtemp++;
         if (headtemp!=tail && headtemp->flag==1)
               headtemp->flag=0;
         else {
            printf("\nWrong predicate name : %s",nome);
	    newfflush();
	    scanf("%c",&mess);
         }
      }  
   }
}



/* Crea predicati d'apprendimento e di vincolo */

edp()
{
   char messaggio[11],tipop,typ,flaglc;
   char com[MAXCOM],form[MAXFORM],par[MAXPAR],sem[MAXSEM],nome[MAXNOME];
   pred *ptemp=NULL;
   pred *controllapr();
   FILE *fsem,*fp;
   int ciclo=1, ciclo1;

   if((fp=fopen("sysframe/max","r"))!=NULL) {
      fscanf(fp,"%d %d",&maxint,&maxfld);
      fclose(fp);
   }
   while(ciclo==1) {
      ciclo1=1;
      clearscr();
      printf("\n*** Edit predicates ***\n");
      printf("________________________");
      printf("\nDefined predicates\n");
      stampanomipred();
      printf("\n________________________\n");
      printf("\nPredicate name (<q> to quit): ");
      scanf("%s",nome);
      if (strcmp(nome,"q")==0)
         ciclo=0;
      else
	 while (ciclo1==1) {
            (pred *) ptemp=(pred *)controllapr(nome);
            if((pred *)ptemp==NULL) {
               printf("\nLearning or Constraint predicate? (l/c): ");
	       newfflush();
	       scanf("%c",&flaglc);
	       printf("\nNumber of variables : ");
               scanf("%d",&contarg);
               strcpy(tail->nomepred,nome);
               strcpy(tail->corpopred.comment," ");
               strcpy(tail->corpopred.params,"(k nil)");
               riempiform(nome,tail->corpopred.form,flaglc);
               strcpy(tail->corpopred.semantics," ");
               strcpy(tail->corpopred.transsem,"");
               if(flaglc=='l')
                  strcpy(tail->corpopred.par," ");
               else {
                  strcpy(tail->corpopred.par,"di");
                  typepar='i';
               }
               tail->corpopred.lc=flaglc;
               tail->corpopred.var=contarg;
               ptemp=tail++;
            }
            else {
               if(ptemp->corpopred.lc=='l') {
		  flaglc='l';
                  typepar=ptemp->corpopred.par[1];
               }
               else {
                  typepar='i';
		  flaglc='c';
               }
               contarg=ptemp->corpopred.var;
            }
            clearscr();
            stampapred(ptemp);
            ptemp->flag=1;
            printf("\nfield (<q> to quit) : ");
            newfflush();
            scanf("%s",messaggio);
            printf("\n");
            if (strcmp(messaggio,"q")==0)
               ciclo1=0;
            else {
	       predstruct *punpred=NULL;
	       punpred=&(ptemp->corpopred);

               if (strcmp(messaggio,"comment")==0) {
                  printf("::");
                  newfflush();
                  preleva(stdin,com,MAXCOM);
	          strcpy(punpred->comment,com);
               }
               else if(strcmp(messaggio,"form")==0) {
                  printf("Number of variables : ");
                  scanf("%d",&contarg);
                  riempiform(nome,punpred->form,flaglc);
                  punpred->var=contarg;
               }
               else if((strcmp(messaggio,"params")==0) && (flaglc=='l')) {
                  FILE *maxfp;
                  if (strcmp(punpred->params,"(k nil)") == 0) {
                     printf("\nContinue or discrete? (c/d) : ");
                     newfflush();
                     scanf("%c",&tipop);
                     if ((tipop!='c') && (tipop!='d'))
                        ;
                     else if (tipop == 'c') {
                        punpred->par[1] = 'f';
                        typepar='f';
                        initcont(punpred->params);
                     }
	             else {
	                printf("\nInteger, Float or Char ? (i/f/c): ");
                        newfflush();
	                scanf("%c",&typ);
                        punpred->par[1] = typ;
                        typepar=typ;
                        initdiscr(punpred->params,typ);
	             }
                     punpred->par[0] = tipop;
                  }
                  else if (punpred->par[0] == 'c')
	             modcont(punpred->params);
                  else
                     moddiscr(punpred->params,ptemp->corpopred.par[1]);
                  maxfp=fopen("sysframe/max","w");
                  fprintf(maxfp,"%d %d\n",maxint,maxfld);
                  fclose(maxfp);
               }
               else if(strcmp(messaggio,"semantics")==0) {
                  char vartemp[MAXSEM],varsem[MAXSEM];
                  char variabili1[MAXFORM],var2[MAXFORM];

                  if((frame *)testa==(frame *)coda &&
		     caricaattr()==0) {
			printf("ERROR: UNDEFINED ATTRIBUTES !\n");
			newfflush();
			sleep(3);
                  }
                  else {
		     if(strcmp(punpred->semantics," ")!=0)
		        caricasem(punpred->semantics,fsem);
		     if (contarg==0) {
		        typepar=punpred->par[1];
			contarg=punpred->var;
	             }
		     system("vi sysframe/semantics");
		     fsem=fopen("sysframe/semantics","r");
		     prelevasem(fsem,varsem,MAXSEM);
		     fclose(fsem);
		     prendivar(punpred->form,variabili1,var2);
		     if (strcmp(varsem,punpred->semantics) !=0) {
		        strcpy(vartemp,"");
			if (!checksem(vartemp)) {
			   strcpy(varsem,"");
			   if(!stampaerr(vartemp,varsem))
			      ;
			   else
			      concludi(punpred,var2,variabili1,vartemp,varsem);
		        }
			else
			   concludi(punpred,var2,variabili1,vartemp,varsem);
		     }
		     system("rm sysframe/semantics");
                  }
	       }
            }
         }
   }
}




/* Inizializza variabili1 e var2 appropriatamente in vista del loro
   utilizzo per comporre la traduzione in C della semantica del
   predicato */

prendivar(form,variabili1,var2)
   char form[], variabili1[], var2[];
{
   int i=1,j=5,z=0;

   while(form[i]!=' ')
      var2[z++]=form[i++];
   var2[z++]='(';
   i++;
   strcpy(variabili1," int ");
   while((form[i]!='k') && (form[i]!=')')) {
      if(form[i]==' ') {
         variabili1[j++]=',';
	 var2[z++]=',';
	 i++;
      }
      else {
         variabili1[j++]=form[i];
	 var2[z++]=form[i++];
      }
   }
   if(form[i]=='k') {
      variabili1[j-1]='\0';
      var2[z-1]='\0';
   }
   else {
      variabili1[j]='\0';
      var2[z]='\0';
   }
   strcat(variabili1,"; ");
   strcat(var2,")");
}



/* Definizione della traduzione finale in C della semantica */

concludi(punpred,var2,variabili,vartemp,varsem)
   predstruct *punpred;
   char var2[], variabili[], vartemp[], varsem[];
{
   if (punpred->par[0] == 'c')
      strcpy(punpred->transsem,"float *");
   else if(punpred->par[1] == 'c')
      strcpy(punpred->transsem,"char *  ");
   else if(punpred->par[1] == 'i')
      strcpy(punpred->transsem,"int *");
   else
      strcpy(punpred->transsem,"float *");
   strcat(punpred->transsem,var2);
   strcat(punpred->transsem,variabili);
   strcat(punpred->transsem,vartemp);
   strcpy(punpred->semantics,varsem);
}


/* Carica la semantica scritta dall'utente */

prelevasem(fp,sem,lim)
   FILE *fp;
   char sem[];
   int lim;
{
   int c, i=0;

   c=getc(fp);
   while(i<(lim-1) && (c!=EOF)) {
      if (c!='\n') {
         sem[i++]=c;
	 c=getc(fp);
      }
      else {
         sem[i++]=' ';
	 while (((c=getc(fp))==' ') || (c=='\t'))
	    ;
      }
   }
   sem[i]='\0';
}



/* In caso di errori, essi sono segnalati e viene offerta
   l'opportunuta' di correggerli richiamando il vi */

stampaerr(trans,varsem)
   char trans[], varsem[];
{
   FILE *fer,*fsem;
   int c;

   if((fer=fopen("sysframe/temperror","r"))!=NULL) {
      clearscr();
      while((c=getc(fer))!=EOF)
         printf("%c",c);
      fclose(fer);
      printf("\n\nCorrection ?(y/n)\n");
      newfflush();
      scanf("%c",&risp);
      if(risp=='n') {
         strcpy(trans,"");
	 return(0);
      }
      else {
         system("vi sysframe/semantics");
	 fsem=fopen("sysframe/semantics","r");
	 prelevasem(fsem,varsem,MAXSEM);
	 fclose(fsem);
	 strcpy(trans,"");
	 if(checksem(trans))
	    return(1);
         else {
	    strcpy(varsem,"");
	    if(stampaerr(trans,varsem))
	       return(1);
	    else {
	       strcpy(trans,"");
	       return(0);
	    }
	 }
      }
   }
}



/* Inizializzazione dei parametri di tipo discreto */

initdiscr(par,type)
   char par[], type;
{
   char k[MAXPAR];

   strcpy(par,"(k [");
   getdiscr(par,type);
}



/* Prelevamento e controllo dei parametri discreti introdotti */

getdiscr(par,type)
   char par[], type;
{
   char temp[MAXPAR], k[MAXPAR], val[15];
   int i=4, v=0, c, flag, len, star=0;
   int tempdim=0; /* Numero di parametri introdotti */

   len=strlen(par);
   if(par[len-2]=='*') {
      star=1;
      par[len-2]='\0';
   } 
   strcpy(temp,"");
   while (par[i]!='\0') {
      while((par[i]!='\0') && (par[i]!=' '))
	 i++;
      tempdim++;
      if(par[i]==' ')
	 i++;
   }
   i=0;
   printf("\nInsert the string of values : ");
   newfflush();
   fgets(k,MAXPAR,stdin);
   while((k[i] != '\n') && (k[i] != '\0')) {
      while(k[i]==' ')
         i++;
      if(k[i] == '\n')
         break;
      if(type == 'i') {  /* Parametri interi */
         while((isdigit((int) k[i])) && (k[i]!=' ') && (k[i]!='\n'))
            val[v++]=k[i++];
         if((k[i]=='*') &&
	    ((k[i-1]==' ') || (i == 0)) &&
	    ((k[i+1]=='\n') || (k[i+1]==' '))) {
	    tempdim--;
	    star=1;
	    i++;
         }
	 else {
            if((k[i]==' ') || (k[i]=='\n')) {
	       val[v]=' ';
	       val[++v]='\0';
	       strcat(par,val);
	    }
	    else {
	       if(k[i]=='.') {
	          val[v++]='.';
		  i++;
		  break;
               }
	       else {
	          val[v]=k[i];
		  while((k[i]!=' ') && (k[i]!='\n'))
	             val[v++]=k[i++];
	          val[v]=' ';
		  val[++v]='\0';
		  strcat(temp,val);
	       }
	    }
         }
	 v=0;
      } /* fine parametri interi */ 
      if(type == 'f') {   /* Parametri reali */
         while(((isdigit((int) k[i])) ||
		((k[i]=='.') &&(isdigit((int) k[i-1])) &&
		 (isdigit((int) k[i+1])))) && (k[i]!=' ') && (k[i]!='\n'))
            val[v++]=k[i++];
         if((k[i]=='*') &&
	    ((k[i-1]==' ') || (i == 0)) &&
	    ((k[i+1]=='\n') || (k[i+1]==' '))) {
            tempdim--;
	    star=1;
	    i++;
         }
	 else {
            if((k[i]==' ') || (k[i]=='\n')) {
               val[v]=' ';
	       val[++v]='\0';
	       strcat(par,val);
	    }
         }
	 v=0;
      } /* fine parametri reali */
      else if(type=='c') {  /* Parametri carattere */
         flag=0;
	 while((k[i]!=' ') && (k[i]!='\n')) {
	    if((flag==0) && (isalpha(k[i])))
	       flag=1;
	    else
	       if((flag == 1) && (!isalnum(k[i]))) 
	          break;
	    val[v++]=k[i++];
         }
	 if((k[i-1]=='*') &&
	    (((i-1) == 0) || (k[i-2]==' ')) &&
	    ((k[i]=='\n') || (k[i]==' '))) {
	    tempdim--;
	    star=1;
	    i++;
         }
	 else {
	    if((flag==1) && ((k[i] == ' ') || (k[i] == '\n'))) {
               val[v]=' ';
	       val[++v]='\0';
	       strcat(par,val);
	    }
	    else {
	       while((k[i] != ' ') && (k[i] != '\n'))
	          val[v++] = k[i++];
	       val[v]=' ';
	       val[++v]='\0';
	       strcat(temp,val);
	    }
         }
	 v=0;
      } /* fine parametri carattere */
      tempdim++; 
   }
   if(star==1)
   strcat(par,"* ");
   if(strcmp(temp,"")!=0) {
      clearscr();
      printf("Type conflict for %s\nCorrection? (y/n): ",temp);
      scanf("%c",&risp);
      if(risp=='y')
         getdiscr(par,type);
      else {
         par[strlen(par)-1]='\0';
	 strcat(par,"])");
      }
   }
   else {
      if((type=='i') && (tempdim>maxint))
         maxint=tempdim;
      else if((type=='f') && (tempdim>maxfld))
         maxfld=tempdim;
      par[strlen(par)-1]='\0';
      strcat(par,"])");
   }
}



/* Modifica dei parametri discreti */

moddiscr(par,type)
   char par[], type;
{
   char stringa[MAXPAR];
   int len;

   printf("Delete or add ? (d/a) "); 
   newfflush();
   scanf("%c",&risp);
   if(risp=='d') {
      cancellap(par);
      printf("\nAdd ? (y/n) ");
      newfflush();
      scanf("%c",&risp);
      if(risp=='y') {
         len= strlen(par);
         if(par[len-3]!='[') {
            par[strlen(par)-2]=' ';
            par[strlen(par)-1]='\0';
         }
         else
            par[strlen(par)-2]='\0';
         getdiscr(par,type);
      }
   } 
   else {
      len= strlen(par);
      if(par[len-3]!='[') {
         par[strlen(par)-2]=' ';
         par[strlen(par)-1]='\0';
      }
      else
         par[strlen(par)-2]='\0';
      getdiscr(par,type);
   }
}



/* Eliminazione dalla lista dei parametri */

cancellap(par)
   char par[];
{
   char temppar[MAXPAR], t[MAXPAR], copy[MAXPAR], error[MAXPAR];
   int i=4, j=0, indpar, indcopy, copy_ind, temp_i=4, err_ind=0;

   strcpy(error,"");
   strcpy(temppar,"(k [");
   strcpy(copy,"");
   printf("\nInsert the string to delete : ");
   newfflush();
   fgets(t,MAXPAR,stdin);
   while((par[i]!=']') && (t[j] !='\n')) {
      while(t[j] == ' ')
         j++;
      while (t[j] != '\n') {
         indpar=i;
	 while(t[j] == ' ')
	 j++;
	 copy_ind=0;
	 if(par[i] != t[j])
	    while((t[j] != ' ') && (t[j] != '\n'))
	       copy[copy_ind++] = t[j++]; /* passiamo alla stringa successiva
					     in t e salviamo in copy
					     quella corrente */
         else {
	    indcopy=copy_ind;
	    copy[copy_ind++]=t[j];
	    while((t[++j]==par[++i]) && (t[j]!= ' ') &&
		  (t[j]!='\n') && (par[i] != ']'))
               copy[copy_ind++]=t[j];
	    if(((t[j] == par[i]) && (t[j] == ' ')) ||
	       ((t[j] == '\n') && (t[j-1] == par[i-1]) &&
		((par[i] == ']') || (par[i] == ' '))) ||
	       ((par[i] == ']') && (par[i-1] == t[j-1]) &&
		((t[j] == ' ') || (t[j] == '\n')))) {
               copy_ind=indcopy;
	       copy[copy_ind]='\0';
	       strcat(copy,t+j);
	       strcpy(t,copy);
	       indpar=++i;
	       if(par[i-1] == ']')
	          if(temppar[temp_i -1] != '[')
		     temppar[temp_i -1] = ']';
		  else
		     temppar[temp_i++] = ']';
	       temppar[temp_i] = '\0';
	       strcat(temppar,par+i);
	       strcpy(par,temppar);
	       temp_i=4; i=4; j=0;
	       break;
	    }
	    else {
	       while((par[i]!=' ') && (par[i]!=']'))
	          i++;
	       if(par[i]==' ')
	          i++;
	       else {
	          int tci=indcopy;
		  i=4;
		  while(indcopy < copy_ind)
		     error[err_ind++] = copy[indcopy++];
		  while((t[j] != ' ') && (t[j] != '\n'))
		     error[err_ind++] = t[j++];
		  error[err_ind++] = ' ';
		  copy_ind=tci;
		  temp_i=4;
	       }
	       while(indpar < i)
	          temppar[temp_i++] = par[indpar++];
	       copy[copy_ind]='\0';
	       strcat(copy,t+j);
	       strcpy(t,copy);  
	       strcpy(copy,"");
	       j=0;
	    }
	 }
      }   
      if((par[i] != '[') && (j!=0)) {
         temppar[temp_i++] = par[i++];
	 while((par[i] != ' ') && (par[i] !=']'))
	    temppar[temp_i++] = par[i++];
	 if(par[i] == ']') {
	    int tci=indcopy;
	    while(indcopy < copy_ind)
	       error[err_ind++] = copy[indcopy++];
	    while((t[j] != ' ') && (t[j] != '\n'))
	       error[err_ind++] = t[j++];
	    error[err_ind++] = ' ';
	    copy_ind=tci; temp_i=4; i=4;
	 }
	 else {
	    i++; j=0;
	    temppar[temp_i++] = ' ';
	 }
      }
   }
   if(err_ind != 0) {
      error[err_ind] = '\0';
      clearscr();
      printf("\nWARNING: string '%s' don't exist!\nDeleting another string? (y/n) ",error);
      newfflush();
      scanf("%c",&risp);
      if(risp == 'y')
         cancellap(par);
   }
}



/* Inizializzazione dei parametri reali per un intervallo continuo */

initcont(temp)
   char temp[];
{
   float val;
   char sval[8];
 
   strcpy(temp,"(k [");
   printf("\nMax : ");
   scanf("%f",&val);
   sprintf(sval,"%f",val);
   strcat(temp,sval);
   printf("Min : ");
   newfflush();
   scanf("%f",&val);
   sprintf(sval," %f",val);
   strcat(temp,sval);
   printf("Step : ");
   scanf("%f",&val);
   sprintf(sval," %f",val);
   strcat(temp,sval);
   strcat(temp," *])");
}




/* Modifica parametri reali per un intervallo continuo */

modcont(par)
   char par[];
{
   float max,min,step;
   char sval[8],scelta[8],sl[8];
   int i=4,j=0;

   while(par[i]!=' ')
      sval[j++]=par[i++];
   sval[j]='\0'; 
   j=0; 
   sscanf(sval,"%f",&max);
   i++;
   while(par[i]!=' ')
      sval[j++]=par[i++];
   sval[j]='\0'; 
   j=0; 
   sscanf(sval,"%f",&min);
   i++;
   while(par[i]!='*')
      sl[j++]=par[i++];
   sl[j-1]='\0';
   sscanf(sl,"%f",&step);
   stampapar(max,min,step);
   scanf("%s",scelta);
   while(strcmp(scelta,"q")!=0) {
      if(strcmp(scelta,"max")==0) {
         printf("::");
         scanf("%f",&max);
      }
      else if(strcmp(scelta,"min")==0) {
         printf("::");
         scanf("%f",&min);
      }
      else if(strcmp(scelta,"step")==0) {
         printf("::");
         newfflush();
         scanf("%8f",&step);
      }
      stampapar(max,min,step);
      scanf("%s",scelta);
   }
   strcpy(par,"(k [");
   sprintf(sl," %f",step);
   sprintf(sval,"%f",max);
   strcat(par,sval);
   sprintf(sval," %f",min);
   strcat(par,sval);
   strcat(par,sl);
   strcat(par," *])");
}
 


stampapar(max,min,step)
   float max,min,step;
{
   clearscr();
   printf("\n  : max     : %f\n  : min     : %f",max,min);
   printf("\n  : step    : %f\n\n\n",step);
   printf("Parameter (<q> to quit) : ");
   newfflush();
}




/* Inizializzazione del campo form */

riempiform(nome,form,flag)
   char nome[], form[], flag;
{
   int i=1;
   char temp[5],c[5];

   strcpy(form,"(");
   strcat(form,nome);
   while(i<=contarg) {
      sprintf(temp," x%d",i-1);
      i++;
      strcat(form,temp);
   }
   if(flag=='l')
      strcat(form," k)");
   else
      strcat(form,")");
}



/* Verifica che il predicato nome compaia tra quelli gia' definti */

pred *controllapr(nome)
   char nome[];
{
   pred *ptemp=head;
  
   while(ptemp!=tail) {
      if(strcmp(ptemp->nomepred,nome)==0)
         return(ptemp);
      ptemp++;
   }
   return(NULL);
} 



/* Indentazione della semantica in notazione lisp-like della
   semantica scritta dall'utente */

caricasem(sem,fsem)
   FILE *fsem;
   char sem[];
{
   int disp=0, cont=0, offset=0, i=0, j, pila[20];

   fsem=fopen("sysframe/semantics","w");
   while (sem[i]!='\0') {
      while (sem[i]!=')') {
         if(sem[i]=='(') {
            pila[cont++]=disp;
	    disp=1;
	 }
	 else
	    disp++;
	 offset++;
	 fprintf(fsem,"%c",sem[i++]);
      }
      offset-=disp;
      disp=pila[--cont];
      fprintf(fsem,"%c",sem[i++]);
      while ((sem[i]==' ') && (sem[i]!='\0'))
         i++;
      if((sem[i]!=')') && (sem[i]!='\0')) {
         fprintf(fsem,"\n");
	 for (j=0;j<offset;j++)
	    fprintf(fsem," ");
      }
   }
   fprintf(fsem,"\n");
   fclose(fsem);
}




listpred()
{
   pred *ptemp=head;
   char mess;

   clearscr();
   printf("\n*** Predicates list ***\n");
   printf("_______________________\n");
   printf("\nLearning predicates\n\n");
   while(ptemp!=tail) {
      if((ptemp->flag ==1) && (ptemp->corpopred.lc=='l'))
         printf("%s\n",ptemp->corpopred.form);
      ptemp++;
   }
   ptemp=head;
   printf("\n\nConstraint predicates\n\n");
   while(ptemp!=tail) {
      if((ptemp->flag ==1) && (ptemp->corpopred.lc=='c'))
         printf("%s\n",ptemp->corpopred.form);
      ptemp++;
   }
   printf("_______________________\n");
   printf("\n<cr> continue");
   newfflush();
   scanf("%c",&mess);
}



caricapr()
{
   FILE *svpr;
   char nome[MAXNOME], com[MAXCOM], form[MAXFORM],
	params[MAXPAR], sem[MAXSEM], par[3];
   int var[4],num[2];

   if((svpr=fopen("sysframe/savepr","r"))!=NULL) {
      c=getc(svpr);
      while(c!=EOF) {
         preleva3(nome,svpr);
	 strcpy(tail->nomepred,nome);
	 preleva3(num,svpr);
	 tail->flag=atoi(num);
	 preleva3(com,svpr);
	 strcpy(tail-> corpopred.comment,com);
	 preleva3(form,svpr);
	 strcpy(tail-> corpopred.form,form);
	 preleva3(params,svpr);
	 strcpy(tail-> corpopred.params,params);
	 preleva3(sem,svpr);
	 strcpy(tail-> corpopred.semantics,sem);
	 preleva3(sem,svpr);
	 strcpy(tail-> corpopred.transsem,sem);
	 preleva3(par,svpr);
	 tail-> corpopred.lc=par[0];
	 preleva3(var,svpr);
	 tail-> corpopred.var=atoi(var);
	 preleva3(par,svpr);
	 strcpy(tail-> corpopred.par,par);
	 tail++;
      }
      fclose(svpr);
      return(1);
   }
   else
      return(0);
}


preleva3(campo,svpr)
   char campo[];
   FILE *svpr;
{
   int i=0;

   while(c!='\n') {
      campo[i++]=c;
      c=getc(svpr);
   }
   campo[i]='\0';
   c=getc(svpr);
}



stampanomipred()
{
   pred *ptemp=head;

   printf("\nLearning predicates:\n");
   while(ptemp!=tail) {
      if((ptemp->flag==1) && (ptemp->corpopred.lc=='l'))
         printf("\n%s",ptemp->nomepred);
      ptemp++;
   }
   ptemp=head;
   printf("\n\nConstraint predicates:\n");
   while(ptemp!=tail) {
      if((ptemp->flag ==1) && (ptemp->corpopred.lc=='c'))
         printf("\n%s",ptemp->nomepred);
      ptemp++;
   }
}



stampapred( nomestruct )
   pred *nomestruct;
{
   printf("\n%s \n  : comment    : %s",nomestruct->nomepred,nomestruct->corpopred.comment);
   printf("\n  : form       : %s",nomestruct->corpopred.form);
   printf("\n  : params     : ");
   stampar(nomestruct->corpopred.params);
   printf("\n  : semantics  : ");
   if (strcmp(nomestruct->corpopred.semantics, " ") != 0) {
      int i=0;
      char sem;
      while((i<(COL-25)) && ((sem=nomestruct->corpopred.semantics[i])!='\0')) {
         printf("%c",sem);
	 i++;
      }
      if(sem!='\0')
      printf("....");
   }
   printf("\n  : lc         : %c\n",nomestruct->corpopred.lc);
}




stampar(params)
   char params[];
{
   int i=0, j=0;
   while (params[i]!='\0') {
      j=0;
      while((j<(COL-22)) && (params[i]!='\0')) {
         printf("%c",params[i++]);
	 j++;
      }
      if (j==(COL - 22)) {
         printf("\n");
	 for (j=0;j<17;j++)
	 printf(" ");
      }
   }
}





showpr()
{
   pred *ptemp=head;
   char mess;
   int i;

   clearscr();
   newfflush();
   printf("\nLearning predicates:\n");
   while(ptemp!=tail) {
      if ((ptemp->flag ==1) && (ptemp->corpopred.lc=='l')) {
         stampapred(ptemp);
	 printf("\n <cr> continue");
	 for (i=0;i<50;i++) printf("-");
	 newfflush();
	 scanf("%c",&mess);
	 if (mess=='q')
	    break; 
      }
      ptemp++; 
   }
   clearscr();
   printf("\nConstraint predicates:\n");
   ptemp=head;
   while(ptemp!=tail) {
      if ((ptemp->flag ==1) && (ptemp->corpopred.lc=='c')) {
         stampapred(ptemp);
	 printf("\n <cr> continue");
	 for (i=0;i<50;i++)
	    printf("-");
	 newfflush();
	 scanf("%c",&mess);
	 if (mess=='q')
	    break; 
      }
      ptemp++; 
   }
}



svpred()
{
   FILE *svpr;
   pred *headtemp=head;
   char nome[MAXNOME],mess;

   svpr=fopen("sysframe/savepr","w");
   while (headtemp!=tail) {
      if(headtemp->flag==1) {
	 fstampa(headtemp,svpr);
      }
      headtemp++;
   }
   fclose(svpr);
}
