#include <stdio.h>
#include "share.h"
#include "externals.h"
#include "version.h"

#define newfflush() getchar()

#define clearscr() printf("\f")

extern struct matchtable {short startbit,nbit; int function,next;} matel[];

main_menu(com_p)
   int *com_p;
{
   char command[50];
   int quit, rewr;

   quit = FALSE;
   do {
      printf("\f");
      printf("\n ******               REGAL %s                ******\n", VERSION);
      printf("-------------------------------------------------------\n");
      printf("  SDH         : "); print_list(stdout,sdhsp0,num_of_classes);
      printf("\n  set-vars    = set the global variable values\n");
      printf("  set-network = set network parameters\n");
      printf("  start       = start the system from scratch\n");
      printf("  rstart      = restart the system from the last saved status\n");
      printf("\n  help        = print the help file\n");
      printf("  q           = exit from REGAL 3.0\n");
      printf("-------------------------------------------------------\n");

      rewr = FALSE;
      do {
         printf("\ncommand: ");
	 scanf("%s",command);
	 if(!strcmp(command,"set-vars")) {
	    globalvar_menu();
	    printf("\f");
	    rewr = TRUE;
	 }
	 else if(!strcmp(command,"set-network")) {
	    net_menu();
	    printf("\f");
	    rewr = TRUE;
	 }
	 else if(!strcmp(command,"help")) {
	    print_help("MAINhelp");
	    printf("\f");
	    rewr = TRUE;
	 }
	 else if(!strcmp(command,"start")) {
	    *com_p = START;
	    quit = TRUE;
	 }
	 else if(!strcmp(command,"rstart")) {
	    *com_p = RSTART;
	    quit = TRUE;
	 }
	 else if(!strcmp(command,"q")) {
	    *com_p = EXIT;
	    quit = TRUE;
	 }
	 else printf("\nERROR : COMMAND %s DOES NOT EXIST !\n",command);
      } while (!quit && !rewr);
   } while (!quit);
}




#define write_ipar(str,par) printf("  %s = %d\n",str,par)
#define write_fpar(str,par) printf("  %s = %f\n",str,par)
#define write_spar(str,par) printf("  %s = %s\n",str,par)


write_sipar(str,par) 
   char str[];
   int par[];
{
   int i;
   
   printf("  %s = ( ",str);
   for(i=0;i<num_of_classes;i++) 
      if(par[i]) 
         printf("%d ",i+1);
   printf(")\n");
}

#define read_ipar(par) printf("\n%s = ",command); scanf("%d",&(par));\
		       printf("\f"); modif_var = TRUE
#define read_fpar(par) printf("\n%s = ",command); scanf("%f",&(par));\
		       printf("\f"); modif_var = TRUE

read_sipar(par,command) 
   int par[]; 
   char command[];
{
   int i;

   printf("\n%s = ",command); 
   for(i=0; i<MAXCLASS; i++) 
      par[i] = 0;
   getchar();
   while(getc(stdin)!=')') {
      fscanf(stdin,"%d",&i);
      if(i<=MAXCLASS) 
      par[i-1]=1;
   }
   printf("\f"); 
}

# define read_spar(par) printf("\n%s = ",command);\
			scanf("%s",par);\
			modif_var = TRUE


globalvar_menu()
{
   char command[50];
   int modif_var, quit;

   printf("\f");
   quit = FALSE;
   do {
      printf("\n Run time parameters setting\n");
      printf("----------------------------------------------\n");
      write_sipar("goalcl",goalcl);
      write_ipar("pop-size",population_size);
      write_fpar("percentage",percentage);
      write_ipar("epochs",epochs);
      write_ipar("gens-for-epoch",gens_for_epoch);
      write_ipar("quantum",quantum);
      write_fpar("generation-gap",generation_gap);
      write_ipar("open-to-foreign",open_to_foreign);
      write_fpar("foreign-mating-rate",foreign_mating_rate);
      write_fpar("crossover-rate",crossover_rate);
      write_fpar("mutation-rate",mutation_rate);
      write_fpar("complement-rate",complementation_rate);
      write_fpar("migration-rate",migration_rate);
      write_ipar("node-persistence", node_persistence);
      write_ipar("global-persistence",global_persistence);
      write_ipar("change-ratio",change_ratio);
      write_fpar("decision-limit",decision_limit);
      write_fpar("overlap-ratio",overlap_ratio);
      printf("----------------------------------------------\n");
      printf("  save = make the variables permanent\n");
      printf("\n  help = print the help file\n");
      printf("  q = go to main menu\n");
      printf("----------------------------------------------\n");

      modif_var = FALSE;
      do {
         printf("\ncommand: ");
	 scanf("%s",command);

	 if(!strcmp(command,"save")) { 
	    save_globalvars(); 
	    printf("\f");
	    modif_var = TRUE; 
	 } 
	 else if(!strcmp(command,"goalcl")) {
	    int i;
	    read_sipar(goalcl,command);
	    modif_var = TRUE;
	 }
	 else if(!strcmp(command,"pop-size")) {
	    read_ipar(population_size);
	 }
	 else if(!strcmp(command,"percentage")) {
	    read_fpar(percentage);
	 }
	 else if(!strcmp(command,"epochs")) {
	    read_ipar(epochs);
	 }
	 else if(!strcmp(command,"gens-for-epoch")) {
	    read_ipar(gens_for_epoch);
	 }
	 else if(!strcmp(command,"quantum")) {
	    read_ipar(quantum);
	 }
	 else if(!strcmp(command,"generation-gap")) {
	    read_fpar(generation_gap);
         }
	 else if(!strcmp(command,"open-to-foreign")) {
	    read_ipar(open_to_foreign);
         }
	 else if(!strcmp(command,"foreign-mating-rate")) {
	    read_fpar(foreign_mating_rate);
         }
	 else if(!strcmp(command,"crossover-rate")) {
	    read_fpar(crossover_rate);
	 }
	 else if(!strcmp(command,"mutation-rate")) {
	    read_fpar(mutation_rate);
	 }
	 else if(!strcmp(command,"complement-rate")) {
	    read_fpar(complementation_rate);
	 }
	 else if(!strcmp(command,"migration-rate")) {
	    read_fpar(migration_rate);
	 }
	 else if(!strcmp(command,"node-persistence")) {
	    read_ipar(node_persistence);
	 }
	 else if(!strcmp(command,"global-persistence")) {
	    read_ipar(global_persistence);
         }
	 else if(!strcmp(command,"change-ratio")) {
	    read_ipar(change_ratio);
         }
	 else if(!strcmp(command,"decision-limit")) {
	    read_fpar(decision_limit);
         }
	 else if(!strcmp(command,"overlap-ratio")) {
	    read_fpar(overlap_ratio);
         }
	 else if(!strcmp(command,"help")) {
	    print_help("RTVhelp");
	    modif_var=TRUE;
	    clearscr();
	 }
	 else if(!strcmp(command,"q"))
	    quit = TRUE;
	 else printf("\nERROR : COMMAND %s DOES NOT EXIST !\n",command);
      } while (!modif_var && !quit);
   } while (!quit);
} /* end menu */

int check_distribution() {
  int i, tot=0;
  for(i=0; i<nhosts; i++) tot+= hosts[i].load;
  if(tot!=nodes) {
    printf("The nodes assigned to the processors doesn't\ncorresponds to the declared one!!!!\n");
    getchar();
    }
  return(tot!=nodes?0:1);
  }

net_menu()
{
   int quit, modif_var, new_nodes, new_dim, p_of_2;
   char command[50], new_topology[30], temp[30];
 
   quit=FALSE;
   do {
      printf("\f");
      printf("\n Network setting\n");
      printf("-------------------------------------------------\n");
      printf(" Virtual Network parameters\n\n");
      write_ipar("nodes",nodes);
      write_spar("topology",topology);
      if (strcmp(topology,"grid"))
         write_spar("dimension","unuseful parameter for hypercube or total-connection");
      else
         write_ipar("dimension",dim);
      printf("\n-------------------------------------------------\n");
      printf(" PVM hosts\n\n");
      print_pvm();
      printf("\n  distribution = assign subpopulations to hosts\n");
      printf("\n-------------------------------------------------\n");
      printf("  save = make the parameters permanent\n");
      printf("\n  help = print the help file\n");
      printf("  q = go to main menu\n");
      printf("-------------------------------------------------\n");
      modif_var=FALSE;
      do {
         printf("\ncommand: ");
         scanf("%s",command);
         if (!strcmp(command,"save")) {
            if(check_distribution()){
	      save_parameters();
	      save_distribution();
              modif_var=TRUE;
	    }
         }
	 else if (!strcmp(command,"distribution")) {
            distribution();
	    printf("\f");
	    modif_var=TRUE;
         }
         else if (!strcmp(command,"nodes")) {
            read_ipar(new_nodes);
            p_of_2=(log(new_nodes)/log(2.)-floor((log(new_nodes)/log(2.)))==0.);
            if (!strcmp(topology,"hypercube") && !p_of_2) {
               printf("\nERROR : NODES MUST BE A POWER OF 2 !\n");
               modif_var=FALSE;
            }
            else if (!strcmp(topology,"grid") && new_nodes%2) {
               printf("\nERROR : NODES MUST BE AN EVEN NUMBER !\n");
               modif_var=FALSE;
            }
            else
               nodes=new_nodes;
         }
         else if (!strcmp(command,"topology")) {
            read_spar(new_topology);
            if (strcmp(new_topology,"hypercube") &&
		      strcmp(new_topology,"grid") &&
		      strcmp(new_topology,"total-connection"))  {
                  printf("\nERROR : TOPOLOGY MUST BE hypercube,grid OR total-connection!\n");
                  modif_var=FALSE;
            }
            else {
               p_of_2=(log(nodes)/log(2.)-floor((log(nodes)/log(2.)))==0.);
               if (!strcmp(new_topology,"hypercube") && !p_of_2) {
                  printf("\nERROR : TOPOLOGY CAN'T BE AN hypercube !\n");
                  modif_var=FALSE;
               } 
               else {
                  strcpy(temp,topology);
                  strcpy(topology,new_topology);
                  strcpy(new_topology,temp);
               } 
            }
         }
         else if (!strcmp(command,"dimension"))
            if (!strcmp(topology,"grid")) {
               read_ipar(new_dim);
               if (nodes%new_dim) {
                  printf("\nERROR : DIMENSION NOT VALID !\n");
                  modif_var=FALSE;
               }
               else
                  dim=new_dim;
            }
            else
               printf("\nERROR : UNUSEFUL PARAMETER FOR hypercube !\n");
         else if (!strcmp(command,"help")) {
	    print_help("NEThelp");
            modif_var=TRUE;
	    clearscr();
	    }
         else if (!strcmp(command,"q")) {
            if(check_distribution()) quit=TRUE;
	    }
         else
         printf("\nERROR : COMMAND %s DOES NOT EXIST !\n",command);
      } while (!modif_var && !quit);
   } while (!quit);
}


save_globalvars()
{
   int i;
   FILE *fp;
   fp = fopen("dataframe/globalvar.i","w");

   fprintf(fp,"( ");
   for(i=0;i<num_of_classes;i++) 
      if(goalcl[i])
	 fprintf(fp,"%d ",i+1);
   fprintf(fp,")\n");
   fprintf(fp,"%d\n",population_size);
   fprintf(fp,"%f\n",percentage);
   fprintf(fp,"%d\n",epochs);
   fprintf(fp,"%d\n",gens_for_epoch);
   fprintf(fp,"%d\n",quantum);
   fprintf(fp,"%f\n",generation_gap);
   fprintf(fp,"%d\n",open_to_foreign);
   fprintf(fp,"%f\n",foreign_mating_rate);
   fprintf(fp,"%f\n",crossover_rate);
   fprintf(fp,"%f\n",mutation_rate);
   fprintf(fp,"%f\n",complementation_rate);
   fprintf(fp,"%f\n",migration_rate);
   fprintf(fp,"%d\n",node_persistence);
   fprintf(fp,"%d\n",global_persistence);
   fprintf(fp,"%d\n",change_ratio);
   fprintf(fp,"%f\n",decision_limit);
   fprintf(fp,"%f\n",overlap_ratio);

   fclose(fp);
} /* end save_vars */



load_globalvars()
{
   FILE *fp;
   int i,j;
   fp = fopen("dataframe/globalvar.i","r");

   if (fp == NULL) {
      population_size = epochs = gens_for_epoch = 0;
      change_ratio = 0;
      quantum = node_persistence = global_persistence = open_to_foreign = 0;
      percentage = generation_gap = foreign_mating_rate = 0.0;
      crossover_rate = mutation_rate = complementation_rate = 0.0;
      migration_rate = overlap_ratio = decision_limit = 0.0;
      for (i=0; i<MAXCLASS; i++)
	 goalcl[i] = 0;
      goalcl[0] = 1;
   }
   else {
      j = 0;
      for(i=0; i<MAXCLASS; i++)
	 goalcl[i] = 0;
      while(getc(fp)!=')') {
         j = fscanf(fp,"%d", &i);
	 if(i<=MAXCLASS)
	    goalcl[i-1] = 1;
      }
      fscanf(fp,"%d",&population_size);
      fscanf(fp,"%f",&percentage);
      fscanf(fp,"%d",&epochs);
      fscanf(fp,"%d",&gens_for_epoch);
      fscanf(fp,"%d",&quantum);
      fscanf(fp,"%f",&generation_gap);
      fscanf(fp,"%d",&open_to_foreign);
      fscanf(fp,"%f",&foreign_mating_rate);
      fscanf(fp,"%f",&crossover_rate);
      fscanf(fp,"%f",&mutation_rate);
      fscanf(fp,"%f",&complementation_rate);
      fscanf(fp,"%f",&migration_rate);
      fscanf(fp,"%d",&node_persistence);
      fscanf(fp,"%d",&global_persistence);
      fscanf(fp,"%d",&change_ratio);
      fscanf(fp,"%f",&decision_limit);
      fscanf(fp,"%f",&overlap_ratio);
   }
   fclose(fp);
} /* end load_vars */


save_parameters()
{
   FILE *fp=fopen("dataframe/parameters.i","w");

   fprintf(fp,"%d\n",nodes);
   fprintf(fp,"%d\n",dim);
   fprintf(fp,"%s\n",topology);
   fclose(fp);
}


load_parameters()
{
   FILE *fp=fopen("dataframe/parameters.i","r");

   if (fp==NULL) {
      nodes=dim=0;
      strcpy(topology,"hypercube");
   }
   else {
      fscanf(fp,"%d",&nodes);
      fscanf(fp,"%d",&dim);
      fscanf(fp,"%s",topology);
   }
   fclose(fp);
}


save_distribution()
{
   FILE *fp=fopen("dataframe/pvm_hosts","w");
   int i;

   for (i=0;i<nhosts;i++)
      fprintf(fp,"%s %d\n",hosts[i].name,hosts[i].load);
   fclose(fp);
}


load_distribution()
{
   FILE *fp, *fp1;
   char hostname[20], conf_file[15], pvm_deamon[15],
	pvmpath[20];
   int load, i;

   nhosts=0;
   if((fp = fopen("dataframe/pvm_hosts", "r"))!=NULL) {
      while(fscanf(fp,"%s %d",hosts[nhosts].name,&hosts[nhosts].load)!=EOF
		  && nhosts <MAXHOSTS) nhosts++;
      fclose(fp);
      }
   else {
      fp1=fopen("sysframe/constpvm","r");
      fscanf(fp1,"%s",conf_file);
      fscanf(fp1,"%s",pvm_deamon);
      fclose(fp1);
      pvmpath[0]='\0';
      sprintf(pvmpath,"sysframe/%s",conf_file);
      fp1=fopen(pvmpath,"r");
      while(fscanf(fp1,"%s",hosts[nhosts].name)!=EOF&&nhosts<MAXHOSTS) {
	 hosts[nhosts].load=0;
         nhosts++;
	 while(getc(fp1)!='\n');
      }
      fclose(fp1);
   }
}



save_nodes()
{
   FILE *fp;

   fp = fopen("sysframe/old_nodes.i","w");
   fprintf(fp,"%d\n",nodes);
   fclose(fp);
}


load_old_nodes()
{
   FILE *fp;
   int n;

   fp = fopen("sysframe/old_nodes.i","r");
   fscanf(fp,"%d",&n);
   fclose(fp);
   return(n);
}


print_pvm()
{
   int i;

   for(i=0;i<nhosts;i++)
      printf("  %s : %d\n",hosts[i].name,hosts[i].load);
}


distribution()
{
   char hostname[20];
   int load, i=0;

   printf("\nhostname :: ");scanf("%s",hostname);
   printf("load     :: ");scanf("%d",&load);
   while(strcmp(hosts[i].name,hostname) && i<nhosts) i++;
   if (i==nhosts) {
      printf("\nERROR : UNKNOW HOST !");
      fflush(stdout);
      sleep(3);
   }
   else
      hosts[i].load=load;
}

print_help(h)
   char h[];
{
   char cmd[128];

   sprintf(cmd, "more -c %s/%s", HELP, h);
   system(cmd);
   printf("\n------------------------------------------------------------------------------\n");
   newfflush();
   printf("\nType a key to continue");
   getchar();
}
