#include "share.h"
#include "externals.h"
#include "archdep.h"

static int mcov[MAXCLASS];

static char cover[MAXSAMP];

static int ntot, ncover;

static int firsttime = 0;

static struct binder {
   Solution *cur;
   int next;
};

static struct ss {
   int H[MAXCLASS];
   struct binder v[MAXPOP];
   int fr;
} sm;


clear_firstt() {
  firsttime = 0;
  }

clear_sm() {
   int i;

   for(i=0; i<num_of_classes; i++)
      sm.H[i] = -1;
   sm.fr=0;
}


ins_sm(c, s)
   int c;
   Solution *s;
{
   int tmp;
   tmp = sm.H[c];

   if(tmp < 0) {
      sm.H[c]=sm.fr;
      sm.fr++;
      sm.v[sm.H[c]].next = -1;
      sm.v[sm.H[c]].cur = s;
   }
   else {
      while(sm.v[tmp].next >=0 && sm.v[tmp].cur->efit> s->efit)
         tmp=sm.v[tmp].next;
      if(sm.v[tmp].cur->efit<=s->efit) {
         sm.v[sm.fr].cur = sm.v[tmp].cur;;
	 sm.v[sm.fr].next = sm.v[tmp].next;
	 sm.v[tmp].cur = s;
	 sm.v[tmp].next = sm.fr;
	 sm.fr++;
      }
      else {
         sm.v[tmp].next = sm.fr;
	 sm.v[sm.fr].cur = s;
	 sm.v[sm.fr].next = -1;
	 sm.fr++;
      }
   }
}

static int check_tm(b) char b[]; {
  int i;
  i = 0;
  while((b[i] != '\0')&&(b[i] != ':')) i++;
  return(b[i] == ':' ? 1 : 0);
  }

static float eval_mx_tm() {
  int k, i, j;
  char buf[128], com[128];
  float mx = 0.0, tx;
  FILE *tf;
  system("rm -f dataframe/TT");
  sprintf(com, "%s |grep nregal > dataframe/TT", PS);
  system(com);
  tf = fopen("dataframe/TT", "r");
  k=1;
  while(k!=EOF) {
    k=fscanf(tf, "%s", buf);
    if(k!=EOF && check_tm(buf)) {
      sscanf(buf, "%d:%d", &i, &j);
      tx = (float)i + (float)j/60.0;
      if(tx > mx) mx = tx;
      }  
    }  
  fclose(tf);
  return(mx);
  }


int contribution(s, mode)
   Solution *s;
   int mode;
{
   int i, count=0;

   for(i=0; i<Numcodes; i++)
      if((s->sample[i]=='1')&&(cover[i]=='0')&&(indice[i].class-1==s->class)) {
         if(mode==0) {
	    cover[i]='1';
	    ncover++;
	    mcov[indice[i].class-1]++;
	 }
	 count++;
      }
   if(count && (mode==0))
      for(i=0; i<Numcodes; i++)
         if((s->sample[i]=='1')&&(cover[i]=='0')){
	    cover[i]='1';
	    mcov[indice[i].class-1]++;
	 }
   return(count);
}


Solution *get_max_contr(cl)
   int cl;
{
   int tmp, mx=0, mxc=0, tc;
   int cons_sol, cons_mxc= 0, cons_mx = 0;
   tmp = sm.H[cl];
   mx = tmp;

   if(tmp<0)
      return(NULL);

   tc=contribution(sm.v[mx].cur, 1);
   cons_sol = consistent (sm.v[mx].cur->class,sm.v[mx].cur->sdh);
   if ((tc > mxc) && (cons_sol == 0)) {
            mxc = tc;
	    mx = tmp;
   }
   if ((tc > cons_mxc) && (cons_sol == 1)) {
            cons_mxc = tc;
	    cons_mx = tmp;
   }

   tmp = sm.v[tmp].next;
   while(tmp>=0) {

      tc = contribution(sm.v[tmp].cur,1);
      cons_sol = consistent (sm.v[tmp].cur->class,sm.v[tmp].cur->sdh);
      if ((tc > mxc) && (cons_sol == 0)) {
            mxc = tc;
	    mx = tmp;
      }
      if ((tc > cons_mxc) && (cons_sol == 1)) {
            cons_mxc = tc;
	    cons_mx = tmp;
      }
      tmp = sm.v[tmp].next;
   }

   if (cons_mxc > 0) {
      mxc = cons_mxc;
      mx = cons_mx;
   }

   tc = contribution(sm.v[mx].cur,0);
   if(mx == sm.H[cl])
      sm.H[cl] = sm.v[sm.H[cl]].next;
   else {
      tmp = sm.H[cl];
      while(sm.v[tmp].next != mx)
	 tmp = sm.v[tmp].next;
      sm.v[tmp].next = sm.v[mx].next;
   }
   if(mxc>0)
      return(sm.v[mx].cur);
   else
      return(NULL);
}
    

int consistent (cl, m)
   int cl, m[];
{
   int i, mneg=0;

   for (i=0; i<num_of_classes; i++)
      if (i != cl)
	 mneg += m[i];
   if (mneg == 0)
      return (1);
   else
      return (0);
}


or (flag)
   int flag;
{
   FILE *fp,*out, *tt, *count_ess;
   int i,j,indu,num=0, k, cl;
   Solution *pun;
   char suffix[4], file1[100], file2[100], cmd[100] ;
   static int count = 0;

   clear_sm();
   if (flag == 0) {
      sprintf(file1,"dataframe/bfitor.l");
      sprintf(file2,"dataframe/bfitor.i");
   }
   else {
    
      if (count > 1) {
         sprintf(cmd,
             "cmp -s dataframe/bfitor.all.l dataframe/bfitor.all.%d.l", 
	     (count - 1));
         if (system(cmd) == 0) count--;
      }
      sprintf(cmd,
        "mv dataframe/bfitor.all.l dataframe/bfitor.all.%.3d.l",count);
      system(cmd);
   
      sprintf(file1,"dataframe/bfitor.all.l");
      sprintf(file2,"dataframe/bfitor.all.i");
   }
   fp=fopen(file1,"w");
   out=fopen(file2,"w");
   for(i=0; i<num_of_classes; i++)
      if(goalcl[i]) {
         for(j=0;j<num_of_classes;j++)
	    mcov[j]=0;
         if (flag == 0) {
            for(j=0; j<Numcodes; j++) {
	       cover[j]=indice[j].covered;
	       if(indice[j].covered == '1')/* && indice[j].class-1==i)*/
	          mcov[indice[j].class-1]++;
            }
	    fprintf(fp,"Cover: ");
	    print_list(fp,mcov,num_of_classes);
	    fflush (fp);
	    pun=population.class[i].H;
         }
         else {
	    for(j=0; j<Numcodes; j++)
	      cover[j] = '0';
	    pun=population1.class[i].H;
         }
	 fprintf(fp,"\n\n***** CLASS %d\n\n", i);
	 while((pun!=NULL)&&(mcov[i]<sdhsp0[i])) {
	    if(consistent(pun->class,pun->sdh) && contribution(pun,0)) {
	       fprintf(fp,"\n\nCLASS %d  \n%s\n",i,pun->bitstring);
	       fprintf(fp,"f: %f  sf: %f  ",pun->fitness,pun->sharedfit);
	       fprintf(fp,"ef: %f\n\n",pun->efit);
	       print_form(pun->bitstring,fp);
	       fprintf(fp,"\n");
	       print_list(fp,pun->sdh,num_of_classes);
	       fprintf(fp, "\nCover: ");
	       print_list(fp,mcov,num_of_classes);
	       fprintf(out,"%s\n",pun->bitstring);
	       print_riga(out,pun->sample);
	       fprintf(out,"%f\n",pun->fitness);
	       fprintf(out,"%f\n",pun->sharedfit);
	       fprintf(out,"%f\n",pun->efit);
	       fprintf(out,"%d\n",pun->class);
	       print_list(out,pun->sdh,num_of_classes);
	       print_list(out,pun->sdhstar,num_of_classes);
	       print_list(out,pun->sdhunc,num_of_classes);
	       num++;
	       ins_sm(i,pun);
	    }
	    pun=pun->next_cl_sol;
	 }
         if (flag == 0) {
	    classinfo[i].ccover = mcov[i];
	    pun=population.class[i].H;
	    }
	 else             
	    pun=population1.class[i].H;
	 while((pun!=NULL)&&(mcov[i]<sdhsp0[i])) {
	    if(!consistent(pun->class,pun->sdh) && contribution(pun,0)) {
               fprintf(fp,"\n\nCLASS %d  \n%s\n",i,pun->bitstring);
               fprintf(fp,"f: %f  sf: %f  ",pun->fitness,pun->sharedfit);
               fprintf(fp,"ef: %f\n\n",pun->efit);
	       print_form(pun->bitstring,fp);
	       fprintf(fp,"\n");
	       print_list(fp,pun->sdh,num_of_classes);
	       fprintf(fp, "\nCover: ");
	       print_list(fp,mcov,num_of_classes);
	       fprintf(out,"%s\n",pun->bitstring); 
	       print_riga(out,pun->sample);
	       fprintf(out,"%f\n",pun->fitness);
	       fprintf(out,"%f\n",pun->sharedfit); 
	       fprintf(out,"%f\n",pun->efit); 
	       fprintf(out,"%d\n",pun->class); 
	       print_list(out,pun->sdh,num_of_classes); 
	       print_list(out,pun->sdhstar,num_of_classes);
	       print_list(out,pun->sdhunc,num_of_classes);
	       num++;
	       ins_sm(i,pun);
	    }
	    pun=pun->next_cl_sol;
	 }
	 classinfo[i].tcover = mcov[i];
	 classinfo[i].err = 0;
	 for(k=0; k<num_of_classes; k++)
	   if(k!=i) classinfo[i].err += mcov[k];
      }
   fclose(fp);
   fclose(out);
   /*fp=fopen(file_names.numor,"w");
   fprintf(fp,"%d\n",num);
   fclose(fp);*/
   if (flag == 0) {
      sprintf(file1,"dataframe/essential.l");
      sprintf(file2,"dataframe/essential.i");
   }
   else {
      if (firsttime == 0) {
	firsttime =1;
	count_ess = fopen("dataframe/count_ess","r");
	fscanf(count_ess, "%d", &count);
	fclose(count_ess);
      }
      sprintf(cmd,
	      "cp dataframe/essential.all.i interface/essential.all.i.old");
      system(cmd);
      sprintf(cmd,
	      "cp dataframe/essential.all.l interface/essential.all.l.old");
      system(cmd);
#ifndef CMAML
      sprintf(cmd,
	      "mv dataframe/essential.all.i dataframe/essential.all.%.3d.i",
	      count);
      system(cmd);
      sprintf(cmd,
	      "mv dataframe/essential.all.l dataframe/essential.all.%.3d.l",
	      count++);
      system(cmd);
#endif
      sprintf(file1,"dataframe/essential.all.l");
      sprintf(file2,"dataframe/essential.all.i");
      simplicity=0; ndisjuncts = 0; ccovered =0;
      smallest = 0;
      biggest =0;
      for(k=0; k<num_of_classes; k++) {
	smallest = (sdhsp0[k]> smallest ? sdhsp0[k] : smallest);
	biggest = (sdhsp0[k]< biggest ? sdhsp0[k] : biggest);
      }
      ecovered=0; tcovered=0; avgdisj = 0.0;
      count_ess = fopen("dataframe/count_ess","w");
      fprintf(count_ess, "%d\n", count);
      fclose(count_ess);
   }
   fp=fopen(file1,"w");
   out=fopen(file2,"w");
   for(i=0; i<num_of_classes; i++)
      if(sm.H[i]>=0) {
         for(j=0;j<num_of_classes;j++)
	    mcov[j]=0;
         if (flag == 0) {
	    for(j=0; j<Numcodes; j++) {
	       cover[j]=indice[j].covered;
	       if(indice[j].covered == '1')  /*&&indice[j].class-1==i)*/
	          mcov[indice[j].class-1]++;
            }
	    fprintf(fp,"Cover: "); 
	    print_list(fp,mcov,num_of_classes);   
	    fflush (fp);
            pun=population.class[i].H;
	 }
	 else {
	    for(j=0; j<Numcodes; j++)
	       cover[j] = '0';
	    pun=population1.class[i].H;
	 }
	 fprintf(fp,"\n\n***** CLASS %d\n\n", i);
	 while((pun = get_max_contr(i))!= NULL) {
	    if(flag!=0) {
	      for(k=0; k<LTEMPLATE; k++)
		if(pun->bitstring[k] == '0') simplicity++;
	      ndisjuncts++;
	      smallest = (pun->sdh[i] < smallest ? pun->sdh[i] : smallest);
	      biggest = (pun->sdh[i] > biggest ? pun->sdh[i] : biggest);
	      avgdisj += (float) pun->sdh[i];
	      tcovered = ccovered = ecovered = 0;
	      for(k=0; k<num_of_classes; k++)
		if(goalcl[k]==1) {
		  tcovered += classinfo[k].tcover;
		  ccovered += classinfo[k].ccover;
		  ecovered += classinfo[k].err;
		  }
	      }
            fprintf(fp,"\n\nCLASS %d  \n%s\n",i,pun->bitstring);
            fprintf(fp,"f: %f  sf: %f  ",pun->fitness,pun->sharedfit);
            fprintf(fp,"ef: %f\n\n",pun->efit);
	    print_form(pun->bitstring,fp);
	    fprintf(fp,"\n");
	    print_list(fp,pun->sdh,num_of_classes);
	    fprintf(fp, "\nCover: ");
	    print_list(fp,mcov,num_of_classes);
            fprintf(out,"%s\n",pun->bitstring);
	    print_riga(out,pun->sample);
	    fprintf(out,"%f\n",pun->fitness);
	    fprintf(out,"%f\n",pun->sharedfit);
	    fprintf(out,"%f\n",pun->efit);
	    fprintf(out,"%d\n",pun->class);
	    print_list(out,pun->sdh,num_of_classes);
	    print_list(out,pun->sdhstar,num_of_classes);
	    print_list(out,pun->sdhunc,num_of_classes);
	    num++;
	 }
      }
   if(flag!=0) {
     for(cl=0;cl<num_of_classes;cl++)
	 glob_mcov[cl] = mcov[cl];
     avgdisj = avgdisj / (float) ndisjuncts;
     fprintf(fp, "\nSimplicity = %d, Ndisjuncts = %d, Smallest = %d, AverageSize = %f, Biggest = %d\n",
		  simplicity, ndisjuncts, smallest, avgdisj, biggest );
     tm_ex = eval_mx_tm();
     tm_ex += used_cpu_tm;
     fprintf(fp, "\nTime = %f, Min Gen = %d\n", tm_ex, min_gener);

     }
   fclose(out);
   fclose(fp);

   system("cp dataframe/essential.all.i interface/essential.all.i");
   system("cp dataframe/essential.all.l interface/essential.all.l");

   fp=fopen("dataframe/CPU_TIME", "w");
   fprintf(fp,"%f %d\n", tm_ex, min_gener);
   fclose(fp);

}



check_cc_solution ()
{
   int i, j, num = 0, stop = TRUE; 
   Solution *pun;
 
   for (i=0; i<num_of_classes; i++)
      if (goalcl[i]) { 
         for (j=0;j<num_of_classes;j++) 
            mcov[j] = 0; 
         for (j=0; j<Numcodes; j++) { 
            cover[j] = indice[j].covered; 
            if(indice[j].covered == '1')
               mcov[indice[j].class-1]++;   
         }    
         pun = population1.class[i].H; 
         while ((pun != NULL) && (mcov[i] < sdhsp0[i])) {  
            if (consistent (pun->class,pun->sdh))
               contribution (pun,0);
            pun = pun->next_cl_sol; 
         } 
         if (mcov[i] != sdhsp0[i]) 
            stop = FALSE;
      }
   return (stop); 
}
