#include <curses.h>
#include "share.h"
#include "externals.h"

#define H1 5
#define H2 4
#define H3 3
#define H4 2
#define H5 3
#define D1 8
#define D3 10

static  WINDOW *mwin[8], *cwin[3][MAXCLASS], *nwin[MAXNODES];
static  int ncols = 0, nlines=0, ncl = 0;
static  int pflag=0, mflag=0, clflag=0;
static  int pnx=0, pny=0;
static  int winon = 0;

void vbar(w, x, y,l) WINDOW *w; int x, y, l; {
  int i;
  for(i=y; i<y+l; i++) mvwaddch(w, i, x, '|');
  }

void hbar(w, x, y, l) WINDOW *w; int x, y, l; {
  int i;
  for(i=x; i<x+l; i++) mvwaddch(w, y, i, '-');
  }

void make_grid(w, nw, nx, ny, dx, dy, x, y) WINDOW *w, *nw[MAXNODES];
					     int nx, ny, dx, dy, x, y;
{
  int i, j, n; char s[64];
  n=0;
  for(i = y+1; i<y+(ny+1)*dy; i += dy) {
    hbar(w, x, i, nx*dx+5);
    if(n<ny) {
      sprintf(s, "%d", n*nx); n++;
      mvwaddstr(w, i+dy/2, x, s);
      }
    }
  n = 0;
  for(i = x+5; i<x+(nx+1)*dx; i += dx)  {
    vbar(w, i, y, ny*dy+2); 
    if(n < nx) {
      sprintf(s, "%d", n); n++;
      mvwaddstr(w, y, i+dx/2, s);
      }
    }
  for(i=0; i<nx; i++)
    for(j=0; j<ny; j++) nw[i+(j*nx)] = subwin(w, dy-1, dx-2, y+3+j*dy, x+7+i*dx);
}

void close_windows() {
 if(winon) {
    endwin();
    winon = 0;
    }
 }

void init_windows() {
  int i, j, x, y, cw, n;
  int mx, my;
  char str[128];

  winon = 1;
  initscr();
  clear();
  refresh();
  nlines = LINES;
  ncols = COLS;
  mwin[0] = newwin(nlines-2, ncols-2, 1, 1);
  hbar(mwin[0], 1, H1-1, 7*D1);
  hbar(mwin[0], 1, H1+H2, 7*D1);
  if((ncols<7*D1+4)||(nlines<H1+H2+2)) return;
  mflag = 1;
  x = 4; y=H1+2;
  for(i=1; i<8; i++) {
    mwin[i] = subwin(mwin[0], H1-2, D1-2, y, x);
    scrollok(mwin[i], TRUE);
    x += D1;
    vbar(mwin[0], x-3, y-3, H2+2);
    }
  mvwaddch(mwin[0], 0, 0, ' ');
  box(mwin[0], '|', '-');
  wprintw(mwin[0], "- Master Report Window ");
  x = 3;
  mvwaddstr(mwin[0], H1, x, "Simpl.");
  x += D1;
  mvwaddstr(mwin[0], H1, x, "Total");
  x += D1;
  mvwaddstr(mwin[0], H1, x, "Corr.");
  x += D1;
  mvwaddstr(mwin[0], H1, x, "Error");
  x += D1;
  mvwaddstr(mwin[0], H1, x, "SDisj");
  x += D1;
  mvwaddstr(mwin[0], H1, x, " AvgD");
  x += D1;
  mvwaddstr(mwin[0], H1, x, "NDisj");
  mvwaddch(mwin[0], 2, 2, ' ');
  wprintw(mwin[0], "LSD: [");
  for(i=0; i<num_of_classes; i++)
    if(i< num_of_classes-1)
      wprintw(mwin[0], " %d,", sdhsp0[i]);
    else wprintw(mwin[0], " %d", sdhsp0[i]);
  wprintw(mwin[0], "]     Target: [");
  for(i=0; i<num_of_classes; i++) 
    if(i< num_of_classes-1)
      wprintw(mwin[0], " %d,", goalcl[i]);
    else wprintw(mwin[0], " %d", goalcl[i]);
  wprintw(mwin[0], "]");
  n=0;
  for(i=0; i<num_of_classes; i++) if(goalcl[i]) n++;
  if((n*D3+11>ncols)||(nlines <H1+H2+H3+H4+H4+H4+3)) return;
  clflag = 1;
  mvwaddstr(mwin[0], H1+H2+H3, 3, "Class: ");
  n = 0;
  x = 11;
  for(i=0; i<num_of_classes; i++)
    if(goalcl[i] == 1) {
      mvwaddch(mwin[0], H1+H2+H3, x, ' ');
      wprintw(mwin[0], "    %2d", i);
      x += D3;
      n += D3;
      }
  hbar(mwin[0], 1, H1+H2+H3+1, n+D3);
  mvwaddstr(mwin[0], H1+H2+H3+2, 3, "Correct");
  hbar(mwin[0], 1, H1+H2+H3+H4+1, n+D3);
  mvwaddstr(mwin[0], H1+H2+H3+H4+2, 3, "Total");
  hbar(mwin[0], 1, H1+H2+H3+H4+H4+1, n+D3);
  mvwaddstr(mwin[0], H1+H2+H3+H4+H4+2, 3, "Error");
  hbar(mwin[0], 1, H1+H2+H3+H4+H4+H4+1, n+D3);
  for(i=0; i<= n; i += D3) {
    vbar(mwin[0], i + 11, H1+H2+H3, H4+H4+H4+2);
    }
  x = 14; y= H1+H2+H3 + 2;
  n=0;
  for(i=0; i<num_of_classes; i++)
    if(goalcl[i] == 1) {
      cwin[0][n] = subwin(mwin[0], 1, D3-3, y+1, x);
      cwin[1][n] = subwin(mwin[0], 1, D3-3, y+1+H4, x);
      cwin[2][n] = subwin(mwin[0], 1, D3-3, y+1+H4+H4, x);
      x += D3;
      n++;
      }
  ncl = n;
  mx = (ncols-6)/D3;
  my = (nlines-H1+H2+H3+H4+H4+H4+6)/H5;
  if(mx*my<nodes) pflag=0;
    else {
      pflag=1;
      pnx=nodes;
      pny=1;
      while(pnx > mx) {
	pnx = pnx/2;
	pny++;
	}
      if(pny>my) {
	pnx = mx;
	pny = ((nodes/mx)*mx <nodes ? nodes/mx +1 : nodes/mx);
	}
      sprintf(str,"Population Number: %d", nodes);
      mvwaddstr(mwin[0], H1+H2+H3+H4+H4+H4+4, 6, str);
      make_grid(mwin[0], nwin, pnx, pny, D3, H5, 4, H1+H2+H3+H4+H4+H4+6);
      }
  wrefresh(mwin[0]);
  }


void upd_pop() {
  int i;
  if(pflag>0)
    for(i=0; i<nodes; i++) {
      wclear(nwin[i]);
      wprintw(nwin[i], "%5d\n%5d", pstat[i].gen, pstat[i].nas);
      wrefresh(nwin[i]);
      }
}

void upd_pops(n) int n; {
  if(pflag>0) {
    wclear(nwin[n]);
    wprintw(nwin[n], "%5d\n%5d", pstat[n].gen, pstat[n].nas);
    wrefresh(nwin[n]);
    }
}

void upd_clwin(n, m) int n, m; {
  if(!clflag) return;
  wclear(cwin[0][m]);
  wclear(cwin[1][m]);
  wclear(cwin[2][m]);
  wprintw(cwin[0][m], "%6d\n", classinfo[n].ccover);
  wprintw(cwin[1][m], "%6d\n", classinfo[n].tcover);
  wprintw(cwin[2][m], "%6d\n", classinfo[n].err);
  wrefresh(cwin[0][m]);
  wrefresh(cwin[1][m]);
  wrefresh(cwin[2][m]);
  }

void upd_master() {
  int i, k;
  if(!mflag) return;
  wprintw(mwin[1], "%5d\n", simplicity);
  wprintw(mwin[2], "%5d\n", tcovered);
  wprintw(mwin[3], "%5d\n", ccovered);
  wprintw(mwin[4], "%5d\n", ecovered);
  wprintw(mwin[5], "%5d\n", smallest);
  wprintw(mwin[6], "%5.1f\n", avgdisj);
  wprintw(mwin[7], "%5d\n", ndisjuncts);
  for(i=1; i<8; i++) wrefresh(mwin[i]);
  k=0;
  for(i=0; i<num_of_classes; i++)
    if(goalcl[i] == 1){
      upd_clwin(i, k);
      k++;
      }
  }

