#include "share.h"
#include "externals.h"

extern apply_seeding();
extern int prob(), partner_of(), select_cross_func();
extern int mutate(), make_seed(), complement();
extern crossover(), make_mating();
Solution *alloc_solution();

ga_loop(generation_num, mg, ndist)
   int generation_num, mg, ndist;
{
   Solution *selected_solutions[2*MAXPOP+1];
   int nsel, nsel2;
   Solution *first_parent, *second_parent;
   static Solution *children[2*MAXPOP+1];
   static firstime=0;
   int new[2*MAXPOP+1];
   int nmutated, ncompl;
   int sol_to_delete, crowding();
   int i,cross_func, cross_appl[NUMCROSS];
   float c_rate;
   int first_child_index, second_child_index;

   fprintf(errlog,"----------------------------------------------------------------\n");
   fprintf(errlog,"G: %d *** ",generation_num);
   fflush(errlog);
  
   if (firstime == 0) { 
	firstime =1;
	for (i=0 ; i<2*MAXPOP+1;i++) children[i] = NULL;
   }

   /* SELEZIONE */
   nsel = mate_select(selected_solutions, ndist);
   for (i=0 ; i<nsel; i++) {
      if (children[i] == NULL) children[i] = alloc_solution();
      solcpy(children[i], selected_solutions[i]);
      new[i] = FALSE;
      children[i]->ancestor=selected_solutions[i];
   }

   make_mating(children, nsel);
   /* CROSSOVER */
   c_rate = crossover_rate; 
   for (i=0 ; i<NUMCROSS ; i++)
      cross_appl[i] = 0;
      nsel2 = nsel/2;
   for (i=0 ; i<nsel2 ; i++)
      if (prob(c_rate)) {
         first_child_index=i*2;
	 second_child_index=i*2+1;
	 first_parent=children[first_child_index]->ancestor;
	 second_parent=children[second_child_index]->ancestor;
	 cross_func=select_cross_func(first_parent,second_parent);
	 cross_appl[cross_func]++;
	 crossover(cross_func,
		   first_parent->bitstring,
		   second_parent->bitstring,
		   children[first_child_index]->bitstring,
		   children[second_child_index]->bitstring);
         new[first_child_index] = new[second_child_index] = TRUE;
      }
   fprintf(errlog,"UC: %d  ",cross_appl[CROSS_U]);
   fprintf(errlog,"2C: %d  ",cross_appl[CROSS_2PT]);
   fprintf(errlog,"SC: %d  ",cross_appl[CROSS_S]);
   fprintf(errlog,"GC: %d  ",cross_appl[CROSS_G]);
   fflush(errlog);

   /* MUTAZIONE */
   fprintf(errlog,"Mut: ");
   fflush(errlog);
   nmutated = 0;
   for (i=0 ; i<nsel ; i++)
      if(prob((double)PSM)) {
         if(make_seed(children[i])) {
	    new[i] = TRUE;
	    nmutated++;
	 }
      }
      else if(mutate(children[i]->bitstring)) { 
         new[i] = TRUE;
	 nmutated++;
      }
   fprintf(errlog,"%d  ",nmutated);
   fflush(errlog);

   /* COMPLEMENTAZIONE */
   fprintf(errlog,"Cmp: ");
   fflush(errlog);
   ncompl = 0;
   for (i=0 ; i<nsel ; i++)
      if (complement(children[i]->bitstring)) {
         new[i] = TRUE;
	 ncompl++;
      }
   fprintf(errlog,"%d\n",ncompl);
   fflush(errlog);

   /* VALUTAZIONE */
   for (i=0 ; i<nsel ; i++) {
      int j,ind;
      if (new[i]) {
         evaluate_solution(children[i],0);
      }
      else 
	 solcpy(children[i], children[i]->ancestor);
   }
   for(i=population_size; i<pop_limit; i++) delete_solution(i, 1);
   replace(children, nsel, mg);
}


replace(solutions,nsol,mg)
   Solution *solutions[];
   int nsol, mg;
{
   int i, j, position, local, outside;
   char replaced[MAXPOP];
   static firsttime =0;


   outside = (foreign_mating_rate * (float)inb_limit);  
   if((outside%2)!=0) outside--;
   local = nsol - outside;
   for(i=0;i<MAXPOP;i++)
      replaced[i]='0';
   position=random_int(population_size);
   i=0;
   while(i<local) {
      if((prob(generation_gap)) && replaced[position]=='0') {
	 replaced[position]='1';
	 delete_solution(position, 0);
	 population.solution[position] = alloc_solution();
	 solcpy(population.solution[position], solutions[i]);
         insert_solution(population.solution[position]);
         i++;
      }
      position=(position+1)%population_size;
   }
   if(mg && (firsttime == 0)) {
     firsttime = 1;
     for(j=0; j<migr_num; j++) {
       population.outb[j] = NULL;
       }
     outb_limit = 0;
     while(i<nsol) {
       if (population.outb[outb_limit] == NULL) 
	  population.outb[outb_limit] = alloc_solution();
       solcpy(population.outb[outb_limit] , solutions[i]);
       outb_limit++;
       }
     outb_size = outb_limit;
     outside = (int)((1.0 - foreign_mating_rate) * inb_limit);
     for(i=0; i<outside; i++) {
       if (population.outb[outb_limit] == NULL) 
          population.outb[outb_limit] = alloc_solution();
	solcpy(population.outb[outb_limit] , population.inb[random_int(inb_limit)]);
	outb_limit++;
	}
     while(outb_limit < migr_num) {
       if (population.outb[outb_limit] == NULL) 
           population.outb[outb_limit] = alloc_solution();
	solcpy(population.outb[outb_limit], 
	       population.solution[random_int(population_size)]);
       outb_limit++;
       }
    }


}


solcpy(to,from)
   Solution *to, *from;
{
   int i;

   for (i=0 ; i<num_of_classes ; i++) {
      to->sdh[i] = from->sdh[i];
      to->sdhstar[i] = from->sdhstar[i];
      to->sdhunc[i] = from->sdhunc[i];
   }
   strcpy(to->bitstring,from->bitstring);
   strcpy(to->sample,from->sample);
   to->class = from->class;
   to->fitness = from->fitness;
   to->sharedfit = from->sharedfit;
   to->efit = from->efit;
}
