#include "share.h"
#include "externals.h"

extern struct matchtable {
   short startbit,nbit;
   int function,next;
} matel[];

extern evaluate_solution();
extern make_random_bitstring();


pp_distance(s1,s2)
   Solution *s1, *s2;
{
   int i, class=0, k=0;

   class = s1->class;
   for (i=0; i<Numcodes; i++)
      if((s1->sample[i]=='0')&&(s2->sample[i]=='1')&&
	 (indice[i].class-1 == class)) k++;
         return(k);
}


p_distance(s1,s2)
   Solution *s1, *s2;
{
   int i, k=0;

   for (i=0; i<Numcodes; i++)
      if(s1->sample[i]!=s2->sample[i])
	 k++;
   return(k);
}


p_intersection(s1,s2)
   Solution *s1, *s2;
{
   int i, k=0;

   for (i=0; i<Numcodes; i++)
      if((s1->sample[i]=='1')&&(s2->sample[i]=='1'))
	 k++;
   return(k);
}


p_forseen(s1,s2,m1,m2)
   Solution *s1, *s2;
   int m1[], m2[];
{
   int i;
   char sample1[MAXSAMP+1], sample2[MAXSAMP+1];

   strcpy(sample1,s1->sample);
   strcpy(sample2,s2->sample);
   for(i=0; i<num_of_classes; i++) {
      m1[i]=0;
      m2[i]=0;
   }
   for(i=0; i<Numcodes; i++)
      if((sample1[i]=='1')||(sample2[i]=='1')) {
         m1[(sample1[i]=='1' ?
			     indice[sample1[i]].class-1 :
			     indice[sample2[i]].class-1)]++;
         if((sample1[i]=='1')&&(sample2[i]=='1'))
	    m1[indice[sample1[i]].class-1]++;
      }  
}


crossover(func,parent1,parent2,offsp1,offsp2)
   int func;
   char parent1[],parent2[],offsp1[],offsp2[];
{
   switch (func) {
      case CROSS_U : crossover_u(parent1,parent2,offsp1,offsp2);
                     break;
      case CROSS_2PT : crossover_2pt(parent1,parent2,offsp1,offsp2);
	               break;
      case CROSS_S : crossover_s(parent1,parent2,offsp1,offsp2);
		     break;
      case CROSS_G : crossover_g(parent1,parent2,offsp1,offsp2);
     		     break;
   }
}


/*
int partner_of(child_index,selected_solutions,nsel)
   int child_index, selected_solutions[], nsel;
{
   int index = -1, i = 1, j, z, found = FALSE;
   Solution *p1, *p2;
   p1 = population.solution[selected_solutions[child_index]];

   while (!found && i++ <= crowding_factor+1) {
      index = random_int(nsel);
      p2 = population.solution[selected_solutions[index]];
      if (p1->class == p2->class) found = TRUE;
   }
   return(index);
}
*/


int select_cross_func(s1,s2)
   Solution *s1, *s2;
{
   double fm, r, prob_op[NUMCROSS], p, rrandom();
   int nop, sdhs1, sdhs2, sdhssp0, sdhs();

   sdhs1 = sdhs(s1->sdh);
   sdhs2 = sdhs(s2->sdh);
   sdhssp0 = sdhs(sdhsp0);
   r = (double)(sdhs1 + sdhs2) / (2* sdhssp0);
   fm = (s1->fitness + s2->fitness)/2;
   prob_op[CROSS_U]   = (1 - 0.7*fm)*0.4;
   prob_op[CROSS_2PT] = (1 - 0.7*fm)*0.6;
   prob_op[CROSS_S]   = fm * 0.7 * r;
   prob_op[CROSS_G]   = fm * 0.7 * (1 - r);
   p = rrandom();
   nop = 0;
   while (p >= prob_op[nop])
      p -= prob_op[nop++];
   return(nop);
}


int sdhs(sdh)
   int sdh[];
{
   int i,sum = 0;
 
   for (i=0 ; i<num_of_classes ; i++)
      sum += sdh[i];
   return(sum);
}


crossover_2pt(parent1,parent2,offsp1,offsp2)
  char parent1[], parent2[], offsp1[], offsp2[];
{
   int i, first_cross_point, second_cross_point;

   first_cross_point = random_int(LTEMPLATE);
   second_cross_point = random_int(LTEMPLATE);
   if (first_cross_point > second_cross_point) {
      int temp;
      temp = first_cross_point;
      first_cross_point = second_cross_point;
      second_cross_point = temp;
   }
   for (i=0 ; i < first_cross_point ; i++) {
      offsp1[i] = parent1[i];
      offsp2[i] = parent2[i];
   }
   for (i = first_cross_point ; i <= second_cross_point ; i++) {
      offsp1[i] = parent2[i];
      offsp2[i] = parent1[i];
   }
   for (i = second_cross_point + 1 ; i < LTEMPLATE ; i++) {
      offsp1[i] = parent1[i];
      offsp2[i] = parent2[i];
   }
   offsp1[i] = offsp2[i] = '\0';
}


crossover_u(parent1,parent2,offsp1,offsp2)
   char parent1[], parent2[], offsp1[], offsp2[];
{
   int i, prob();

   for (i=0 ; i<LTEMPLATE ; i++)
      if (prob(0.5)) {
         offsp1[i] = parent1[i];
	 offsp2[i] = parent2[i];
      }
      else {
         offsp1[i] = parent2[i];
	 offsp2[i] = parent1[i];
      }
   offsp1[i] = offsp2[i] = '\0';
}


crossover_s(parent1,parent2,offsp1,offsp2)
   char parent1[], parent2[], offsp1[], offsp2[];
{
   char and_bit();
   crossover_sg(parent1,parent2,offsp1,offsp2,and_bit); 
}


crossover_g(parent1,parent2,offsp1,offsp2)
   char parent1[], parent2[], offsp1[], offsp2[];
{
   char or_bit();
   crossover_sg(parent1,parent2,offsp1,offsp2,or_bit);
}


crossover_sg(parent1,parent2,offsp1,offsp2,fbit)
   char parent1[], parent2[], offsp1[], offsp2[],(*fbit)();
{
#define FPROB 0.4
   int subs,i,prob();
   int start,end;

   for (subs=0 ; subs<MAXMATCH ; subs++) {
      start=matel[subs].startbit;
      end=start+matel[subs].nbit;
      if (prob(FPROB))
         for (i=start; i<end ; i++) { 
	    if(parent1[i]!=' ') {
	       offsp1[i] =  (*fbit)(parent1[i],parent2[i]); 
	       offsp2[i] = offsp1[i];
	    }
	 }
	 else
	    for (i=start; i<end ; i++) {
	       offsp1[i] = parent1[i];
	       offsp2[i] = parent2[i];
	    }
   }
   offsp1[i] = offsp2[i] = '\0';
}


char and_bit(bit1,bit2)
   char bit1,bit2;
{
   return((bit1 == '1' && bit2 == '1') ? '1' : '0');
}


char or_bit(bit1,bit2)
   char bit1,bit2;
{
   return((bit1 == '0' && bit2 == '0') ? '0' : '1');
}


int make_seed(s)
   Solution *s;
{
   int i, prob(), mutated = 0;

   for (i=0 ; i<LTEMPLATE ; i++)
      if(prob(mutation_rate))
	 mutated++;
   if(mutated) {
      make_random_bitstring(s->bitstring);
      evaluate_solution(s,2);
    }
    return(mutated);
}


int mutate(bitstring)
   char bitstring[];
{
   int i, prob(), mutated = 0;

   for (i=0 ; i<LTEMPLATE ; i++)
      if (prob(mutation_rate)) {
         if(bitstring[i]!=' ') {
	    bitstring[i] = (bitstring[i] == '0') ? '1' : '0';
	    mutated++;
	 }
      }
   if(strlen(bitstring)!=LTEMPLATE) {
      fprintf(errlog,"\nERROR IN MUTATE\n\n");
      fflush(errlog);
      exit(0);
   }
   return(mutated);
}


complement(bitstring)
   char bitstring[];
{
   int i,prob();

   if (prob(complementation_rate)) {
      for (i=0 ; i<LTEMPLATE ; i++)
         if(bitstring[i]!=' ')
	    bitstring[i] = (bitstring[i] == '0') ? '1' : '0';
      if(strlen(bitstring)!=LTEMPLATE) {
         fprintf(errlog,"\nERROR IN COMPLEMENT\n\n");
	 fflush(errlog);
	 exit(0);
      }
      return(1);
   }
   else
      return(0);
}

make_mating(solutions, n) Solution *solutions[]; int n; {
  Solution *cl[MAXCLASS], *tmp;
  int i, j, k, tj, ncl[MAXCLASS], scl[MAXCLASS];
  for(i=0; i<MAXCLASS; i++)  {
    cl[i] = NULL;
    scl[i] = 0;
    ncl[i] = 0;
    }
  for(i=0; i<n; i++)  {
    solutions[i]->next_cl_sol = cl[solutions[i]->class];
    cl[solutions[i]->class] = solutions[i];
    ncl[solutions[i]->class]++;
    }
  j = 0;
  for(i=0; i<MAXCLASS; i++) {
    scl[i] = j;
    while(cl[i] != NULL) {
      solutions[j] = cl[i];
      cl[i] = cl[i]->next_cl_sol;
      j++;
      }
    }
  if(j!=n) fprintf(errlog, "wrong count in make_mating\n");
  for(i=0; i<MAXCLASS; i++) {
    k = scl[i]+ncl[i];
    for(j=scl[i]; j<k; j++) {
      tj = random_int(ncl[i])+scl[i];
      tmp = solutions[tj];
      solutions[tj] = solutions[j];
      solutions[j] = tmp;
      }
    }
  }
