#include "share.h"
#include "externals.h"
#include "pvm3.h"

extern int tids[];

static int dir;		/*  DIREZIONE DI SPEDIZIONE  */
int near[MAXNODES],	/*  CONTIENE GLI sid DEI VICINI  */
    n_near;		/*  NUMERO VICINI  */


/* CONVERSIONE DECIMALE - BINARIO   */
encode(num,byte)
   int num,*byte;
{
   int i=0;

   while (num != 0) {
      byte[i] = num % 2;
      i++;
      num  = num / 2;
   }
   for (;i<8;i++)
      byte[i] = 0;
}


/* CONVERSIONE BINARIO - DECIMALE   */
decode1(byte)
   int *byte;
{
   int num = 0,i;

   for (i=0;i<8;i++)
      num += byte[i] * pow(2.,(double)i);
   return(num);
}
 
 
/* INDIVIDUA VICINI TOPOLOGIA IPERCUBO */
vicinato1()
{
   int i,byte[8];
 
   encode(sid,byte);
   for (i=0;i<n_near;i++) {
      byte[i]=!byte[i];
      near[i]=decode1(byte);
      byte[i]=!byte[i];
   }
   for (;i<MAXNODES;i++)
      near[i]= -1;
}
 
 
/* INDIVIDUA VICINI TOPOLOGIA GRIGLIA  */
vicinato2()
{
   int i;
 
   near[0]=((sid-1+dim)%dim)+((sid/dim)*dim);
   near[1]=(sid-dim+nodes)%nodes;
   near[2]=(sid+1)%dim+((sid/dim)*dim);
   near[3]=(sid+dim)%nodes;
   for (i=4;i<MAXNODES;i++)
      near[i]= -1;
}

/* INDIVIDUA VICINI TOPOLOGIA COMPLETAMENTE CONNESSA  */
vicinato3()
{
   int i, j=0;

   for (i=0;i<nodes;i++) {
      if (i!=sid)
         near[j++]=i;
   }
   for (i=j;i<MAXNODES;i++)
      near[i]= -1;
}
 
/* INIZIALIZZAZIONE STRUTTURE DATI PER MIGRAZIONE  */
init_migration()
{
   double temp;

   /* INIZ. PER GRIGLIA    */
   if (!strcmp(topology,"grid")) {
      n_near = 4;
      vicinato2();
   }
   /* INIZ. PER IPERCUBO   */
   else if (!strcmp(topology,"hypercube")) {
      temp=log((float)nodes)/log(2.);
      n_near = (int) temp;
      vicinato1();
   }
   /* INIZ. PER CONNESSIONE COMPLETA  */
   else {
      n_near = nodes-1;
      vicinato3();
   }

   if (n_near > 0) dir=random_int(n_near);

}
 
/* EFFETTUA LA MIGRAZIONE  */
migration(nmigr)
   int nmigr;
{
   static int pointer = 0;
   int i, tobesent, res_send;
   static int send_num=0, rec_num=0;
 
   Solution *ind_pointer,		/*  PUNT. IND. SELEZIONATO  */
            *alloc_solution();
 
 
   /* SPEDIZIONE INDIVIDUI */
   tobesent = nmigr;
   for(i=0; ((send_num < tobesent) && (i<tobesent)); i++) {
      ind_pointer = population.outb[i];

#ifdef CMAML

      /* sulla CMAML funziona bene */
      pvm_initsend (PvmDataInPlace);

#else
      pvm_initsend (PvmDataDefault);

#endif

      pvm_pkbyte (ind_pointer->bitstring,LTEMPLATE+1,1);
      /*
      pvm_pkbyte (ind_pointer->sample,Numcodes,1);
      pvm_pkdouble (&ind_pointer->fitness,1,1);
      pvm_pkdouble (&ind_pointer->sharedfit,1,1);
      pvm_pkdouble (&ind_pointer->efit,1,1);
      pvm_pkint (ind_pointer->sdh,num_of_classes,1);
      pvm_pkint (ind_pointer->sdhstar,num_of_classes,1);
      pvm_pkint (ind_pointer->sdhunc,num_of_classes,1);
      pvm_pkint (&ind_pointer->class,1,1);
      */
      if (pvm_pstat (tids[near[dir]]) == PvmOk) {
         res_send= pvm_send (tids[near[dir]],MIG);
	 send_num++;
      }
      else {

#ifdef CMAML

      /* sulla CMAML funziona bene */
      pvm_initsend (PvmDataInPlace);

#else
      pvm_initsend (PvmDataDefault);

#endif

      }
      dir = (dir+1) % n_near;
   }
      fprintf(errlog,"Sent individuals: %d\n",send_num);
      fflush(errlog);
 

   /* RICEZIONE INDIVIDUI  */

   rec_num=0;
   while (pvm_probe (-1,MIG) > 0) {
      int bufid;
      bufid = pvm_recv (-1,MIG);
      if(population.inb[pointer] == NULL)
	 population.inb[pointer] = alloc_solution();
      pvm_upkbyte (population.inb[pointer]->bitstring,LTEMPLATE+1,1);
      population.inb[pointer]->bitstring[LTEMPLATE+1] = '\0';
      /*
      fprintf (errlog,"%s\n", population.inb[pointer]->bitstring);
      fprintf (errlog);
      */
      /*
      pvm_upkbyte (population.inb[pointer]->sample,Numcodes,1);
      population.inb[pointer]->sample[Numcodes] = '\0';
      pvm_upkdouble (&population.inb[pointer]->fitness,1,1);
      pvm_upkdouble (&population.inb[pointer]->sharedfit,1,1);
      pvm_upkdouble (&population.inb[pointer]->efit,1,1);
      pvm_upkint (population.inb[pointer]->sdh,num_of_classes,1);
      pvm_upkint (population.inb[pointer]->sdhstar,num_of_classes,1);
      pvm_upkint (population.inb[pointer]->sdhunc,num_of_classes,1);
      pvm_upkint (&population.inb[pointer]->class,1,1);
      */
      /* RIVALUTAZIONE DELL' INDIVIDUO */
      evaluate_solution(population.inb[pointer],0);
      rec_num++;
      send_num--;
      pointer++;
      if(pointer>inb_limit)
	 inb_limit=pointer;
      if(pointer>=nmigr) pointer=0;
      pvm_freebuf(bufid);
   }

   fprintf(errlog,"Received individuals: %d\n",rec_num);
   fflush(errlog);

   fprintf(errlog,"sent indiv %d rec indiv %d", send_num, rec_num);
   fflush(errlog);
}

clear_inb() {
  int i;
  for(i=0; i<MAXPOP; i++) population.inb[i] = NULL;
  }
