#include <sys/param.h>
#include "share.h"
#include "globvar.h"
#include "pvm3.h"

int htid, tids[MAXNODES];
 
char *malloc ();
 
extern init (), init_sdhsp0_and_numofcl ();
extern match_string ();

char assigned[MAXSAMP+1];

int ok_newbest=1;

double avgf, minf, mxf;
int generation_num =0;

main ()
{
   int i, j, max_cost, tocover, last_send_gen = 0;
 
   int bufid;
   
   float temp;
   
   Solution *s, *make_random_solution ();
 
   double maxf[MAXCLASS],
          min_fitness (), max_fitness (), avg_fitness ();
 
   int subpd[MAXCLASS], ndist;
 
   char hostname[15], objname[15], objpath[128];
 
   int com, objp, kk;

   FILE *tf, *tfp;

   if (pvm_mytid () < 0) {
      printf ("ERROR : ENROLL FAILED !\n");
      exit (-1);
   }

   init ();
   random_init ();

   htid = pvm_parent ();

   /*    RICEZIONE VARIABILI GLOBALI   */
   bufid= pvm_recv (htid,VAR);
   pvm_upkstr (distrpath);
   pvm_upkstr (objname);
   pvm_upkint (&objp,1,1);
   sprintf (objpath,"%s/%s",distrpath,objname);
   nobjtup = objld (objpath);
   init_sdhsp0_and_numofcl (sdhsp0,&num_of_classes); 
   pvm_upkint (&population_size,1,1);
   pvm_upkint (&epochs,1,1);
   pvm_upkint (&gens_for_epoch,1,1);
   pvm_upkint (&quantum,1,1);
   pvm_upkint (&nodes,1,1);
   pvm_upkint (&dim,1,1);
   pvm_upkfloat (&percentage,1,1);
   pvm_upkfloat (&generation_gap,1,1);
   pvm_upkfloat (&crossover_rate,1,1);
   pvm_upkfloat (&mutation_rate,1,1);
   pvm_upkfloat (&complementation_rate,1,1);
   pvm_upkfloat (&migration_rate,1,1);
   pvm_upkint (&open_to_foreign, 1, 1);
   pvm_upkfloat (&foreign_mating_rate, 1, 1);
   pvm_upkint (&global_persistence, 1, 1);
   pvm_upkint (goalcl,num_of_classes,1);
   pvm_upkstr (topology);
   pvm_upkint (tids,nodes,1);
   pvm_freebuf(bufid);


   bufid = pvm_recv (htid,VAR1);
   pvm_upkint (&node_persistence,1,1);
   pvm_upkint (&sid,1,1);
   pvm_upkstr (assigned);
   pvm_freebuf(bufid);

   init_file_names ();
 
   /*    RICEZIONE COMANDO    */
   bufid= pvm_recv (htid,COM);
   pvm_upkint (&com,1,1);
   pvm_freebuf(bufid);    
 
   if (com == START) {
      errlog = fopen (file_names.err, "w");
      fprintf (errlog,"tid : %d\n",pvm_mytid ());fflush (errlog);

      tfp= fopen (file_names.behaviour, "w");
      fclose(tfp);

      tfp= fopen (file_names.int_bf, "w");
      fclose(tfp);

      /*
      tf = fopen (file_names.cover, "w");
      fclose (tf);
      */
      generation_num = 0;
      init_assignment (assigned, assigned);
      initialize_population ();
      init_best_solutions ();
 
      /*    CALCOLO DATI POPOLAZIONE INIZIALE   */
      avgf = avg_fitness ();
      minf = min_fitness ();
      mxf = max_fitness ();
      select_maxf (maxf);
      subpop_distribution (subpd);
      ndist = distinct_solutions ();
 
      /*    SPEDIZIONE DATI POPOLAZIONE INIZIALE AL MAIN    */
      pvm_initsend (PvmDataDefault);
      pvm_pkint (&sid,1,1);
      pvm_pkdouble (&avgf,1,1);
      pvm_pkdouble (&minf,1,1);
      pvm_pkdouble (&mxf,1,1);
      pvm_pkdouble (maxf,num_of_classes,1);
      pvm_pkint (subpd,num_of_classes,1);
      pvm_pkint (&ndist,1,1);
      pvm_send (htid,REP);
   }
   if (com == RSTART) {
      errlog = fopen (file_names.err, "a");
      init_assignment (assigned, assigned);
      read_last_generation_num (&generation_num);
      fprintf (errlog, "restarting %d\n", generation_num);
      fflush (errlog);
      last_send_gen = (generation_num - node_persistence) - 1;
      if (objp > 0) {
         load_solutions (1,0);
         init_best_solutions ();
         reportf (generation_num, assigned);
      }
      else {
         load_solutions (0,0);
         load_best_solutions ();
      }
   }

   /*    CALCOLO ALTRE VARIABILI GLOBALI  */
   temp = population_size * generation_gap;
   num_select = (int) temp;
   if ((num_select%2)!=0)
      num_select = num_select-1;
   temp = population_size * migration_rate;
   migr_num = (int) temp;

   tocover = TRUE;

   inb_limit = outb_limit = outb_size = 0;
   clear_inb ();
 
   ndist = distinct_solutions ();

   /* CICLO GENETICO */
   max_cost = epochs * gens_for_epoch;
   init_migration ();
   while (!end_ga_loop (generation_num, max_cost) && !suspend_ga_loop ()) {

#ifdef CMAML         

      /* on CMAML this avoid file system overflow  */ 
      fclose(errlog);
      errlog = fopen (file_names.err, "w");
					   
#endif

      generation_num++;
      listen_policy (generation_num);
      if (generation_num % gens_for_epoch == 0 && nodes > 1) {
	 ga_loop (generation_num, 1, ndist);
         migration (migr_num);
      }
      else
	 ga_loop (generation_num, 0, ndist);
      avgf = avg_fitness ();
      ndist = distinct_solutions ();
      minf = min_fitness ();
      mxf = max_fitness ();
      select_maxf (maxf);
      subpop_distribution (subpd);

      /*    SPEDIZIONE DATI POPOLAZIONE AL MAIN    */
      if (generation_num % quantum == 0) {
         bufid = pvm_initsend (PvmDataDefault);
         pvm_pkint (&sid,1,1);
         pvm_pkint (&generation_num,1,1);
         pvm_pkdouble (&avgf,1,1);
         pvm_pkdouble (&minf,1,1);
         pvm_pkdouble (&mxf,1,1);
         pvm_pkdouble (maxf,num_of_classes,1);
         pvm_pkint (subpd,num_of_classes,1);
         pvm_pkint (&ndist,1,1);
         pvm_send (htid,REP1);
	 pvm_freebuf(bufid);
      }

      reportf (generation_num, assigned);
      if 
	  /* (ok_newbest == 1) && */
	  (check_best (generation_num, last_send_gen, node_persistence) > 0) {
	  send_best_solutions (generation_num);
	  /* ok_newbest = 0; */
	  last_send_gen=generation_num;
      }

      fprintf(errlog,"last_send_gen %d \n", last_send_gen);
      fflush(errlog);


      if (generation_num % quantum == 0) {
         save_status (generation_num);
	 /*
         or (generation_num);
	 */
      }
   }
   save_status (generation_num);
   /*
   syncronization ();
   send_cpu_time ();
   */
   fflush (errlog);
   fclose (errlog);
   for(;;);
}


end_ga_loop (gen, maxgen)
   int gen, maxgen;
{
   int end;

   end = FALSE;

   /*
   if (++gen <= maxgen) end = FALSE;
   */

   if (pvm_nrecv (htid, STOP) > 0) {
      fprintf (errlog,"STOP!! (nmain) \n"); fflush (errlog);
      end = TRUE;
   }

   if (end) {
      /*    SPEDIZIONE SEGNALE DI END  */
      fprintf (errlog,"END!!\n"); fflush (errlog);
      pvm_initsend (PvmDataDefault);
      pvm_send (htid,END);
      end = TRUE;
   }
   return (end);
}
 

suspend_ga_loop ()
{
   int bufid, msg_type, end = FALSE;
   int stop_or_res = 0;

   if (pvm_nrecv (htid, SUS) > 0)  {
      fprintf (errlog, "Suspended\n");
      fflush (errlog); 
      save_status (generation_num);
      while (stop_or_res == 0) {
          bufid = pvm_recv (htid, -1);
          pvm_bufinfo (bufid, NULL, &msg_type, NULL);
          if (msg_type == STOP) {
              end = TRUE;
              stop_or_res = 1;
	      fprintf (errlog,"STOP!! (from nmain; in suspend) \n"); fflush (errlog);
          }
          if (msg_type == RES)
              stop_or_res = 1;
      }  
   }   
   return (end);
}


save_status (gen)
   int gen;
{
   save_solutions ();
   save_best_solutions ();
   save_last_generation_num (gen - 1);
   report_best_form ();
   node_curr_report (gen);
}


Solution *alloc_solution ()
{
   Solution *p;
 
   p = (Solution *) malloc (sizeof (Solution));
   if (p == NULL) {
      fprintf (errlog,"malloc returns NULL in alloc_solution\n");
      fflush (errlog);
      exit (0);
   }
   else
      return (p);
}
 
 
 
init_file_names ()
{
   char suffix[5];

   /*
   int digit1=0, digit2=0, digit3=0;

   digit1 = (int) (sid/100);
   suffix[0] = (char) ((int) ('0' + digit1));
   digit2 = (int) ((sid - (100 * digit1)) / 10); 
   suffix[1] = (char) ((int) ('0' + digit2));
   digit3 = (int) ((sid - (100 * digit1)) % 10); 
   suffix[2] = (char) ((int) ('0' + digit3));
   suffix[3] = '\0';
   */

   sprintf (suffix, "%.3d", sid);
 
   sprintf (file_names.sol,"%s/dataframe/solutions_%s.i",distrpath,suffix);
   sprintf (file_names.behaviour,"%s/interface/behaviour_%s.i",distrpath,suffix);
   sprintf (file_names.params,"%s/interface/params_%s.i",distrpath,suffix);
   /*
   sprintf (file_names.solor,"%s/dataframe/solor_%s.i",distrpath,suffix);
   sprintf (file_names.numor,"%s/dataframe/numor_%s.i",distrpath,suffix);
   sprintf (file_names.cover,"%s/dataframe/cover_%s.i",distrpath,suffix);
   */
   sprintf (file_names.best_sol,"%s/dataframe/best_sol_%s.i",distrpath,suffix);
   sprintf (file_names.best_form,"%s/dataframe/best_sol_%s.l",distrpath,suffix);

   sprintf (file_names.int_bf,"%s/interface/best_sol_%s.l",distrpath,suffix);

   sprintf (file_names.last_gen,"%s/dataframe/last_generation_%s",distrpath,suffix);
   /*
   sprintf (file_names.samp,"%s/dataframe/sampointers_%s.i",distrpath,suffix);
   */
   sprintf (file_names.err,"%s/ERRLOG_%s",distrpath,suffix);
   sprintf (file_names.objcount,"%s/dataframe/objcount_%s.i",distrpath,suffix);
   /*
   sprintf (file_names.bfitor1,"%s/dataframe/bfitor_%s.l",distrpath,suffix);
   sprintf (file_names.bfitor2,"%s/dataframe/bfitor_%s.i",distrpath,suffix);
   sprintf (file_names.essential1,"%s/dataframe/essential_%s.l",distrpath,suffix);
   sprintf (file_names.essential2,"%s/dataframe/essential_%s.i",distrpath,suffix);
   */
}



init_assignment (assigned,covered)
   char assigned[],covered[];
{
   int i, empty_ass;

   empty_ass=1;

   fprintf (errlog,"START INIT ASSIGN.\n"); fflush (errlog);
   for (i=0;i<Numcodes;i++)
      if (assigned[i] == '1') {
	 empty_ass = 0;
         indice[i].assigned = '1';
      }
      else
         indice[i].assigned = '0';

   if (empty_ass == 1) {
       for (i=0;i<Numcodes;i++)
           if(covered[i] == '0' && goalcl[indice[i].class-1]) {
	      indice[i].assigned='1';
	      assigned[i]='1';
	   }
   }

   fprintf (errlog,"END INIT ASSIGN.\n"); fflush (errlog);
}



init_covered (covered)
   char covered[];
{
   int i;

   fprintf (errlog,"START INIT COVER.\n"); fflush (errlog);
   for (i=0;i<Numcodes;i++)
      if (covered[i] == '1')
         indice[i].covered = '1';
      else
         indice[i].covered = '0';
   fprintf (errlog,"END INIT COVER.\n"); fflush (errlog);
}


insert_best_bitstring (best_bitstring, cl)
   char best_bitstring[];
   int cl;
{
   int position,i;
   Solution *s;

   i=0;

   while ((i < population_size) &&
	  (population.solution[i]->class != cl))
     i++;

   if (i < population_size)
      position=i;
   else
      position=0;
   delete_solution (position,0);
   s = alloc_solution ();
   population.solution[position] = s; 
   strcpy (s->bitstring,best_bitstring);
   evaluate_solution (s,0); 
   insert_solution (s);
}



syncronization ()
{
   pvm_recv (htid, SYN);
}



send_cpu_time ()
{
   float time, get_cpu_time ();

   time = get_cpu_time ();
   fprintf(errlog,"Time = %f\n",time);fflush(errlog);
   pvm_initsend (PvmDataDefault);
   pvm_pkint (&sid, 1, 1);
   pvm_pkfloat (&time, 1, 1);
   pvm_send (htid, TIM);
}


float get_cpu_time ()
{
   float time;
   struct tms buffer;

   if (times (&buffer) >= 0) {
      time = (float) (buffer.tms_utime + buffer.tms_stime)/60.0;
      return (time);
   }
   else {
      fprintf (errlog, "ERROR IN get_cpu_time!");
      fflush (errlog);
      pvm_exit ();
      exit (0);
   }
}


listen_policy (gen)
   int gen;
{
   int rest, k;
   int bufid;
   char covered[MAXSAMP+1];
   char best_bitstring[LTEMPLATE+1];

   fprintf (errlog,"START LISTEN\n"); fflush (errlog);

   if ((bufid=pvm_nrecv (htid, POL)) > 0) {
      pvm_upkint (&rest, 1, 1);
      pvm_upkstr (assigned);
      pvm_upkstr (covered);
      init_assignment (assigned, covered);
      init_covered (covered);
      if (rest)
	 restart ();
      for (k=0;k<num_of_classes;k++) {
         pvm_upkstr (best_bitstring);
         fprintf(errlog, "%d \n%s\n", k, best_bitstring);
         fflush(errlog);
         if (strcmp (best_bitstring,"") != 0)
	    insert_best_bitstring (best_bitstring, k);
      }
      init_best_solutions ();
      pvm_freebuf(bufid);

      pvm_initsend (PvmDataDefault);
      pvm_pkint (&sid,1,1);
      pvm_send (htid,RDY);
   }

/*
   k=0;
   if (generation_num % quantum == 0) {
      pvm_initsend (PvmDataDefault);
      pvm_pkint (&k,1,1);
      pvm_send (htid,SYNNB);
 
      bufid=pvm_recv (htid, RDYSYNNB)
      pvm_upkint (&k, 1, 1);
      pvm_freebuf(bufid);
      ok_newbest = 1;
   }
*/

   /*
   if ((bufid=pvm_nrecv (htid, RDYNB)) > 0) {
       pvm_upkint (&sid, 1, 1);
       pvm_freebuf(bufid);
       ok_newbest = 1;
   }
   */


   fprintf (errlog,"END LISTEN\n"); fflush (errlog);
}
