#include <stdio.h>
#include <string.h>
#include <math.h>
#include <curses.h>
#include <sys/types.h>
#include <sys/times.h>
#include "constants.h"

#define UNARY 0
#define BINARY 1

/*	comandi di menu		*/
#define EXIT 0
#define START 1
#define RSTART 2

/*	costanti di crossover	*/
#define NUMCROSS 4
#define CROSS_U   0
#define CROSS_2PT 1
#define CROSS_S   2
#define CROSS_G   3

/*	modi di selezione per la migrazione	*/ 
#define PROP_FIT_PROB       0
#define UNIF_PROB           1
#define PROP_COMPL_FIT_PROB 2
#define PROP_SHFIT_PROB	    3

/*	tipi di messaggi	*/
#define VAR        0
#define VAR1       1
#define REP        2
#define REP1       3
#define COM        4
#define END        5
#define MIG        6
#define BST        7
#define POL        8
#define TIM        9
#define STOP      10
#define SUS       11
#define RES       12
#define SYN       13
#define RDY       14
#define RDYNB     15 


#define PLENGTH namelength /* lunghezza massima dei nomi di predicato */

#include "attr.h"

/* struttura per l'indice */
struct indty {
   int first;      /* puntatore al primo oggetto del campione in objrel */
   int class;      /* classe del campione */
   int last;       /* # d'ordine del futuro oggetto del campione */
   int n;
   double count;    /* quantita' di torta associata al campione */
   char covered;   /* accounts for covering of the sample */
   char assigned;  /* dice se l'esempio e' assegnato al nodo  */
};

/*	individuo	*/
typedef
struct sol {
   char bitstring[LTEMPLATE+1];
   char sample[MAXSAMP+1];
   double fitness;
   double sharedfit;
   double efit;
   int sdh[MAXCLASS];
   int sdhstar[MAXCLASS];
   int sdhunc[MAXCLASS];
   int class;
   struct sol *prev_cl_sol, *next_cl_sol, *ancestor;
} Solution;

/*	popolazione	*/
struct popstruct {
   Solution *solution[MAXPOP*2], *inb[MAXPOP], *outb[MAXPOP];
   struct {
      Solution *H, *T;
   } class[MAXCLASS];
   double mxf, mnf;
};



/*	Best solutions   */
struct bsolstruct {
   double fitness;
   int found_in_gen;
   Solution descr;
};



/* elemento della matrice */
struct coppia {
   int nozze;
   int fallite;
};

/*	path dei file di lavoro		*/
struct files {
   char sol[128], solor[128], numor[128], cover[128], best_sol[128],
        best_form[128], objcount[128], essential1[128], essential2[128],
        last_gen[128], samp[128], err[128], bfitor1[128],
	bfitor2[128], behaviour[128], int_bf[128], params[128];
};

/*	nome e carico di un host pvm	*/
struct hoststruct {
   char name[32];
   char arch[32];
   int load;
};

struct p_stat {int gen, nas;};

struct clinf {int tcover, ccover, err;};
