#include "share.h"
#include "externals.h"
#include "global.h"
#include "match.h"
#include "constraints.h"
#include "setchar.h"
#include "setfl.h"
#include "setfld.h"
#include "setint.h"

static int ncha;
extern float minv(), maxv(), max(), min();
extern int maxo(), mino();

#include "semanticlib.h"
#include "init.h"

void get_str(s, str, sbit, nbit) char s[], str[]; int sbit, nbit; {
  int i, j;
  j = 0;
  i = sbit;
  while(j < nbit) {
    str[j] = s[i];
    i++;
    j++;
    }
  for(j = j; j< MAXSUBBIT+1; j++) str[j] = '\0';
  }

int getfloat(set,f1,f2,x) float set[],*f1,*f2; int x; {
  static float cur1 = 0.0, cur2 = 0.0;
  if (x<0) {
    cur1 = set[1];
    cur2 = set[1]+set[2];
    *f1 = cur1;
    *f2 = cur2;
    return(1);
    }
  else if(cur2 < set[0]) {
    cur1 = cur2;
    cur2 = cur2+set[2];
    *f1 = cur1;
    *f2 = cur2;
    return(1);
    }
  else return(0);
  }

int getsymbol(s,d,x) char s[], d[]; int x; {
  static int j, k;
  if(x<0) {j = 0; k = 1;}
  /* if(s[j]!='\0') */
   k = sscanf(&s[j], "%s", d);
  j = j+strlen(d);
  if(s[j]==' ') j++;
  if(k>0) return(1);
    else {
      j = 0;
      return(0);
      }  
  }

int match_int(v, sp, str, star, ref) int v, sp, star; char str[], ref; {
  int i, j, set[MAXSETINT];
  i = 1;
  j = 0;
  while((i<=setint[sp][0])&&(j == 0))
    if(str == 0)
      if(v == setint[sp][i]) j = 1;
      else i++;
     else 
      if(star) {
       if(v == setint[sp][i]) {
	str[i-1]=ref;
	j=1;
	}
       else i++;
       }
      else
       if((str[i-1]==ref) && (v == setint[sp][i])) j = 1;
       else i++;
  return(j);
  }

int match_instar(v, sp, str,star, ref) int v, sp,star; char str[], ref; {
  int i, j, set[MAXSETINT], k=0;
  i = 1;
  j = 0;
  while((i<=setint[sp][0]) && (j == 0))
    if(str == 0)
      if(v == setint[sp][i]){j++; i++;}
      else i++;
    else
      if(star) {
       if(v == setint[sp][i]) {
	str[i-1]=ref;
	j=1;
	}
       else i++;
       }
      else 
       if((str[i-1] ==ref) && (v == setint[sp][i])) {j++; i++; k++;}
      else {
       i++;
       if(v == setint[sp][i]) k++;
       }
  if(str == 0) return(j ? 1 : 0);
  else 
   if(j) return(1);
   else if (star) {
      str[i-1]=ref;
      return(1);}
     else return((str[i-1] == ref) &&(k==0) ? 1 : 0);
  }

/* set of floats */
int match_flset(v, sp, str,star, ref) float v; int sp,star; char str[], ref; {
  int i, j;
  i = 1;
  j = 0;
  while((i<=(int)setfld[sp][0])&&(j == 0))
    if(str == 0)
      if(v == setfld[sp][i]) j = 1;
      else i++;
    else
      if(star) {
       if(v == setint[sp][i]) {
	str[i-1]=ref;
	j=1;
	}
       else i++;
       }
      else if((str[i-1] ==ref) && (v == setfld[sp][i])) j = 1;
             else i++;
  return(j);
  }

/* set of floats + star */
int match_flsestar(v, sp, str, star, ref) float v; int sp, star; char str[], ref; {
  int i=1, j=0, k=0;
  while((i<=(int)setfld[sp][0]) && (j == 0))
    if(str == 0) 
      if(v == setfld[sp][i]){j++; i++;}
        else i++;
    else
      if(star) {
       if(v == setint[sp][i]) {
	str[i-1]=ref;
	j=1;
	}
       else i++;
       }
      else if((str[i-1] ==ref) && (v == setfld[sp][i])){j++; i++; k++;}
             else {
	       i++;
	       if(v == setfld[sp][i])k++;
	       }
  if(str == 0) return(j ? 1 : 0);
    else 
     if(j) return(1);
     else if (star) {
      str[i-1]=ref;
      return(1);}
      else return((str[i-1] == ref)&&(k==0) ? 1 : 0);
  }

int match_char(v, sp, str, star, ref) char *v, str[], ref; int sp, star; {
  char s1[MAXNOME+2];
  int i = -1, j = 0;
  while((getsymbol(setchar[sp], s1, i++)) && (j == 0)) 
  if(str == 0){
    if(strcmp(s1, v) == 0) j = 1;
    }
  else
   if(star) {
    if(strcmp(s1, v) == 0) {
     str[i]=ref;
	j=1;
	}
       }
   else if((str[i] ==ref) && (strcmp(s1, v) == 0)) j = 1;
  return(j);
  }

int match_chstar(v, sp, str, star, ref) char *v, str[], ref; int sp, star; {
  char s1[MAXNOME+2];
  int i = -1, j = 0, k=0;
  while((getsymbol(setchar[sp], s1, i++)) && (j == 0))
    if(str == 0){
      if(strcmp(s1, v) == 0) j++;
      }
  else
   if(star) {
    if(strcmp(s1, v) == 0) {
     str[i]=ref;
	j=1;
	}
       }
    else if((str[i] ==ref) && (strcmp(s1, v) == 0)) {j++; k++;}
    else if(strcmp(s1, v) == 0) k++;
  if(str == 0) return(j ? 1 : 0);
    else 
     if(j) return(1);
     else if (star) {
      str[i]=ref;
      return(1);}
      else return((str[i] == ref)&&(k==0) ? 1 : 0);
  }

int match_flsetc(v,sp,str,star, ref) float v; int sp,star; char str[], ref; {
  int i=-1, j=0;
  float v1=0.0, v2=0.0;
  while((getfloat(setfl[sp],&v1,&v2,i++)) && (j == 0))
    if(str == 0) {
      if((v1<=v)&&(v<v2)) j=1;
      }  
    else
      if(star) {
       if((v1<=v)&&(v<v2)) {
	str[i]=ref;
	j=1;
	}
       }
    else if((str[i] ==ref)&&(v1<=v)&&(v<v2)) j=1;
  return(j);
  }

int match_flsecstar(v,sp,str,star, ref) float v; int sp,star; char str[], ref; {
  int i=-1, j=0, k=0;
  float v1=0.0, v2=0.0;
  while((getfloat(setfl[sp],&v1,&v2,i++)) && (j == 0))
    if(str == 0){
      if((v1<=v)&&(v<v2)) j++;
      }
    else
      if(star) {
       if((v1<=v)&&(v<v2)) {
	str[i]=ref;
	j=1;
	}
       }
    else if((str[i] ==ref)&&(v1<=v)&&(v<v2)) {j++; k++;}
    else if((v1<=v)&&(v<v2)) k++;
  if(str == 0) return(j ? 1 : 0);
    else 
     if(j) return(1);
     else if (star) {
      str[i]=ref;
      return(1);}
      else return((str[i] == ref)&&(k==0) ? 1 : 0);
  }

int match_ucl(var, fun) int var, fun; {
  int cur, fp, res=1;
  cur = fun;
  while((cur > -1)&&(res > 0)) {
    fp = constrel[cur].function;
    switch(funtable[fp].type) {
    case '0': res = match_int(*(*funtable[fp].code_pointer.a1)(objrel[var]),
			      funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case '1': res = match_instar(*(*funtable[fp].code_pointer.a1)(objrel[var]),
				 funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case '2': res = match_char((*funtable[fp].code_pointer.a3)(objrel[var]),
			       funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case '3': res = match_chstar((*funtable[fp].code_pointer.a3)(objrel[var]),
				 funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case '4': res = match_flset(*(*funtable[fp].code_pointer.a2)(objrel[var]),
				funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case '5': res = match_flsestar(*(*funtable[fp].code_pointer.a2)(objrel[var]),
				   funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case '6': res = match_flsetc(*(*funtable[fp].code_pointer.a2)(objrel[var]),
				 funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case '7': res = match_flsecstar(*(*funtable[fp].code_pointer.a2)(objrel[var]),
				    funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    default:  res = 0;
    }
    cur = constrel[cur].next;
  }
  return(res);
}

int match_bcl(v1, v2, fun) int v1, v2, fun; {
  int cur, fp, res=1;
  cur = fun;
  while((cur > -1)&&(res > 0)) {
    fp = constrel[cur].function;
    switch(funtable[fp].type) {
    case '8': res = match_int(*(*funtable[fp].code_pointer.a1)(objrel[v1],objrel[v2]),
			      funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case '9': res = match_instar(*(*funtable[fp].code_pointer.a1)(objrel[v1],objrel[v2]),
				 funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case 'a': res = match_char((*funtable[fp].code_pointer.a3)(objrel[v1],objrel[v2]),
			       funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case 'b': res = match_chstar((*funtable[fp].code_pointer.a3)(objrel[v1],objrel[v2]),
				 funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case 'c': res = match_flset(*(*funtable[fp].code_pointer.a2)(objrel[v1],objrel[v2]),
				funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case 'd': res = match_flsestar(*(*funtable[fp].code_pointer.a2)(objrel[v1],objrel[v2]),
				   funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case 'e': res = match_flsetc(*(*funtable[fp].code_pointer.a2)(objrel[v1],objrel[v2]),
				 funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    case 'f': res = match_flsecstar(*(*funtable[fp].code_pointer.a2)(objrel[v1],objrel[v2]),
				    funtable[fp].set_pointer, 0, 0, '1');
    		  break;
    default:  res = 0;
    }
    cur = constrel[cur].next;
  }
  return(res);
}

int match_upl(var, fun, s, star, ref) int var, fun, star; char s[], ref; {
  int cur, fp, res=1,i;
  char str[MAXSUBBIT+2];
  short sbit, nbit;
  cur = fun;
  while((cur > -1)&&(res > 0)) {
    fp = matel[cur].function;
    sbit = matel[cur].startbit;
    nbit = matel[cur].nbit;
    get_str(s, str, sbit, nbit);
    if(str[0]!=' ') {
    switch(funtable[fp].type) {
    case '0': res = match_int(*(*funtable[fp].code_pointer.a1) (objrel[var]),
			      funtable[fp].set_pointer, str, star, ref);
    		  break;
    case '1': res = match_instar(*(*funtable[fp].code_pointer.a1) (objrel[var]),
				 funtable[fp].set_pointer, str, star, ref);
    		  break;
    case '2': res = match_char((*funtable[fp].code_pointer.a3) (objrel[var]),
			       funtable[fp].set_pointer, str, star, ref);
    		  break;
    case '3': res = match_chstar((*funtable[fp].code_pointer.a3) (objrel[var]),
				 funtable[fp].set_pointer, str, star, ref);
    		  break;
    case '4': res = match_flset(*(*funtable[fp].code_pointer.a2) (objrel[var]),
				funtable[fp].set_pointer, str, star, ref);
    		  break;
    case '5': res = match_flsestar(*(*funtable[fp].code_pointer.a2)(objrel[var]),
				   funtable[fp].set_pointer, str, star, ref);
    		  break;
    case '6': res = match_flsetc(*(*funtable[fp].code_pointer.a2)(objrel[var]),
				 funtable[fp].set_pointer, str, star, ref);
    		  break;
    case '7': res = match_flsecstar(*(*funtable[fp].code_pointer.a2)(objrel[var]),
				    funtable[fp].set_pointer, str, star, ref);
    		  break;
    default:  res = 0;
    }
    }
    cur = matel[cur].next;
    for(i=0;i<nbit;i++)
     s[sbit+i]=str[i];
  }
  return(res);
}

int match_bpl(v1, v2, fun, s, star, ref) int v1, v2, fun, star; char s[], ref; {
  int cur, fp, res=1,i;
  char str[MAXSUBBIT+2];
  short sbit, nbit;
  cur = fun;
  while((cur > -1)&&(res > 0)) {
    fp = matel[cur].function;
    sbit = matel[cur].startbit;
    nbit = matel[cur].nbit;
    get_str(s, str, sbit, nbit);
    if(str[0]!=' ') {
    switch(funtable[fp].type) {
    case '8': res = match_int(*(*funtable[fp].code_pointer.a1) (objrel[v1],objrel[v2]),
			      funtable[fp].set_pointer, str, star, ref);
    		  break;
    case '9': res = match_instar(*(*funtable[fp].code_pointer.a1) (objrel[v1],objrel[v2]),
				 funtable[fp].set_pointer, str, star, ref);
    		  break;
    case 'a': res = match_char((*funtable[fp].code_pointer.a3) (objrel[v1],objrel[v2]),
			       funtable[fp].set_pointer, str, star, ref);
    		  break;
    case 'b': res = match_chstar((*funtable[fp].code_pointer.a3) (objrel[v1],objrel[v2]),
				 funtable[fp].set_pointer, str, star, ref);
    		  break;
    case 'c': res = match_flset(*(*funtable[fp].code_pointer.a2) (objrel[v1],objrel[v2]),
				funtable[fp].set_pointer, str, star, ref);
    		  break;
    case 'd': res = match_flsestar(*(*funtable[fp].code_pointer.a2) (objrel[v1],objrel[v2]),
				   funtable[fp].set_pointer, str, star, ref);
    		  break;
    case 'e': res = match_flsetc(*(*funtable[fp].code_pointer.a2) (objrel[v1],objrel[v2]),
				 funtable[fp].set_pointer, str, star, ref);
    		  break;
    case 'f': res = match_flsecstar(*(*funtable[fp].code_pointer.a2) (objrel[v1],objrel[v2]),
				    funtable[fp].set_pointer, str, star, ref);
    		  break;
    default:  res = 0;
    }
    }
    cur = matel[cur].next;
    for(i=0;i<nbit;i++)
     s[sbit+i]=str[i];
  }
  return(res);
}

int match_uc(vars, v, f, bg, end) int vars[], v, f, bg, end; {
  int i;
  ncha = f;
  i = bg;
  while((templ[i].v1 < v)&&(templ[i].v2 == -1)&&(i<end)) i++;
  while((templ[i].v2 == -1)&&(i<end)) {
    if(match_ucl(vars[templ[i].v1], templ[i].toconst)) i++;
      else return(templ[i].v1);
    }
  return(-1); /* the match is succesful */
}

int match_bc(vars, v, f, bg, end) int vars[], v, f, bg, end; {
  int i;
  ncha = f;
  i = bg;
  while(((templ[i].v1 < v)||(templ[i].v2 < 0))&&(i<end)) i++;
  while(i<end) {
    if(match_bcl(vars[templ[i].v1],vars[templ[i].v2],templ[i].toconst)) i++;
      else return((templ[i].v1 < templ[i].v2 ? templ[i].v2 : templ[i].v1));
  }
  return(-1); /* the match is succesful */
}

int match_up(vars, v, s, f, star, bg, end, ref) int vars[], v, f, star, bg, end;
						char s[], ref; {
  int i;
  ncha = f;
  i = bg;
  while((templ[i].v1 < v)&&(templ[i].v2 == -1)&&(i<end)) i++;
  while((templ[i].v2 == -1)&&(i<end)) {
    if(match_upl(vars[templ[i].v1], templ[i].tomatch, s, star, ref)) i++;
      else return(templ[i].v1);
    }
  return(-1); /* the match is succesful */
  }

int match_bp(vars, v, s, f, star, bg, end, ref) int vars[], v, f, star, bg, end;
						char s[], ref; {
  int i;
  ncha = f;
  i = bg;
  while(((templ[i].v1 < v)||(templ[i].v2 < 0))&&(i<end)) i++;
  while(i<end) {
    if(match_bpl(vars[templ[i].v1],vars[templ[i].v2],templ[i].tomatch, s, star, ref)) i++;
      else return((templ[i].v1 < templ[i].v2 ? templ[i].v2 : templ[i].v1));
  }
  return(-1); /* the match is succesful */
}

int match_neg(vars, v, s, f) int vars[], v, s, f; {
  int tvars[MAXV], i, tv, go, nmatch=0, v0=-1;
  for(i=0; i<MAXV; i++) tvars[i]=vars[i];
  tv=v+1;
  go=1;
  while(go) {
    if(match_uc(tvars,v0,f,MAXTEMPL,MAXNTEMPL+MAXTEMPL)<0&&
       match_bc(tvars,v0,f,MAXTEMPL,MAXNTEMPL+MAXTEMPL)<0&&
       match_up(tvars,v0,s,f,0,MAXTEMPL,MAXNTEMPL+MAXTEMPL,'0')<0&&
       match_bp(tvars,v0,s,f,0,MAXTEMPL,MAXNTEMPL+MAXTEMPL,'0')<0) nmatch++;
    go=next_tuple(tvars, &v0, &tv, f);
    if(go>0&&tv<=v) go=0;
    }
  for(i=v+1; i<MAXV; i++) vars[i]=indice[f].last+indice[f].first-1;
  return(nmatch);
  }

