#include "share.h"
#include "externals.h"

static int mcov[MAXCLASS];

static char cover[MAXSAMP];

static int ntot, ncover;

static struct binder {
   Solution *cur;
   int next;
};

static struct ss {
   int H[MAXCLASS];
   struct binder v[MAXPOP];
   int fr;
} sm;



init_goalcl()
{
   FILE *fp;
   int i, j;
   
   fp = fopen("dataframe/globalvar.i","r");
   if(fp == NULL) {
      for(i=0; i<MAXCLASS; i++)
         goalcl[i] = 0;
      goalcl[0] = 1;
   }
   else {
      j = 0;
      for(i=0; i<MAXCLASS; i++)
         goalcl[i] = 0;
      while(getc(fp)!=')') {
         j = fscanf(fp,"%d", &i);
	 if(i<=MAXCLASS)
	    goalcl[i-1] = 1;
      }
      fclose(fp);
   }
}



clear_sm() {
   int i;

   for(i=0; i<MAXCLASS; i++)
      sm.H[i] = -1;
   sm.fr=0;
}


ins_sm(c, s)
   int c;
   Solution *s;
{
   int tmp;
   tmp = sm.H[c];

   if(tmp < 0) {
      sm.H[c]=sm.fr;
      sm.fr++;
      sm.v[sm.H[c]].next = -1;
      sm.v[sm.H[c]].cur = s;
   }
   else {
      while(sm.v[tmp].next >=0 && sm.v[tmp].cur->efit> s->efit)
         tmp=sm.v[tmp].next;
      if(sm.v[tmp].cur->efit<=s->efit) {
         sm.v[sm.fr].cur = sm.v[tmp].cur;;
	 sm.v[sm.fr].next = sm.v[tmp].next;
	 sm.v[tmp].cur = s;
	 sm.v[tmp].next = sm.fr;
	 sm.fr++;
      }
      else {
         sm.v[tmp].next = sm.fr;
	 sm.v[sm.fr].cur = s;
	 sm.v[sm.fr].next = -1;
	 sm.fr++;
      }
   }
}


int contribution(s, mode)
   Solution *s;
   int mode;
{
   int i, count=0;

   for(i=0; i<Numcodes; i++)
      if((s->sample[i]=='1')&&(cover[i]=='0')&&(indice[i].class-1==s->class)) {
         if(mode==0) {
	    cover[i]='1';
	    ncover++;
	    mcov[indice[i].class-1]++;
	 }
	 count++;
      }
   if(count && (mode==0))
      for(i=0; i<Numcodes; i++)
         if((s->sample[i]=='1')&&(cover[i]=='0')){
	    cover[i]='1';
	    mcov[indice[i].class-1]++;
	 }
   return(count);
}


Solution *get_max_contr(cl)
   int cl;
{
   int tmp, mx, mxc, tc;
   tmp = sm.H[cl];
   mx = tmp;

   if(tmp<0)
      return(NULL);
   mxc=contribution(sm.v[mx].cur, 1);
   tmp = sm.v[tmp].next;
   while(tmp>=0) {
      if((tc = contribution(sm.v[tmp].cur,1)) > mxc) {
         mxc = tc;
	 mx = tmp;
      }
      tmp = sm.v[tmp].next;
   }
   tc = contribution(sm.v[mx].cur,0);
   if(mx == sm.H[cl])
      sm.H[cl] = sm.v[sm.H[cl]].next;
   else {
      tmp = sm.H[cl];
      while(sm.v[tmp].next != mx)
	 tmp = sm.v[tmp].next;
      sm.v[tmp].next = sm.v[mx].next;
   }
   if(mxc>0)
      return(sm.v[mx].cur);
   else
      return(NULL);
}
    

int consistent(cl, m)
   int cl, m[];
{
   int i, mneg=0;

   for(i=0; i<MAXCLASS; i++)
      if(i!=cl)
	 mneg+=m[i];
   if(mneg==0)
      return(1);
   else
      return(0);
}


merge_or(file1,file2)
   char *file1, *file2;
{
   FILE *fp,*out;
   int i,j,indu,num=0;
   Solution *pun;

   init_goalcl();
   clear_sm();
   for(i=0; i<num_of_classes; i++)
      if(goalcl[i]) {
         for(j=0;j<MAXCLASS;j++)
	    mcov[j]=0;
         for(j=0; j<Numcodes; j++) {
	    cover[j]=indice[j].covered;
	    if(indice[j].covered == '1'&&indice[j].class-1==i)
	       mcov[i]++;
         }
	 pun=population.class[i].H;
	 while((pun!=NULL)&&(mcov[i]<sdhsp0[i])) {
	    if(consistent(pun->class,pun->sdh) && contribution(pun,0)) {
	       num++;
	       ins_sm(i,pun);
	    }
	    pun=pun->next_cl_sol;
	 }
	 pun=population.class[i].H;
	 while((pun!=NULL)&&(mcov[i]<sdhsp0[i])) {
	    if(!consistent(pun->class,pun->sdh) && contribution(pun,0)) {
	       num++;
	       ins_sm(i,pun);
	    }
	    pun=pun->next_cl_sol;
	 }
      }
   fp=fopen(file1,"w");
   out=fopen(file2,"w");
   for(i=0; i<num_of_classes; i++)
      if(sm.H[i]>=0) {
         for(j=0;j<MAXCLASS;j++)
	    mcov[j]=0;
	 for(j=0; j<Numcodes; j++) {
	    cover[j]=indice[j].covered;
	    if(indice[j].covered == '1' && indice[j].class-1==i)
	       mcov[i]++;
         }
	 fprintf(fp,"\n\n***** CLASS %d\n\n", i);
	 while((pun = get_max_contr(i))!= NULL) {
            fprintf(fp,"\n\nCLASS %d  \n%s\n",i,pun->bitstring);
            fprintf(fp,"f: %f  sf: %f  ",pun->fitness,pun->sharedfit);
            fprintf(fp,"ef: %f\n\n",pun->efit);
	    print_form(pun->bitstring,fp);
	    fprintf(fp,"\n");
	    print_list(fp,pun->sdh,num_of_classes);
	    fprintf(fp, "\nCover: ");
	    print_list(fp,mcov,num_of_classes);
            fprintf(out,"%s\n",pun->bitstring);
	    print_riga(out,pun->sample);
	    fprintf(out,"%f\n",pun->fitness);
	    fprintf(out,"%f\n",pun->sharedfit);
	    fprintf(out,"%f\n",pun->efit);
	    fprintf(out,"%d\n",pun->class);
	    print_list(out,pun->sdh,num_of_classes);
	    print_list(out,pun->sdhstar,num_of_classes);
	    print_list(out,pun->sdhunc,num_of_classes);
	    num++;
	 }
      }
   fclose(out);
   fclose(fp);
}
