#include "share.h"
#include "globvar.h"
#include "version.h"
#define newfflush() getchar();

extern init();

main(argc,argv)
   int argc;
   char *argv[];
{
   int i, quit=FALSE, objp=0;
   char line[100], quantum[5], command[50], objname[15];
   FILE *fp;

   i=1;
   while(argc>i) {
      if(strcmp(argv[i],"-f")==0) {
         i++;
         objp=i;
      }
      i++;
   }
   strcpy(objname,(objp>0) ? argv[objp] : "obj");

   init();

   if((fp=fopen("dataframe/globalvar.i","r"))!=NULL) {
      for (i=0;i<6;i++)
         fgets(line,100,fp);
      strncpy(quantum,line,strlen(line)-1);
      fclose(fp);
   }

   do {
      printf("\f");
      printf("\n ****             REGAL %s UTILITIES             **** \n", VERSION);
      printf("-------------------------------------------------------\n");
      printf(" interact    = create and evaluate a bitstring\n");
      printf(" merge       = merge subpopulations solutions\n");
      printf(" evaluate    = evaluate a description on a test-set\n");
      printf(" help        = print the help file\n");
      printf("\n q           = exit\n");
      printf("-------------------------------------------------------\n");

      printf("\ncommand: ");
      command[0]='\0';
      scanf("%s",command);
      if(!strcmp(command,"interact"))
         interact(objname);
      else if(!strcmp(command,"merge"))
	 merge(objname,quantum);
      else if(!strcmp(command,"evaluate"))
         re_eval(quantum);
      else if(!strcmp(command,"help"))
	 print_help("Uhelp");
      else if(!strcmp(command,"q")) {
	 printf("\f");
	 quit = TRUE;
      }
      else {
	 printf("\nERROR : COMMAND %s DOES NOT EXIST !\n",command);
	 sleep(3);
      }
   } while(!quit);
}


Solution *alloc_solution()
{
   Solution *p;

   p = (Solution *)malloc(sizeof (Solution));
   if(p == NULL) {
      fprintf(stderr,"malloc returns NULL in alloc_solution");
      fflush(stderr);
      exit(0);
   }
   else
      return(p);
}


collect_solutions(file,description)
   char *file;
   Solution *description[];
{
   Solution *s, *alloc_solution();
   FILE *in;
   int i=0;

   if((in=fopen(file,"r"))==NULL)
      return(-1);
   else {
      s=alloc_solution();
      while(load_individual1(in,s)!=0) {
         description[i]=s;
	 i++;
	 s=alloc_solution();
      }
      free(s);
      fclose(in);
      return(i);
   }
}


add(vect1,vect2,dim)
   int vect1[], vect2[], dim;
{
   int i;
       
   for(i=0;i<dim;i++)
      vect1[i]+=vect2[i];
}


load_subpop_num()
{
   FILE *fp;
   int nodes;
       
   fp = fopen("sysframe/old_nodes.i","r");
   fscanf(fp,"%d",&nodes);
   fclose(fp);
   return(nodes);
}


load_individual1(in, s)
   FILE *in;
   Solution *s;
{
   if(fscanf(in,"%s\n",s->bitstring)==EOF)
      return(0);
   else {
      scan_riga(in,s->sample);
      fscanf(in,"%lf",&(s->fitness));
      fscanf(in,"%lf",&(s->sharedfit));
      fscanf(in,"%lf",&(s->efit));
      fscanf(in,"%d",&(s->class));
      read_list(in,s->sdh,num_of_classes);
      read_list(in,s->sdhstar,num_of_classes);
      read_list(in,s->sdhunc,num_of_classes);
      return(1);
   }
}


print_riga(out,stringa)
   FILE *out;
   char stringa[];
{
   int i=0,j=0;
   char stemp[300];

   while(stringa[i]!='\0') {
      while((j<299) && (stringa[i]!='\0'))
         stemp[j++]=stringa[i++];
      if(stringa[i]!='\0')
         stemp[j++]='$';
      stemp[j]='\0';
      fprintf(out,"%s\n",stemp);
      j=0;
   }
}



scan_riga (in,stringa)
   FILE *in;
   char stringa[];
{
   char stemp[301];
   int flag=1,len;
	     
   strcpy(stringa,"");
   while(flag) {
      fscanf(in,"%s",stemp);
      len=strlen(stemp);
      if(stemp[len-1]!='$')
         flag=0;
      else
         stemp[len-1]='\0';
      strcat(stringa,stemp);
   }
}


find_min_gen_num(n)
   int n;
{
   int i, gen_num, min_gen_num=100000;
   char suffix[3], gen_file[30];
   FILE *fp;

   for(i=0;i<n;i++) {
      suffix[0] = (char)((int)('0' + i/10));
      suffix[1] = (char)((int)('0' + i%10));
      suffix[2] = '\0';
      sprintf(gen_file,"dataframe/last_generation_%s",suffix);
      if((fp = fopen(gen_file,"r"))!=NULL) {
         fscanf(fp,"%d",&gen_num);
	 fclose(fp);
	 if(min_gen_num>gen_num)
	    min_gen_num = gen_num;
      }  
   }
   return(min_gen_num);
}


print_help(h)
   char h[];
{
   char cmd[128];

   sprintf(cmd, "more -c %s/%s", HELP, h);
   system(cmd);
   printf("\n------------------------------------------------------------------------------\n");
   newfflush();
   printf("\nType a key to continue");
   getchar();
}
